# CSTParser

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://www.julia-vscode.org/CSTParser.jl/dev)
[![Project Status: Active - The project has reached a stable, usable state and is being actively developed.](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active)
[![Run CI on master](https://github.com/julia-vscode/CSTParser.jl/actions/workflows/jlpkgbutler-ci-master-workflow.yml/badge.svg)](https://github.com/julia-vscode/CSTParser.jl/actions/workflows/jlpkgbutler-ci-master-workflow.yml)
[![codecov](https://codecov.io/gh/julia-vscode/CSTParser.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/julia-vscode/CSTParser.jl)

A parser for Julia using [Tokenize](https://github.com/JuliaLang/Tokenize.jl/) that aims to extend the built-in parser by providing additional meta information along with the resultant AST.

## Installation and Usage
```julia
using Pkg
Pkg.add("CSTParser")
```
```julia
using CSTParser
CSTParser.parse("x = y + 123")
```
**Documentation**: [![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://www.julia-vscode.org/CSTParser.jl/dev)


### Structure
`CSTParser.EXPR` are broadly equivalent to `Base.Expr` in structure. The key differences are additional fields to store, for each expression:
* trivia tokens such as punctuation or keywords that are not stored as part of the AST but are needed for the CST representation;
* the span measurements for an expression;
* the textual representation of the token (only needed for certain tokens including identifiers (symbols), operators and literals);
* the parent expression, if present; and
* any other meta information (this field is untyped and is used within CSTParser to hold errors).

All `.head` values used in `Expr` are used in `EXPR`. Unlike in AST, tokens (terminal expressions with no child expressions) are stored as `EXPR` and additional head types are used to distinguish between different types of token. These possible head values include:

```
:IDENTIFIER
:NONSTDIDENTIFIER (e.g. var"id")
:OPERATOR

# Punctuation
:COMMA
:LPAREN
:RPAREN
:LSQUARE
:RSQUARE
:LBRACE
:RBRACE
:ATSIGN
:DOT

# Keywords
:ABSTRACT
:BAREMODULE
:BEGIN
:BREAK
:CATCH
:CONST
:CONTINUE
:DO
:ELSE
:ELSEIF
:END
:EXPORT
:FINALLY
:FOR
:FUNCTION
:GLOBAL
:IF
:IMPORT
:LET
:LOCAL
:MACRO
:MODULE
:MUTABLE
:NEW
:OUTER
:PRIMITIVE
:QUOTE
:RETURN
:STRUCT
:TRY
:TYPE
:USING
:WHILE

# Literals
:INTEGER
:BININT (0b0)
:HEXINT (0x0)
:OCTINT (0o0)
:FLOAT
:STRING
:TRIPLESTRING
:CHAR
:CMD
:TRIPLECMD
:NOTHING 
:TRUE
:FALSE
```

The ordering of `.args` members matches that in `Base.Expr` and members of `.trivia` are stored in the order in which they appear in text. 

global debug = true

import Base: length, first, last, getindex, setindex!

export ParseState, parse_expression

include("lexer.jl")
include("spec.jl")
include("utils.jl")
include("recovery.jl")
include("components/internals.jl")
include("components/keywords.jl")
include("components/lists.jl")
include("components/operators.jl")
include("components/strings.jl")
include("conversion.jl")
include("display.jl")
include("interface.jl")
include("iterate.jl")

"""
    parse_expression(ps)

Parses an expression until `closer(ps) == true`. Expects to enter the
`ParseState` the token before the the beginning of the expression and ends
on the last token.

Acceptable starting tokens are:
+ A keyword
+ An opening parentheses or brace.
+ An operator.
+ An instance (e.g. identifier, number, etc.)
+ An `@`.

"""
function parse_expression(ps::ParseState, esc_on_error = false; is_toplevel = false)
    if kindof(ps.nt) === Tokens.ENDMARKER
        ret = mErrorToken(ps, UnexpectedToken)
    elseif (esc_on_error && ps.nt.kind == Tokens.ERROR)
        ret = EXPR(:errortoken, 0, 0)
    elseif kindof(ps.nt) ∈ term_c && !(kindof(ps.nt) === Tokens.END && ps.closer.square)
        if ps.closer.square && kindof(ps.nt) === Tokens.RSQUARE
            ret = mErrorToken(ps, UnexpectedToken)
        else
            ret = mErrorToken(ps, EXPR(next(ps)), UnexpectedToken)
        end
    else
        next(ps)
        if iskeyword(kindof(ps.t)) && kindof(ps.t) != Tokens.DO
            ret = parse_kw(ps; is_toplevel=is_toplevel)
        elseif kindof(ps.t) === Tokens.LPAREN
            ret = parse_paren(ps)
        elseif kindof(ps.t) === Tokens.LSQUARE
            ret = @closer ps :for_generator @default ps parse_array(ps)
        elseif kindof(ps.t) === Tokens.LBRACE
            ret = @default ps @closebrace ps parse_braces(ps)
        elseif isinstance(ps.t) || isoperator(ps.t)
            if both_symbol_and_op(ps.t)
                ret = EXPR(:IDENTIFIER, ps)
            else
                @static if VERSION < v"1.6"
                    # https://github.com/JuliaLang/julia/pull/37583
                    ret = INSTANCE(ps)
                else
                    if ps.t.dotop && closer(ps) && !isassignmentop(ps.t)
                        # Split dotted operator into dot-call
                        v = val(ps.t, ps)[2:end]
                        dot = EXPR(:OPERATOR, 1, 1, ".")
                        op = EXPR(:OPERATOR, ps.nt.startbyte - ps.t.startbyte - 1, ps.t.endbyte - ps.t.startbyte, v)
                        ret = EXPR(dot, EXPR[op], nothing)
                    else
                        ret = INSTANCE(ps)
                    end
                end
            end
            if is_colon(ret) && !(iscomma(ps.nt) || kindof(ps.ws) == SemiColonWS)
                ret = parse_unary(ps, ret)
            elseif isoperator(ret) && assign_prec(valof(ret)) && !isunaryop(ret)
                ret = mErrorToken(ps, ret, UnexpectedAssignmentOp)
            end
        elseif kindof(ps.t) === Tokens.AT_SIGN
            ret = parse_macrocall(ps)
        else
            ret = mErrorToken(ps, INSTANCE(ps), UnexpectedToken)
        end
        ret = parse_compound_recur(ps, ret)
    end
    return ret
end

function parse_compound_recur(ps, ret)
    !closer(ps) ? parse_compound_recur(ps, parse_compound(ps, ret)) : ret
end

"""
    parse_compound(ps::ParseState, ret::EXPR)

Attempts to parse a compound expression given the preceding expression `ret`.
"""
function parse_compound(ps::ParseState, ret::EXPR)
    if kindof(ps.nt) === Tokens.FOR
        ret = parse_generator(ps, ret)
    elseif kindof(ps.nt) === Tokens.DO
        ret = @default ps @closer ps :block parse_do(ps, ret)
    elseif isajuxtaposition(ps, ret)
        if disallowednumberjuxt(ret)
            ret = mErrorToken(ps, ret, CannotJuxtapose)
        end
        ret = parse_operator(ps, ret, EXPR(:OPERATOR, 0, 0, "*"))
    elseif issuffixableliteral(ps, ret)
        if isnumberliteral(ps.nt)
            arg = mLITERAL(next(ps))
            push!(ret, arg)
        else
            arg = EXPR(:IDENTIFIER, next(ps))
            push!(ret, EXPR(:STRING, arg.fullspan, arg.span, val(ps.t, ps)))
        end
    elseif (isidentifier(ret) || is_getfield(ret)) && isemptyws(ps.ws) && isprefixableliteral(ps.nt)
        ret = parse_prefixed_string_cmd(ps, ret)
    elseif kindof(ps.nt) === Tokens.LPAREN
        no_ws = !isemptyws(ps.ws)
        ret = @closer ps :for_generator @closeparen ps parse_call(ps, ret)
        if no_ws && !isunarycall(ret)
            ret = mErrorToken(ps, ret, UnexpectedWhiteSpace)
        end
    elseif kindof(ps.nt) === Tokens.LBRACE
        if isemptyws(ps.ws)
            ret = @default ps @nocloser ps :inwhere @closebrace ps parse_curly(ps, ret)
        else
            ret = mErrorToken(ps, (@default ps @nocloser ps :inwhere @closebrace ps parse_curly(ps, ret)), UnexpectedWhiteSpace)
        end
    elseif kindof(ps.nt) === Tokens.LSQUARE && isemptyws(ps.ws) && !isoperator(ret)
        ret = @closer ps :for_generator @default ps @nocloser ps :block parse_ref(ps, ret)
    elseif iscomma(ps.nt)
        ret = parse_tuple(ps, ret)
    elseif isunaryop(ret) && kindof(ps.nt) != Tokens.EQ
        ret = parse_unary(ps, ret)
    elseif isoperator(ps.nt)
        op = EXPR(:OPERATOR, next(ps))
        ret = parse_operator(ps, ret, op)
    elseif is_prime(ret.head)
        # prime operator followed by an identifier has an implicit multiplication
        nextarg = @precedence ps TimesOp parse_expression(ps)
        ret = EXPR(:call, EXPR[EXPR(:OPERATOR, 0, 0, "*"), ret, nextarg], nothing)
# ###############################################################################
# Everything below here is an error
# ###############################################################################
    else
        ps.errored = true
        if kindof(ps.nt) in (Tokens.RPAREN, Tokens.RSQUARE, Tokens.RBRACE)
            nextarg = mErrorToken(ps, EXPR(next(ps)), Unknown)
        else
            nextarg = try
                parse_expression(ps)
            catch err
                if err isa StackOverflowError
                    throw(error(string(ps, "\nsize: ", ps.l.io.size)))
                end
                mErrorToken(ps, ret, Unknown)
            end
        end
        ret = EXPR(:errortoken, EXPR[ret, nextarg], nothing)
    end
    return ret
end

"""
    parse_paren(ps, ret)

Parses an expression starting with a `(`.
"""
function parse_paren(ps::ParseState)
    args = EXPR[]
    trivia = EXPR[EXPR(ps)]
    @closeparen ps @default ps @nocloser ps :inwhere parse_comma_sep(ps, args, trivia, false, true, true, insert_params_at = 1)
    if length(args) == 1 && length(trivia) == 1 && ((kindof(ps.ws) !== SemiColonWS || headof(args[1]) === :block) && headof(args[1]) !== :parameters)
        accept_rparen(ps, trivia)
        ret = EXPR(:brackets, args, trivia)
    elseif VERSION < v"1.5" && length(args) == 1 && args[1].head === :parameters && isempty(args[1].args)
        accept_rparen(ps, trivia)
        pop!(args)
        push!(args, EXPR(:block, EXPR[], nothing))
        ret = EXPR(:brackets, args, trivia)
    else
        accept_rparen(ps, trivia)
        ret = EXPR(:tuple, args, trivia)
    end
    return ret
end

"""
    parse(str, cont = false)

Parses the passed string. If `cont` is true then will continue parsing until the end of the string returning the resulting expressions in a TOPLEVEL block.
"""
function parse(str::String, cont=false)
    ps = ParseState(str)
    x, _ = parse(ps, cont)
    return x
end

"""
    parse_doc(ps::ParseState)

Used for top-level parsing - attaches documentation (such as this) to expressions.
"""
function parse_doc(ps::ParseState)
    if (kindof(ps.nt) === Tokens.STRING || kindof(ps.nt) === Tokens.TRIPLE_STRING) && !isemptyws(ps.nws)
        doc = mLITERAL(next(ps))
        if kindof(ps.nt) === Tokens.ENDMARKER || kindof(ps.nt) === Tokens.END || ps.t.endpos[1] + 1 < ps.nt.startpos[1]
            ret = doc
        elseif isbinaryop(ps.nt) && !closer(ps)
            ret = parse_compound_recur(ps, doc)
        else
            ret = parse_expression(ps; is_toplevel = true)
            ret = EXPR(:macrocall, EXPR[EXPR(:globalrefdoc, 0, 0), EXPR(:NOTHING, 0, 0), doc, ret], nothing)
        end
    else
        ret = parse_expression(ps; is_toplevel = true)
    end
    if _continue_doc_parse(ps, ret)
        push!(ret, parse_expression(ps; is_toplevel = true))
    end
    return ret
end

function parse(ps::ParseState, cont=false)
    if ps.l.io.size == 0
        return (cont ? EXPR(:file, EXPR[]) : nothing), ps
    end
    last_line = 0
    curr_line = 0

    if cont
        top = EXPR(:file, EXPR[], nothing)
        if kindof(ps.nt) === Tokens.WHITESPACE || kindof(ps.nt) === Tokens.COMMENT
            next(ps)
            push!(top, EXPR(:NOTHING, ps.nt.startbyte, ps.nt.startbyte, ""))
        elseif kindof(ps.nt) === Tokens.SEMICOLON
            next(ps)
            push!(top, EXPR(:toplevel, EXPR[EXPR(:NOTHING, ps.nt.startbyte, ps.nt.startbyte, "")]))
        end

        prevpos = position(ps)
        while kindof(ps.nt) !== Tokens.ENDMARKER
            curr_line = ps.nt.startpos[1]
            ret = parse_doc(ps)
            # join semicolon sep items
            if curr_line == last_line && headof(last(top.args)) === :toplevel
                push!(last(top.args), ret)
                top.fullspan += ret.fullspan
                top.span = top.fullspan - (ret.fullspan - ret.span)
            elseif kindof(ps.ws) == SemiColonWS
                push!(top, EXPR(:toplevel, EXPR[ret]))
            else
                push!(top, ret)
            end
            last_line = curr_line
            kindof(ps.nt) === Tokens.ENDMARKER && break # don't do loop check if eof
            prevpos = loop_check(ps, prevpos)
        end
    else
        if kindof(ps.nt) === Tokens.WHITESPACE || kindof(ps.nt) === Tokens.COMMENT
            next(ps)
            top = EXPR(:NOTHING, ps.nt.startbyte, ps.nt.startbyte, "")
        elseif !(ps.done || kindof(ps.nt) === Tokens.ENDMARKER)
            last_line = current_line(ps)
            if ps.nt.kind === Tokens.SEMICOLON
                next(ps)
                top = EXPR(:toplevel, EXPR[EXPR(:NOTHING, ps.nt.startbyte, ps.nt.startbyte, "")])
            else
                top = parse_doc(ps)
            end
            if kindof(ps.ws) == SemiColonWS# && curr_line == last_line
                top = EXPR(:toplevel, EXPR[top], nothing)
                prevpos = position(ps)
                while kindof(ps.ws) == SemiColonWS && current_line(ps) == last_line && kindof(ps.nt) != Tokens.ENDMARKER
                    last_line = current_line(ps)
                    ret = parse_doc(ps)
                    push!(top, ret)
                    prevpos = loop_check(ps, prevpos)
                end
            end
        else
            top = EXPR(:errortoken, EXPR[], nothing, 0, 0)
        end
    end

    return top, ps
end

function _continue_doc_parse(ps::ParseState, x::EXPR)
    kindof(ps.nt) !== Tokens.ENDMARKER &&
    headof(x) === :macrocall &&
    valof(x.args[1]) == "@doc" &&
    length(x.args) < 4 &&
    ps.t.endpos[1] + 1 == ps.nt.startpos[1]
end

include("precompile.jl")
_precompile()

precedence(op::Int) = op < Tokens.end_assignments ?  AssignmentOp :
                       op < Tokens.end_pairarrow ? 2 :
                       op < Tokens.end_conditional ? ConditionalOp :
                       op < Tokens.end_arrow ?       ArrowOp :
                       op < Tokens.end_lazyor ?      LazyOrOp :
                       op < Tokens.end_lazyand ?     LazyAndOp :
                       op < Tokens.end_comparison ?  ComparisonOp :
                       op < Tokens.end_pipe ?        PipeOp :
                       op < Tokens.end_colon ?       ColonOp :
                       op < Tokens.end_plus ?        PlusOp :
                       op < Tokens.end_bitshifts ?   BitShiftOp :
                       op < Tokens.end_times ?       TimesOp :
                       op < Tokens.end_rational ?    RationalOp :
                       op < Tokens.end_power ?       PowerOp :
                       op < Tokens.end_decl ?        DeclarationOp :
                       op < Tokens.end_where ?       WhereOp : DotOp

precedence(kind::Tokens.Kind) = kind === Tokens.DDDOT ? DddotOp :
                        kind < Tokens.begin_assignments ? 0 :
                        kind < Tokens.end_assignments ?   AssignmentOp :
                        kind < Tokens.end_pairarrow ?   2 :
                       kind < Tokens.end_conditional ?    ConditionalOp :
                       kind < Tokens.end_arrow ?          ArrowOp :
                       kind < Tokens.end_lazyor ?         LazyOrOp :
                       kind < Tokens.end_lazyand ?        LazyAndOp :
                       kind < Tokens.end_comparison ?     ComparisonOp :
                       kind < Tokens.end_pipe ?           PipeOp :
                       kind < Tokens.end_colon ?          ColonOp :
                       kind < Tokens.end_plus ?           PlusOp :
                       kind < Tokens.end_bitshifts ?      BitShiftOp :
                       kind < Tokens.end_times ?          TimesOp :
                       kind < Tokens.end_rational ?       RationalOp :
                       kind < Tokens.end_power ?          PowerOp :
                       kind < Tokens.end_decl ?           DeclarationOp :
                       kind < Tokens.end_where ?          WhereOp :
                       kind < Tokens.end_dot ?            DotOp :
                       kind === Tokens.ANON_FUNC ? AnonFuncOp :
                       kind === Tokens.PRIME ?             PrimeOp : 20

precedence(x) = 0
precedence(x::AbstractToken) = precedence(kindof(x))
precedence(x::EXPR) = error()#precedence(kindof(x))

isoperator(x) = false
isoperator(t::AbstractToken) = isoperator(kindof(t))


isunaryop(op) = false
isunaryop(op::EXPR) = isoperator(op) && ((valof(op) == "<:" ||
                                          valof(op) == ">:" ||
                                          valof(op) == "+" ||
                                          valof(op) == "-" ||
                                          valof(op) == "!" ||
                                          valof(op) == "~" ||
                                          valof(op) == "¬" ||
                                          valof(op) == "&" ||
                                          valof(op) == "√" ||
                                          valof(op) == "∛"  ||
                                          valof(op) == "∜"  ||
                                          valof(op) == "::" ||
                                          valof(op) == "\$" ||
                                          valof(op) == ":" ||
                                          valof(op) == "⋆" ||
                                          valof(op) == "±" ||
                                          valof(op) == "∓") ||
                        (length(valof(op)) == 2 && valof(op)[1] == '.' && (valof(op)[2] == '+' ||
                                                                           valof(op)[2] == '-' ||
                                                                           valof(op)[2] == '!' ||
                                                                           valof(op)[2] == '~' ||
                                                                           valof(op)[2] == '¬' ||
                                                                           valof(op)[2] == '√' ||
                                                                           valof(op)[2] == '∛' ||
                                                                           valof(op)[2] == '∜' ||
                                                                           valof(op)[2] == '⋆' ||
                                                                           valof(op)[2] == '±' ||
                                                                           valof(op)[2] == '∓')))
isunaryop(t::AbstractToken) = isunaryop(kindof(t))
@static if VERSION < v"1.2.0"
    isunaryop(kind::Tokens.Kind) = kind === Tokens.ISSUBTYPE ||
                    kind === Tokens.ISSUPERTYPE ||
                    kind === Tokens.PLUS ||
                    kind === Tokens.MINUS ||
                    kind === Tokens.NOT ||
                    kind === Tokens.APPROX ||
                    kind === Tokens.NOT_SIGN ||
                    kind === Tokens.AND ||
                    kind === Tokens.SQUARE_ROOT ||
                    kind === Tokens.CUBE_ROOT ||
                    kind === Tokens.QUAD_ROOT ||
                    kind === Tokens.DECLARATION ||
                    kind === Tokens.EX_OR ||
                    kind === Tokens.COLON
else
    isunaryop(kind::Tokens.Kind) = kind === Tokens.ISSUBTYPE ||
                    kind === Tokens.ISSUPERTYPE ||
                    kind === Tokens.PLUS ||
                    kind === Tokens.MINUS ||
                    kind === Tokens.NOT ||
                    kind === Tokens.APPROX ||
                    kind === Tokens.NOT_SIGN ||
                    kind === Tokens.AND ||
                    kind === Tokens.SQUARE_ROOT ||
                    kind === Tokens.CUBE_ROOT ||
                    kind === Tokens.QUAD_ROOT ||
                    kind === Tokens.DECLARATION ||
                    kind === Tokens.EX_OR ||
                    kind === Tokens.COLON ||
                    kind === Tokens.STAR_OPERATOR
end

isunaryandbinaryop(t) = false
isunaryandbinaryop(t::AbstractToken) = isunaryandbinaryop(kindof(t))
@static if VERSION < v"1.2.0"
    isunaryandbinaryop(kind::Tokens.Kind) = kind === Tokens.PLUS ||
                            kind === Tokens.MINUS ||
                            kind === Tokens.EX_OR ||
                            kind === Tokens.ISSUBTYPE ||
                            kind === Tokens.ISSUPERTYPE ||
                            kind === Tokens.AND ||
                            kind === Tokens.APPROX ||
                            kind === Tokens.DECLARATION ||
                            kind === Tokens.COLON
else
    isunaryandbinaryop(kind::Tokens.Kind) = kind === Tokens.PLUS ||
                            kind === Tokens.MINUS ||
                            kind === Tokens.EX_OR ||
                            kind === Tokens.ISSUBTYPE ||
                            kind === Tokens.ISSUPERTYPE ||
                            kind === Tokens.AND ||
                            kind === Tokens.APPROX ||
                            kind === Tokens.DECLARATION ||
                            kind === Tokens.COLON ||
                            kind === Tokens.STAR_OPERATOR
end

isbinaryop(op) = false
isbinaryop(op::EXPR) = isoperator(op) && !(valof(op) == "√" ||
    valof(op) == "∛" ||
    valof(op) == "∜" ||
    valof(op) == "!" ||
    valof(op) == "¬")
isbinaryop(t::AbstractToken) = isbinaryop(kindof(t))
isbinaryop(kind::Tokens.Kind) = isoperator(kind) &&
                    !(kind === Tokens.SQUARE_ROOT ||
                    kind === Tokens.CUBE_ROOT ||
                    kind === Tokens.QUAD_ROOT ||
                    kind === Tokens.NOT ||
                    kind === Tokens.NOT_SIGN)

function non_dotted_op(t::AbstractToken)
    k = kindof(t)
    return (k === Tokens.COLON_EQ ||
            k === Tokens.PAIR_ARROW ||
            k === Tokens.EX_OR_EQ ||
            k === Tokens.CONDITIONAL ||
            k === Tokens.LAZY_OR ||
            k === Tokens.LAZY_AND ||
            k === Tokens.ISSUBTYPE ||
            k === Tokens.ISSUPERTYPE ||
            k === Tokens.LPIPE ||
            k === Tokens.RPIPE ||
            k === Tokens.EX_OR ||
            k === Tokens.COLON ||
            k === Tokens.DECLARATION ||
            k === Tokens.IN ||
            k === Tokens.ISA ||
            k === Tokens.WHERE ||
            (isunaryop(k) && !isbinaryop(k) && !(k === Tokens.NOT)))
end
isdotted(x::EXPR) = valof(x) isa String && length(valof(x)) > 1 && valof(x)[1] === '.' && !(valof(x) == "..." || valof(x) == "..")

issyntaxcall(op) = false
function issyntaxcall(op::EXPR)
    v = valof(op)
    if v[1] == '.' && length(v) > 1 && assign_prec(v[2:end]) && v[2] !== '~'
        return true
    end
    assign_prec(v) && !(v == "~" || v == ".~" || v == "=>") ||
    v == "-->" ||
    v == "||" ||
    v == ".||" ||
    v == "&&" ||
    v == ".&&" ||
    v == "<:" ||
    v == ">:" ||
    v == ":" ||
    v == "::" ||
    v == "." ||
    v == "..." ||
    v == "'" ||
    v == "where" ||
    v == "->"
end


issyntaxunarycall(op) = false
function issyntaxunarycall(op::EXPR)
    v = valof(op)
    !isdotted(op) && (v == "\$" || v == "&" || v == "::" || v == "..." || v == "'" || v == "<:" || v == ">:")
end



LtoR(prec::Int) = AssignmentOp ≤ prec ≤ LazyAndOp || prec == PowerOp


"""
    parse_unary(ps)

Having hit a unary operator at the start of an expression return a call.
"""
function parse_unary(ps::ParseState, op::EXPR)
    if is_colon(op)
        ret = parse_unary_colon(ps, op)
    elseif should_negate_number_literal(ps, op)
        arg = mLITERAL(next(ps))
        ret = EXPR(literalmap(kindof(ps.t)), op.fullspan + arg.fullspan, (op.fullspan + arg.span), string(is_plus(op) ? "+" : "-", val(ps.t, ps)))
    else
        prec = valof(op) == "::" ? DeclarationOp :
                valof(op) == "&" ? DeclarationOp :
                valof(op) == "\$" ? 20 : PowerOp
        arg = @closer ps :unary @precedence ps prec parse_expression(ps)
        if issyntaxunarycall(op)
            ret = EXPR(op, EXPR[arg], nothing)
        else
            ret = EXPR(:call, EXPR[op, arg], nothing)
        end
    end
    return ret
end

function parse_unary_colon(ps::ParseState, op::EXPR)
    op = requires_no_ws(op, ps)
    if Tokens.iskeyword(kindof(ps.nt)) && op.span == op.fullspan
        ret = EXPR(:quotenode, EXPR[EXPR(:IDENTIFIER, next(ps))], EXPR[op])
    elseif isidentifier(ps.nt)
        id = INSTANCE(next(ps))
        if VERSION > v"1.3.0-" && valof(id) == "var" && isemptyws(ps.ws) && (ps.nt.kind === Tokens.STRING || ps.nt.kind === Tokens.TRIPLE_STRING)
            # Special case for :var"sdf"
            arg = parse_string_or_cmd(next(ps), id)
            id = EXPR(:NONSTDIDENTIFIER, EXPR[id, arg], nothing)
        end
        ret = EXPR(:quotenode, EXPR[id], EXPR[op])
    elseif Tokens.begin_literal < kindof(ps.nt) < Tokens.CHAR ||
            isoperator(kindof(ps.nt)) || isidentifier(ps.nt) || kindof(ps.nt) === Tokens.TRUE || kindof(ps.nt) === Tokens.FALSE
        ret = EXPR(:quotenode, EXPR[INSTANCE(next(ps))], EXPR[op])
    elseif closer(ps)
        ret = op
    else
        prev_errored = ps.errored
        enable!(ps, ParserFlags.InQuote)
        arg = @precedence ps 20 @nocloser ps :inref parse_expression(ps)
        disable!(ps, ParserFlags.InQuote)
        if isbracketed(arg) && headof(arg.args[1]) === :errortoken && errorof(arg.args[1]) === UnexpectedAssignmentOp
            ps.errored = prev_errored
            arg.args[1] = arg.args[1].args[1]
            setparent!(arg.args[1], arg)
        end
        # TODO: need special conversion where arg is a n-bracketed terminal (not keywords)
        unwrapped = unwrapbracket(arg)
        if isoperator(unwrapped) || isidentifier(unwrapped) || isliteral(unwrapped)
            ret = EXPR(:quotenode, EXPR[arg], EXPR[op])
        elseif arg.head == :tuple && length(arg.args) == 1 && arg.args[1].head == :parameters && arg.args[1].args !== nothing && length(arg.args[1].args) == 0 && arg.span > 3
            block = EXPR(:BLOCK, EXPR[], EXPR[])
            block.span = arg.span
            block.fullspan = arg.fullspan
            ret = EXPR(:quote, EXPR[block], EXPR[op])
        else
            ret = EXPR(:quote, EXPR[arg], EXPR[op])
        end
    end
    return ret
end

function parse_operator_eq(ps::ParseState, ret::EXPR, op::EXPR)
    nextarg = @precedence ps AssignmentOp - LtoR(AssignmentOp) parse_expression(ps)

    if is_func_call(ret) && !(isbeginorblock(nextarg))
        nextarg = EXPR(:block, EXPR[nextarg], nothing)
    end
    if issyntaxcall(op)
        ret = EXPR(op, EXPR[ret, nextarg], nothing)
    else
        ret = EXPR(:call, EXPR[op, ret, nextarg], nothing)
    end
    return ret
end

# Parse conditionals

isconditional(x::EXPR) = headof(x) === :if && hastrivia(x) && isoperator(first(x.trivia))
function parse_operator_cond(ps::ParseState, ret::EXPR, op::EXPR)
    ret = requires_ws(ret, ps)
    op = requires_ws(op, ps)
    nextarg = @closer ps :ifop parse_expression(ps)
    if kindof(ps.nt) !== Tokens.COLON
        op2 = mErrorToken(ps, EXPR(:OPERATOR, 0, 0, ":"), MissingColon)
        nextarg2 = mErrorToken(ps, Unknown)
        return EXPR(:if, EXPR[ret, nextarg, nextarg2], EXPR[op, op2])
    else
        op2 = requires_ws(EXPR(:OPERATOR, next(ps)), ps)
    end

    nextarg2 = @closer ps :comma @precedence ps 0 parse_expression(ps)

    return EXPR(:if, EXPR[ret, nextarg, nextarg2], EXPR[op, op2])
end

# Parse comparisons
function parse_comp_operator(ps::ParseState, ret::EXPR, op::EXPR)
    nextarg = @precedence ps ComparisonOp - LtoR(ComparisonOp) parse_expression(ps)

    if headof(ret) === :comparison
        push!(ret, op)
        push!(ret, nextarg)
    elseif can_become_comparison(ret)
        if isoperator(headof(ret))
            ret = EXPR(:comparison, EXPR[ret.args[1], ret.head, ret.args[2], op, nextarg], nothing)
        else
            ret = EXPR(:comparison, EXPR[ret.args[2], ret.args[1], ret.args[3], op, nextarg], nothing)
        end
    elseif issyntaxcall(op)
        ret = EXPR(op, EXPR[ret, nextarg], nothing)
    else
        ret = EXPR(:call, EXPR[op, ret, nextarg], nothing)
    end
    return ret
end

# Parse ranges
function parse_operator_colon(ps::ParseState, ret::EXPR, op::EXPR)
    if isnewlinews(ps.ws) && !ps.closer.paren
        op = mErrorToken(ps, op, UnexpectedNewLine)
    end
    nextarg = @precedence ps ColonOp - LtoR(ColonOp) parse_expression(ps)

    if isbinarycall(ret) && is_colon(ret.args[1])
        ret.trivia = EXPR[]
        pushtotrivia!(ret, op)
        push!(ret, nextarg)
    else
        ret = EXPR(:call, EXPR[op, ret, nextarg], nothing)
    end
    return ret
end

# Parse power (special case for preceding unary ops)
function parse_operator_power(ps::ParseState, ret::EXPR, op::EXPR)
    nextarg = @precedence ps PowerOp - LtoR(PowerOp) @closer ps :inwhere parse_expression(ps)

    if isunarycall(ret)
        # TODO: this smells wrong
        nextarg = EXPR(:call, EXPR[op, ret.args[2], nextarg], nothing)
        ret = EXPR(:call, EXPR[ret.args[1], nextarg], nothing)
    else
        ret = EXPR(:call, EXPR[op, ret, nextarg], nothing)
    end
    return ret
end

# parse where
function parse_operator_where(ps::ParseState, ret::EXPR, op::EXPR, setscope=true)
    # https://github.com/JuliaLang/JuliaSyntax.jl/issues/395
    prec = VERSION > v"1.10-" && kindof(ps.nt) == Tokens.LBRACE ? WhereOp : LazyAndOp
    nextarg = @precedence ps prec @closer ps :inwhere parse_expression(ps)
    if headof(nextarg) === :braces
        pushfirst!(nextarg.args, ret)
        pushfirst!(nextarg.trivia, op)
        ret = EXPR(:where, nextarg.args, nextarg.trivia)
    else
        ret = EXPR(:where, EXPR[ret, nextarg], EXPR[op])
    end
    return ret
end

function rewrite_macrocall_quotenode(op, ret, nextarg)
    mname = EXPR(op, EXPR[ret, EXPR(:quotenode, EXPR[nextarg.args[1]], nothing)], nothing)
    ret = EXPR(:macrocall, EXPR[mname], nextarg.trivia)
    for i = 2:length(nextarg.args)
        push!(ret, nextarg.args[i])
    end
    return ret
end

function parse_operator_dot(ps::ParseState, ret::EXPR, op::EXPR)
    if kindof(ps.nt) === Tokens.LPAREN
        @static if VERSION > v"1.1-"
            iserred = kindof(ps.ws) != Tokens.EMPTY_WS
            sig = @default ps @closer ps :for_generator parse_call(ps, ret)
            nextarg = EXPR(:tuple, sig.args[2:end], sig.trivia)
            if iserred
                nextarg = mErrorToken(ps, nextarg, UnexpectedWhiteSpace)
            end
        else
            sig = @default ps @closer ps :for_generator parse_call(ps, ret)
            nextarg = EXPR(:tuple, sig.args[2:end], sig.trivia)
        end
    elseif iskeyword(ps.nt) || both_symbol_and_op(ps.nt)
        nextarg = EXPR(:IDENTIFIER, next(ps))
    elseif kindof(ps.nt) === Tokens.COLON
        op2 = EXPR(:OPERATOR, next(ps))
        if kindof(ps.nt) === Tokens.LPAREN
            nextarg = @closeparen ps @precedence ps DotOp - LtoR(DotOp) parse_expression(ps)
            nextarg = EXPR(:quotenode, EXPR[nextarg], EXPR[op2])
        else
            nextarg = @precedence ps DotOp - LtoR(DotOp) parse_unary(ps, op2)
        end
    elseif kindof(ps.nt) === Tokens.EX_OR && kindof(ps.nnt) === Tokens.LPAREN
        op2 = EXPR(:OPERATOR, next(ps))
        nextarg = parse_call(ps, op2)
    else
        nextarg = @precedence ps DotOp - LtoR(DotOp) parse_expression(ps)
    end

    if isidentifier(nextarg) || isinterpolant(nextarg)
        ret = EXPR(op, EXPR[ret, EXPR(:quotenode, EXPR[nextarg], nothing)], nothing)
    elseif headof(nextarg) === :vect
        ret = EXPR(op, EXPR[ret, EXPR(:quote, EXPR[nextarg], nothing)], nothing)
    elseif headof(nextarg) === :braces
        @static if VERSION >= v"1.12-"
            ret = EXPR(op, EXPR[ret, EXPR(:quotenode, EXPR[nextarg], nothing)], nothing)
        else
            ret = EXPR(op, EXPR[ret, EXPR(:quote, EXPR[nextarg], nothing)], nothing)
        end
    elseif headof(nextarg) === :macrocall
        ret = rewrite_macrocall_quotenode(op, ret, nextarg)
    elseif VERSION >= v"1.8.0-" && headof(nextarg) === :do && headof(nextarg.args[1]) === :macrocall
        mcall = rewrite_macrocall_quotenode(op, ret, nextarg.args[1])

        ret = EXPR(:do, EXPR[mcall], nextarg.trivia)
        for i = 2:length(nextarg.args)
            push!(ret, nextarg.args[i])
        end
    else
        ret = EXPR(op, EXPR[ret, nextarg], nothing)
    end
    return ret
end

function parse_operator_anon_func(ps::ParseState, ret::EXPR, op::EXPR)
    arg = @closer ps :comma @precedence ps 0 parse_expression(ps)
    if !isbeginorblock(arg)
        arg = EXPR(:block, EXPR[arg], nothing)
    end
    return EXPR(op, EXPR[ret, arg], nothing)
end

function parse_operator_pair(ps::ParseState, ret::EXPR, op::EXPR)
    arg = @closer ps :comma @precedence ps 0 parse_expression(ps)
    return EXPR(:call, EXPR[op, ret, arg], nothing)
end

function parse_operator(ps::ParseState, ret::EXPR, op::EXPR)
    P = isdotted(op) ? get_prec(valof(op)[2:end]) : get_prec(valof(op))
    if op.val == "*" && op.fullspan == 0 # implicit multiplication has a very high precedence, but lower than ^
        P = RationalOp
    end
    if headof(ret) === :call && (is_plus(ret.args[1]) || is_star(ret.args[1])) &&
          valof(ret.args[1]) == valof(op) && ret.args[1].span > 0 &&
          !(hastrivia(ret) && headof(ret[end]) === :RPAREN)
        # a + b -> a + b + c
        nextarg = @precedence ps P - LtoR(P) parse_expression(ps)
        !hastrivia(ret) && (ret.trivia = EXPR[])
        pushtotrivia!(ret, op)
        push!(ret, nextarg)
        ret = ret
    elseif is_eq(op)
        ret = parse_operator_eq(ps, ret, op)
    elseif is_cond(op)
        ret = parse_operator_cond(ps, ret, op)
    elseif is_colon(op)
        ret = parse_operator_colon(ps, ret, op)
    elseif is_where(op)
        ret = parse_operator_where(ps, ret, op)
    elseif is_anon_func(op)
        ret = parse_operator_anon_func(ps, ret, op)
    elseif is_dot(op)
        ret = parse_operator_dot(ps, ret, op)
    elseif is_dddot(op)
        ret = EXPR(op, EXPR[ret], nothing)
    elseif is_prime(op)
        if isidentifier(ret) || isliteral(ret) ||
                headof(ret) in (
                    :call, :tuple, :brackets, :ref, :vect, :vcat, :hcat, :ncat, :typed_vcat,
                    :typed_hcat, :typed_ncat, :comprehension, :typed_comprehension, :curly,
                    :braces, :braces_cat
                ) ||
                headof(ret) === :do ||
                is_dot(headof(ret)) ||
                is_prime(headof(ret)) ||
                isinterpolant(ret)
            if valof(op) == "'"
                ret = EXPR(op, EXPR[ret], nothing)
            else
                ret = EXPR(:call, EXPR[op, ret], nothing)
            end
        else
            ret = EXPR(:errortoken, EXPR[ret, op])
            ret.meta = UnexpectedToken
        end
    elseif P == ComparisonOp
        ret = parse_comp_operator(ps, ret, op)
    elseif P == PowerOp
        ret = parse_operator_power(ps, ret, op)
    elseif P == 2
        ret = parse_operator_pair(ps, ret, op)
    else
        ltor = valof(op) == "<|" ? true : LtoR(P)
        nextarg = @precedence ps P - ltor parse_expression(ps)
        if issyntaxcall(op)
            ret = EXPR(op, EXPR[ret, nextarg], nothing)
        else
            ret = EXPR(:call, EXPR[op, ret, nextarg], nothing)
        end
    end
    return ret
end

assign_prec(op::String) = get(AllPrecs, op, 0) === AssignmentOp || (length(op) > 1 && op[1] == '.' && assign_prec(op[2:end]))
comp_prec(op::String) = get(AllPrecs, op, 0) === ComparisonOp || (length(op) > 1 && op[1] == '.' && comp_prec(op[2:end]))

# Which ops have different precend when dotted?
# [op for op in Symbol.(keys(CSTParser.AllPrecs)) if Base.isoperator(op) && Base.isoperator(Symbol(".", op)) && Base.operator_precedence(op) !== Base.operator_precedence(Symbol(".", op))]

get_prec(op) = get(AllPrecs, maybe_strip_suffix(op), 0)

function maybe_strip_suffix(op::String)
    for (i, c) in enumerate(op)
        if Tokenize.Lexers.isopsuffix(c)
            return op[1:prevind(op, i)]
        end
    end
    return op
end

const AllPrecs = Dict(
    "≏" => PlusOp,
    "⤎" => ArrowOp,
    "<:" => ComparisonOp,
    "⫌" => ComparisonOp,
    "⇀" => ArrowOp,
    "≁" => ComparisonOp,
    "⧀" => ComparisonOp,
    "⪎" => ComparisonOp,
    "⪱" => ComparisonOp,
    "↬" => ArrowOp,
    "⇝" => ArrowOp,
    "⩳" => ComparisonOp,
    "⪻" => ComparisonOp,
    "//" => RationalOp,
    "⬿" => ArrowOp,
    "⊅" => ComparisonOp,
    "⋳" => ComparisonOp,
    "≮" => ComparisonOp,
    "\$=" => AssignmentOp,
    "≗" => ComparisonOp,
    "⋗" => ComparisonOp,
    "⩊" => PlusOp,
    "⪵" => ComparisonOp,
    "⋟" => ComparisonOp,
    "⤠" => ArrowOp,
    "≵" => ComparisonOp,
    "⧁" => ComparisonOp,
    "≫" => ComparisonOp,
    "⩫" => ComparisonOp,
    "⪸" => ComparisonOp,
    "⊓" => TimesOp,
    "⭄" => ArrowOp,
    "⇁" => ArrowOp,
    "≀" => TimesOp,
    "⪚" => ComparisonOp,
    "∷" => ComparisonOp,
    "⥪" => ArrowOp,
    "⥔" => PowerOp,
    "⊻" => PlusOp,
    "⩯" => ComparisonOp,
    "↷" => ArrowOp,
    "⇿" => ArrowOp,
    "⪉" => ComparisonOp,
    "⊰" => ComparisonOp,
    "⨟" => TimesOp,
    "⩻" => ComparisonOp,
    "⭋" => ArrowOp,
    "⩒" => PlusOp,
    "-" => PlusOp,
    "−" => PlusOp,
    "⫸" => ComparisonOp,
    "⤒" => PowerOp,
    "+=" => AssignmentOp,
    "↦" => ArrowOp,
    "⊜" => ComparisonOp,
    "|>" => PipeOp,
    "⩀" => TimesOp,
    "⪫" => ComparisonOp,
    "≡" => ComparisonOp,
    "⋹" => ComparisonOp,
    "⤑" => ArrowOp,
    "⥐" => ArrowOp,
    "≭" => ComparisonOp,
    "≼" => ComparisonOp,
    "⥇" => ArrowOp,
    "⋶" => ComparisonOp,
    "⨸" => TimesOp,
    "⩽" => ComparisonOp,
    "⪐" => ComparisonOp,
    "⨥" => PlusOp,
    "∊" => ComparisonOp,
    "⪙" => ComparisonOp,
    "⥢" => ArrowOp,
    "⅋" => TimesOp,
    "⫘" => ComparisonOp,
    "⊂" => ComparisonOp,
    "⩸" => ComparisonOp,
    "⩄" => TimesOp,
    "⤞" => ArrowOp,
    "⫍" => ComparisonOp,
    "⨢" => PlusOp,
    "⊄" => ComparisonOp,
    "≯" => ComparisonOp,
    "===" => ComparisonOp,
    "⬺" => ArrowOp,
    "⪛" => ComparisonOp,
    "⋡" => ComparisonOp,
    "⫀" => ComparisonOp,
    "⨣" => PlusOp,
    "↞" => ArrowOp,
    "⟾" => ArrowOp,
    "⊬" => ComparisonOp,
    "⇌" => ArrowOp,
    "≷" => ComparisonOp,
    "∓" => PlusOp,
    "⪶" => ComparisonOp,
    "⊀" => ComparisonOp,
    "⊛" => TimesOp,
    "⋠" => ComparisonOp,
    "↢" => ArrowOp,
    "⥦" => ArrowOp,
    "⪪" => ComparisonOp,
    "⋌" => TimesOp,
    "⪅" => ComparisonOp,
    "≿" => ComparisonOp,
    ">>=" => AssignmentOp,
    "\$" => PlusOp,
    "≽" => ComparisonOp,
    "⪟" => ComparisonOp,
    "⋆" => TimesOp,
    "±" => PlusOp,
    "⋴" => ComparisonOp,
    "⥧" => ArrowOp,
    "/" => TimesOp,
    "⥕" => PowerOp,
    "." => DotOp,
    "⩢" => PlusOp,
    "⟖" => TimesOp,
    "⪗" => ComparisonOp,
    "≓" => ComparisonOp,
    "⋨" => ComparisonOp,
    "⥜" => PowerOp,
    "⪊" => ComparisonOp,
    "⨽" => TimesOp,
    "⪦" => ComparisonOp,
    "≱" => ComparisonOp,
    "⧷" => TimesOp,
    ">>" => BitShiftOp,
    "⊏" => ComparisonOp,
    "⬴" => ArrowOp,
    "⪴" => ComparisonOp,
    "⁝" => ColonOp,
    "⤘" => ArrowOp,
    "⩜" => TimesOp,
    "￬" => PowerOp,
    "∤" => TimesOp,
    "⩲" => ComparisonOp,
    "⫙" => ComparisonOp,
    "⇵" => PowerOp,
    "⤗" => ArrowOp,
    "⪀" => ComparisonOp,
    "⩬" => ComparisonOp,
    "↫" => ArrowOp,
    "&" => TimesOp,
    "⩺" => ComparisonOp,
    "↚" => ArrowOp,
    "⨇" => TimesOp,
    "⋭" => ComparisonOp,
    "≐" => ComparisonOp,
    "∩" => TimesOp,
    "↓" => PowerOp,
    "⪓" => ComparisonOp,
    "≦" => ComparisonOp,
    "=" => AssignmentOp,
    "∧" => TimesOp,
    "⇇" => ArrowOp,
    "≖" => ComparisonOp,
    "⇸" => ArrowOp,
    "⋙" => ComparisonOp,
    "≚" => ComparisonOp,
    "⇴" => ArrowOp,
    "⬲" => ArrowOp,
    "⥙" => PowerOp,
    "⋢" => ComparisonOp,
    "⫹" => ComparisonOp,
    "⩛" => PlusOp,
    "⋿" => ComparisonOp,
    "⪑" => ComparisonOp,
    "⭉" => ArrowOp,
    "⋎" => PlusOp,
    "⋋" => TimesOp,
    "⇋" => ArrowOp,
    "≴" => ComparisonOp,
    "…" => ColonOp,
    "⪰" => ComparisonOp,
    "↺" => ArrowOp,
    "⪖" => ComparisonOp,
    "⨦" => PlusOp,
    "⬼" => ArrowOp,
    "⤐" => ArrowOp,
    "⊗" => TimesOp,
    "⨮" => PlusOp,
    "⊚" => TimesOp,
    "⥈" => ArrowOp,
    "≣" => ComparisonOp,
    "⋫" => ComparisonOp,
    "≺" => ComparisonOp,
    "⇽" => ArrowOp,
    "⬳" => ArrowOp,
    "⥨" => ArrowOp,
    "⋽" => ComparisonOp,
    "⩟" => TimesOp,
    "⋞" => ComparisonOp,
    "⩖" => PlusOp,
    "⧥" => ComparisonOp,
    "⨝" => TimesOp,
    "⪕" => ComparisonOp,
    "⊟" => PlusOp,
    "⋑" => ComparisonOp,
    "⊲" => ComparisonOp,
    "≟" => ComparisonOp,
    "⫈" => ComparisonOp,
    "⥋" => ArrowOp,
    "⩂" => PlusOp,
    "⥏" => PowerOp,
    "⥩" => ArrowOp,
    "⥑" => PowerOp,
    "⪤" => ComparisonOp,
    "⫖" => ComparisonOp,
    "×" => TimesOp,
    "÷=" => AssignmentOp,
    "⋪" => ComparisonOp,
    "⫓" => ComparisonOp,
    "⫄" => ComparisonOp,
    "⊋" => ComparisonOp,
    "⇆" => ArrowOp,
    "⤌" => ArrowOp,
    "⟹" => ArrowOp,
    "⊖" => PlusOp,
    "⫏" => ComparisonOp,
    "⫷" => ComparisonOp,
    "⪜" => ComparisonOp,
    "⊕" => PlusOp,
    "%=" => AssignmentOp,
    "⊍" => TimesOp,
    "⨤" => PlusOp,
    "≃" => ComparisonOp,
    "⩪" => ComparisonOp,
    "⤉" => PowerOp,
    "⪽" => ComparisonOp,
    "⋓" => PlusOp,
    "⤀" => ArrowOp,
    "∺" => ComparisonOp,
    "⤆" => ArrowOp,
    "⊳" => ComparisonOp,
    "//=" => AssignmentOp,
    "≒" => ComparisonOp,
    "⩦" => ComparisonOp,
    "↶" => ArrowOp,
    "⊡" => TimesOp,
    "⟈" => ComparisonOp,
    "≩" => ComparisonOp,
    "||" => LazyOrOp,
    "↠" => ArrowOp,
    "⥒" => ArrowOp,
    "⨧" => PlusOp,
    "⪧" => ComparisonOp,
    "⨪" => PlusOp,
    "⇹" => ArrowOp,
    "⥛" => ArrowOp,
    "↣" => ArrowOp,
    "⫁" => ComparisonOp,
    "⭊" => ArrowOp,
    "⋜" => ComparisonOp,
    "⪳" => ComparisonOp,
    "⋼" => ComparisonOp,
    "⥍" => PowerOp,
    "⫎" => ComparisonOp,
    "^=" => AssignmentOp,
    "⪢" => ComparisonOp,
    "∪" => PlusOp,
    "⩅" => PlusOp,
    "⬵" => ArrowOp,
    "⬽" => ArrowOp,
    "≬" => ComparisonOp,
    "⧶" => TimesOp,
    "⪡" => ComparisonOp,
    "≶" => ComparisonOp,
    "⇼" => ArrowOp,
    "^" => PowerOp,
    "⇷" => ArrowOp,
    "⋸" => ComparisonOp,
    "⊩" => ComparisonOp,
    "⭀" => ArrowOp,
    "⧴" => ArrowOp,
    "⊷" => ComparisonOp,
    "⤔" => ArrowOp,
    "~" => AssignmentOp,
    "⫒" => ComparisonOp,
    "⩼" => ComparisonOp,
    "⧺" => PlusOp,
    "⧻" => PlusOp,
    ">>>=" => AssignmentOp,
    "⪂" => ComparisonOp,
    "⨻" => TimesOp,
    "⤏" => ArrowOp,
    "⥘" => PowerOp,
    "≕" => AssignmentOp,
    "⥓" => ArrowOp,
    "⨰" => TimesOp,
    "⨺" => PlusOp,
    "⟵" => ArrowOp,
    "⇜" => ArrowOp,
    "<<=" => AssignmentOp,
    "≔" => AssignmentOp,
    "⩋" => TimesOp,
    "⫊" => ComparisonOp,
    "⪠" => ComparisonOp,
    "⥬" => ArrowOp,
    "⥖" => ArrowOp,
    "⪣" => ComparisonOp,
    "↔" => ArrowOp,
    "≥" => ComparisonOp,
    "⧤" => ComparisonOp,
    "⤄" => ArrowOp,
    "⊢" => ComparisonOp,
    "⋛" => ComparisonOp,
    "⩔" => PlusOp,
    "⇶" => ArrowOp,
    "⤇" => ArrowOp,
    "⟽" => ArrowOp,
    "⩵" => ComparisonOp,
    "⬶" => ArrowOp,
    "⩌" => PlusOp,
    "↮" => ArrowOp,
    "⪾" => ComparisonOp,
    "⋕" => ComparisonOp,
    "⥤" => ArrowOp,
    "∋" => ComparisonOp,
    "↽" => ArrowOp,
    "⋇" => TimesOp,
    "⪍" => ComparisonOp,
    "⩃" => TimesOp,
    "⨈" => PlusOp,
    "⋚" => ComparisonOp,
    "⩐" => PlusOp,
    "≾" => ComparisonOp,
    "⋤" => ComparisonOp,
    "∔" => PlusOp,
    "⤈" => PowerOp,
    "⇾" => ArrowOp,
    "⊮" => ComparisonOp,
    "⪩" => ComparisonOp,
    "⬷" => ArrowOp,
    "↪" => ArrowOp,
    "⭇" => ArrowOp,
    "⨨" => PlusOp,
    "⩓" => TimesOp,
    "⤊" => PowerOp,
    "↤" => ArrowOp,
    "⊱" => ComparisonOp,
    "⟼" => ArrowOp,
    "⨴" => TimesOp,
    "⤋" => PowerOp,
    "⊴" => ComparisonOp,
    "≊" => ComparisonOp,
    "⧡" => ComparisonOp,
    "⫆" => ComparisonOp,
    "⋯" => ColonOp,
    "≜" => ComparisonOp,
    "∍" => ComparisonOp,
    "::" => DeclarationOp,
    "⥣" => PowerOp,
    "⪃" => ComparisonOp,
    "⪹" => ComparisonOp,
    "⩴" => AssignmentOp,
    "⥫" => ArrowOp,
    "￫" => ArrowOp,
    ">>>" => BitShiftOp,
    "≢" => ComparisonOp,
    "⊈" => ComparisonOp,
    "≤" => ComparisonOp,
    "⟿" => ArrowOp,
    "⪨" => ComparisonOp,
    "⋖" => ComparisonOp,
    "⫉" => ComparisonOp,
    "⩹" => ComparisonOp,
    "￪" => PowerOp,
    "⊆" => ComparisonOp,
    "!==" => ComparisonOp,
    "⪔" => ComparisonOp,
    "⥎" => ArrowOp,
    "≋" => ComparisonOp,
    "⊁" => ComparisonOp,
    "⋥" => ComparisonOp,
    "⋉" => TimesOp,
    "⨱" => TimesOp,
    "?" => ConditionalOp,
    "⥚" => ArrowOp,
    "⋷" => ComparisonOp,
    "⟒" => ComparisonOp,
    "⫅" => ComparisonOp,
    "⪏" => ComparisonOp,
    "⩕" => TimesOp,
    "⪞" => ComparisonOp,
    ">:" => ComparisonOp,
    "⟗" => TimesOp,
    "⪷" => ComparisonOp,
    "⩎" => TimesOp,
    "⬱" => ArrowOp,
    "⇺" => ArrowOp,
    "⩁" => PlusOp,
    "⥆" => ArrowOp,
    "⊘" => TimesOp,
    "⨼" => TimesOp,
    "⊙" => TimesOp,
    "⊇" => ComparisonOp,
    "⋍" => ComparisonOp,
    "≛" => ComparisonOp,
    "⊒" => ComparisonOp,
    "⋏" => TimesOp,
    "⭁" => ArrowOp,
    "⤂" => ArrowOp,
    "⥄" => ArrowOp,
    "⋝" => ComparisonOp,
    "÷" => TimesOp,
    "⧣" => ComparisonOp,
    "⊞" => PlusOp,
    "⬾" => ArrowOp,
    "⇉" => ArrowOp,
    "⨶" => TimesOp,
    "in" => ComparisonOp,
    "==" => ComparisonOp,
    "⟶" => ArrowOp,
    "⬰" => ArrowOp,
    ":=" => AssignmentOp,
    "⪋" => ComparisonOp,
    "≂" => ComparisonOp,
    "<|" => PipeOp,
    "⥊" => ArrowOp,
    "⪺" => ComparisonOp,
    "≎" => ComparisonOp,
    "≈" => ComparisonOp,
    "∌" => ComparisonOp,
    "⨹" => PlusOp,
    "⪘" => ComparisonOp,
    "⨵" => TimesOp,
    "⦾" => TimesOp,
    "⇒" => ArrowOp,
    ".." => ColonOp,
    "⇛" => ArrowOp,
    "⪿" => ComparisonOp,
    "≹" => ComparisonOp,
    "⋱" => ColonOp,
    "⇎" => ArrowOp,
    "→" => ArrowOp,
    "⥮" => PowerOp,
    "-=" => AssignmentOp,
    "−=" => AssignmentOp,
    "<" => ComparisonOp,
    "⪇" => ComparisonOp,
    "⥗" => ArrowOp,
    "⪈" => ComparisonOp,
    "⨫" => PlusOp,
    "⥞" => ArrowOp,
    "⭂" => ArrowOp,
    "⩠" => TimesOp,
    "\\" => TimesOp,
    "⩿" => ComparisonOp,
    "↑" => PowerOp,
    "≳" => ComparisonOp,
    "⋧" => ComparisonOp,
    "⩧" => ComparisonOp,
    "--" => 0,
    "⪮" => ComparisonOp,
    "⪄" => ComparisonOp,
    "⊎" => PlusOp,
    "⩾" => ComparisonOp,
    "↝" => ArrowOp,
    "⨲" => TimesOp,
    "⊐" => ComparisonOp,
    "⟻" => ArrowOp,
    "⫗" => ComparisonOp,
    "⩞" => TimesOp,
    "⥯" => PowerOp,
    "⪌" => ComparisonOp,
    "≨" => ComparisonOp,
    "⋄" => TimesOp,
    "⪯" => ComparisonOp,
    "⦸" => TimesOp,
    "⫐" => ComparisonOp,
    "↜" => ArrowOp,
    "≧" => ComparisonOp,
    "∉" => ComparisonOp,
    "⤟" => ArrowOp,
    "⋾" => ComparisonOp,
    "￩" => ArrowOp,
    "<<" => BitShiftOp,
    "≞" => ComparisonOp,
    "⩍" => TimesOp,
    "⇄" => ArrowOp,
    "▷" => TimesOp,
    "⋘" => ComparisonOp,
    "≇" => ComparisonOp,
    "⇏" => ArrowOp,
    "⊶" => ComparisonOp,
    "⫇" => ComparisonOp,
    "*" => TimesOp,
    "⩣" => PlusOp,
    "⬸" => ArrowOp,
    "⥥" => PowerOp,
    "≙" => ComparisonOp,
    "*=" => AssignmentOp,
    "≄" => ComparisonOp,
    "⊑" => ComparisonOp,
    "⫑" => ComparisonOp,
    "⩗" => PlusOp,
    "⟷" => ArrowOp,
    "⟱" => PowerOp,
    "≻" => ComparisonOp,
    "⋲" => ComparisonOp,
    "≑" => ComparisonOp,
    "⭈" => ArrowOp,
    "∾" => ComparisonOp,
    "&=" => AssignmentOp,
    "≪" => ComparisonOp,
    "↼" => ArrowOp,
    "⬹" => ArrowOp,
    "∗" => TimesOp,
    "⊣" => ComparisonOp,
    "⫺" => ComparisonOp,
    "⥌" => PowerOp,
    "⋩" => ComparisonOp,
    "≲" => ComparisonOp,
    "≝" => ComparisonOp,
    "⊽" => PlusOp,
    "/=" => AssignmentOp,
    "⋬" => ComparisonOp,
    "⩶" => ComparisonOp,
    "⫛" => TimesOp,
    "=>" => ConditionalOp,
    "⪁" => ComparisonOp,
    "⨩" => PlusOp,
    "⥝" => PowerOp,
    "⩝" => PlusOp,
    "⟕" => TimesOp,
    "⤖" => ArrowOp,
    "⥉" => PowerOp,
    "⩏" => PlusOp,
    "!=" => ComparisonOp,
    "⨳" => TimesOp,
    "≰" => ComparisonOp,
    "⟂" => ComparisonOp,
    "⋐" => ComparisonOp,
    "\\=" => AssignmentOp,
    "⤝" => ArrowOp,
    "⦷" => ComparisonOp,
    "⊔" => PlusOp,
    ">" => ComparisonOp,
    "⥰" => ArrowOp,
    "∽" => ComparisonOp,
    "⋦" => ComparisonOp,
    "⤅" => ArrowOp,
    "⫕" => ComparisonOp,
    "⋺" => ComparisonOp,
    "∈" => ComparisonOp,
    "∙" => TimesOp,
    "⥅" => ArrowOp,
    "⦼" => TimesOp,
    "<=" => ComparisonOp,
    "←" => ArrowOp,
    "isa" => ComparisonOp,
    "⋻" => ComparisonOp,
    "⫔" => ComparisonOp,
    "⋵" => ComparisonOp,
    "⋅" => TimesOp,
    "·" => TimesOp,
    "⨷" => TimesOp,
    "⟰" => PowerOp,
    "∨" => PlusOp,
    "≆" => ComparisonOp,
    "⪥" => ComparisonOp,
    "≍" => ComparisonOp,
    "⪝" => ComparisonOp,
    "⫂" => ComparisonOp,
    "⊻=" => AssignmentOp,
    "⨭" => PlusOp,
    "⋒" => TimesOp,
    "⦿" => TimesOp,
    "≸" => ComparisonOp,
    "⥡" => PowerOp,
    "+" => PlusOp,
    "⇻" => ArrowOp,
    "⥟" => ArrowOp,
    "⟉" => ComparisonOp,
    "⊵" => ComparisonOp,
    "⩰" => ComparisonOp,
    "%" => TimesOp,
    "⫃" => ComparisonOp,
    "∸" => PlusOp,
    "⋣" => ComparisonOp,
    "-->" => ArrowOp,
    "<--" => ArrowOp,
    "<-->" => ArrowOp,
    "∥" => ComparisonOp,
    "∦" => ComparisonOp,
    "⋮" => ColonOp,
    "⪒" => ComparisonOp,
    "⤃" => ArrowOp,
    "⟑" => TimesOp,
    "⩑" => TimesOp,
    "⋰" => ColonOp,
    "⪬" => ComparisonOp,
    "≠" => ComparisonOp,
    "≅" => ComparisonOp,
    "⊼" => TimesOp,
    "⬻" => ArrowOp,
    "⩘" => TimesOp,
    "⭃" => ArrowOp,
    "⥭" => ArrowOp,
    "⤕" => ArrowOp,
    "≘" => ComparisonOp,
    "⇠" => ArrowOp,
    "⟺" => ArrowOp,
    "⪼" => ComparisonOp,
    "⇢" => ArrowOp,
    "↩" => ArrowOp,
    "⋊" => TimesOp,
    "&&" => LazyAndOp,
    "⩚" => TimesOp,
    "⩮" => ComparisonOp,
    "⤓" => PowerOp,
    "⥠" => PowerOp,
    "⤁" => ArrowOp,
    "≌" => ComparisonOp,
    "⭌" => ArrowOp,
    "⇐" => ArrowOp,
    ":" => ColonOp,
    "⇍" => ArrowOp,
    "⩭" => ComparisonOp,
    "↛" => ArrowOp,
    "↻" => ArrowOp,
    "⪲" => ComparisonOp,
    "⇔" => ArrowOp,
    "⪭" => ComparisonOp,
    "⩱" => ComparisonOp,
    "⤍" => ArrowOp,
    "⊃" => ComparisonOp,
    "∝" => ComparisonOp,
    "⊊" => ComparisonOp,
    "⊠" => TimesOp,
    "∘" => TimesOp,
    "⇚" => ArrowOp,
    "⪆" => ComparisonOp,
    "⫋" => ComparisonOp,
    "|" => PlusOp,
    "⊉" => ComparisonOp,
    "∻" => ComparisonOp,
    "≉" => ComparisonOp,
    "⩡" => PlusOp,
    "⨬" => PlusOp,
    "⩷" => ComparisonOp,
    ">=" => ComparisonOp,
    "..." => 0,
    "where" => WhereOp,
    "->" => AnonFuncOp,
    "|=" => AssignmentOp,
    "'" => PrimeOp,
    "!" => 0,
    "√" => 0,
    "∛" => 0,
    "∜" => 0,
    "++" => PlusOp,
    "¬" => 0,
    "¦" => PlusOp,
    "⌿" => TimesOp,
    "⫪" => ComparisonOp,
    "⫫" => ComparisonOp
)

@testitem "Parser" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test Meta.parse("(1,)") == Expr(:tuple, 1)
end

@testitem "Type Annotations Curly" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "x{T}" |> test_expr
    @test "x{T,S}" |> test_expr
    @test "a.b{T}" |> test_expr
    @test "a(b){T}" |> test_expr
    @test "(a(b)){T}" |> test_expr
    @test "a{b}{T}" |> test_expr
    @test "a{b}(c){T}" |> test_expr
    @test "a{b}.c{T}" |> test_expr
    @test """x{T,
S}""" |> test_expr
end

@testitem "Tuples" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @static if VERSION > v"1.1-"
        @test headof(CSTParser.parse("1,")) === :errortoken
    else
        @test "1," |> test_expr
    end
    @test "1,2" |> test_expr
    @test "1,2,3" |> test_expr
    @test "()" |> test_expr
    @test "(==)" |> test_expr
    @test "(1)" |> test_expr
    @test "(1,)" |> test_expr
    @test "(1,2)" |> test_expr
    @test "(a,b,c)" |> test_expr
    @test "(a...)" |> test_expr
    @test "((a,b)...)" |> test_expr
    @test "a,b = c,d" |> test_expr
    @test "(a,b) = (c,d)" |> test_expr
end

@testitem "Generators" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "(y for y in X)" |> test_expr
    @test "((x,y) for x in X, y in Y)" |> test_expr
    @test "(y.x for y in X)" |> test_expr
    @test "((y) for y in X)" |> test_expr
    @test "(y,x for y in X)" |> test_expr
    @test "((y,x) for y in X)" |> test_expr
    @test "[y for y in X]" |> test_expr
    @test "[(y) for y in X]" |> test_expr
    @test "[(y,x) for y in X]" |> test_expr
    @test "Int[y for y in X]" |> test_expr
    @test "Int[(y) for y in X]" |> test_expr
    @test "Int[(y,x) for y in X]" |> test_expr
    @test """
[a
for a = 1:2]""" |> test_expr
    @test "[ V[j][i]::T for i=1:length(V[1]), j=1:length(V) ]" |> test_expr
    @test "all(d ≥ 0 for d in B.dims)" |> test_expr
    @test "(arg for x in X)" |> test_expr
    @test "(arg for x in X for y in Y)" |> test_expr
    @test "(arg for x in X for y in Y for z in Z)" |> test_expr
    @test "(arg for x in X if A)" |> test_expr
    @test "(arg for x in X if A for y in Y)" |> test_expr
    @test "(arg for x in X if A for y in Y if B)" |> test_expr
    @test "(arg for x in X if A for y in Y for z in Z)" |> test_expr
    @test "(arg for x in X if A for y in Y if B for z in Z)" |> test_expr
    @test "(arg for x in X if A for y in Y if B for z in Z if C)" |> test_expr
    @test "(arg for x in X, y in Y for z in Z)" |> test_expr
    @test "(arg for x in X, y in Y if A for z in Z)" |> test_expr
end

@testitem "Macros " begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "macro m end" |> test_expr
    @test "macro m() end" |> test_expr
    @test "macro m() a end" |> test_expr
    @test "@mac" |> test_expr
    @test "@mac a b c" |> test_expr
    @test "@mac f(5)" |> test_expr
    @test "(@mac x)" |> test_expr
    @test "Mod.@mac a b c" |> test_expr
    @test "[@mac a b]" |> test_expr
    @test "@inline get_chunks_id(i::Integer) = _div64(Int(i)-1)+1, _mod64(Int(i) -1)" |> test_expr
    @test "@inline f() = (), ()" |> test_expr
    @test "@sprintf(\"%08d\", id)" |> test_expr
    @test "[@m @n a for a in A]" |> test_expr
    @test ":(@foo bar baz bat)" |> test_expr
    @test ":(@foo bar for i in j end)" |> test_expr
    @test "(@foo bar for i in j end)" |> test_expr
    @test "foo(@foo bar for i in j)" |> test_expr
    @test "foo.(@foo bar for i in j)" |> test_expr
    @test CSTParser.parse("@__DIR__\n\nx", true)[1].span == 8

    if VERSION >= v"1.8.0-"
        @test "M43018.@test43018() do; end" |> test_expr
        @test "@M43018.test43018() do; end" |> test_expr
    end
end

@testitem "Triple-quoted string" begin
    using CSTParser: remlineinfo!, valof
    include("../shared.jl")

    @test valof(CSTParser.parse("\"\"\" \" \"\"\"")) == " \" "
    @test valof(CSTParser.parse("\"\"\"a\"\"\"")) == "a"
    @test valof(CSTParser.parse("\"\"\"\"\"\"")) == ""
    @test valof(CSTParser.parse("\"\"\"\n\t \ta\n\n\t \tb\"\"\"")) == "a\n\nb"
    @test to_codeobject(CSTParser.parse("\"\"\"\ta\n\tb \$c\n\td\n\"\"\"")) == Expr(:string, "\ta\n\tb ", :c, "\n\td\n")
    @test to_codeobject(CSTParser.parse("\"\"\"\n\ta\n\tb \$c\n\td\n\"\"\"")) == Expr(:string, "\ta\n\tb ", :c, "\n\td\n")
    @test to_codeobject(CSTParser.parse("\"\"\"\n\ta\n\tb \$c\n\td\n\t\"\"\"")) == Expr(:string, "a\nb ", :c, "\nd\n")
    @test to_codeobject(CSTParser.parse("\"\"\"\n\t \ta\$(1+\n1)\n\t \tb\"\"\"")) == Expr(:string, "a", :(1 + 1), "\nb")
    ws = "                         "
    "\"\"\"\n$ws%rv = atomicrmw \$rmw \$lt* %0, \$lt %1 acq_rel\n$(ws)ret \$lt %rv\n$ws\"\"\"" |> test_expr
    ws1 = "        "
    ws2 = "    "
    "\"\"\"\n$(ws1)a\n$(ws1)b\n$(ws2)c\n$(ws2)d\n$(ws2)\"\"\"" |> test_expr
    "\"\"\"\n$(ws1)a\n\n$(ws1)b\n\n$(ws2)c\n\n$(ws2)d\n\n$(ws2)\"\"\"" |> test_expr
    @test "\"\"\"\n$(ws1)α\n$(ws1)β\n$(ws2)γ\n$(ws2)δ\n$(ws2)\"\"\"" |> test_expr
    @test "\"\"\"Float\$(bit)\"\"\"" |> test_expr
    @test headof(CSTParser.parse("\"\"\"abc\$(de)fg\"\"\"").args[3]) == :STRING
    @test headof(CSTParser.parse("\"\"\"abc(de)fg\"\"\"")) == :TRIPLESTRING
    @test "\"\"\"\n\t\"\"\"" |> test_expr # Change of behaviour from v1.5 -> v1.6
end

@testitem "raw strings with unicode" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test raw"""re = r"(\\"[^\\"]*\\")  (\d+) bytes α (\\"[^\\"]*\\")\\\\" """ |> test_expr
    @test raw"""re = r"(\\"[^\\"]*\\") ⋯ (\d+) bytes ⋯ (\\"[^\\"]*\\")" """ |> test_expr
end


@testitem "weird string edge cases" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    if VERSION > v"1.7-"
        @test """x = raw"a \$(asd)  sd\\\n  bsf\\\\leq\n\\\\leq" """ |> test_expr
        @test """x = "a \$(asd)  sd\\\n  bsf\\\\leq\n\\\\leq" """ |> test_expr
        @test """x = raw\"\"\"a \$(asd)  sd\\\n  bsf\\\\leq\n\\\\leq\"\"\" """ |> test_expr
        @test """x = \"\"\"a \$(asd)  sd\\\n  bsf\\\\leq\n\\\\leq\"\"\" """ |> test_expr
        @test """x = @naah \"\"\"a \$(asd)  sd\\\n  bsf\\\\leq\n\\\\leq\"\"\" """ |> test_expr
        @test """x = Foo.@naah \"\"\"a \$(asd)  sd\\\n  bsf\\\\leq\n\\\\leq\"\"\" """ |> test_expr
        @test """x = Foo.@naah_str \"\"\"a \$(asd)  sd\\\n  bsf\\\\leq\n\\\\leq\"\"\" """ |> test_expr
        @test """x = Foo.naah\"\"\"a \$(asd)  sd\\\n  bsf\\\\leq\n\\\\leq\"\"\" """ |> test_expr
        @test """\"\"\"a \$(asd)  sd\\\n  bsf\\\\leq\n\\\\leq\"\"\"\nfoo""" |> test_expr
        @test """throw(ArgumentError("invalid \$(m == 2 ? "hex (\\\\x)" :
        "unicode (\\\$u)") escape sequence"))""" |> test_expr
        @test "\"a\\\\\\\\\\\nb\"" |> test_expr
        for c in 0:20
            @test test_expr(string("\"a", '\\'^c, "\nb\""))
            @test test_expr(string("\"\"\"a", '\\'^c, "\nb\"\"\""))
        end
        for c in 0:20
            @test test_expr(string("`a", '\\'^c, "\nb`"))
            @test test_expr(string("```a", '\\'^c, "\nb```"))
        end

        @test "\"\"\"\n    a\\\n  b\"\"\"" |> test_expr
        @test "\"\"\"\n        a\\\n  b\"\"\"" |> test_expr
        @test "\"\"\"\na\\\n  b\"\"\"" |> test_expr
        @test "\"\"\"\na\\\nb\"\"\"" |> test_expr
        @test "\"\"\"\n   a\\\n       b\"\"\"" |> test_expr
    end
end

@testitem "No longer broken things" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "[ V[j][i]::T for i=1:length(V[1]), j=1:length(V) ]" |> test_expr
    @test "all(d ≥ 0 for d in B.dims)" |> test_expr
    @test ":(=)" |> test_expr
    @test ":(1)" |> test_expr
    @test ":(a)" |> test_expr
    @test "(@_inline_meta(); f(x))" |> test_expr
    @test "isa(a,b) != c" |> test_expr
    @test "isa(a,a) != isa(a,a)" |> test_expr
    @test "@mac return x" |> test_expr
    @static if VERSION > v"1.1-"
        @test headof(CSTParser.parse("a,b,").trivia[2]) === :errortoken
    else
        @test "a,b," |> test_expr
    end
    @test "m!=m" |> test_expr
    @test "+(x...)" |> test_expr
    @test "+(promote(x,y)...)" |> test_expr
    @test "\$(x...)" |> test_expr
    @test "ccall(:gethostname, stdcall, Int32, ())" |> test_expr
    @test "@inbounds @ncall a b c" |> test_expr
    @test "(a+b)``" |> test_expr
    @test "(-, ~)" |> test_expr
    @test """function +(x::Bool, y::T)::promote_type(Bool,T) where T<:AbstractFloat
            return ifelse(x, oneunit(y) + y, y)
        end""" |> test_expr
    @test """finalizer(x,x::GClosure->begin
                ccall((:g_closure_unref,Gtk.GLib.libgobject),Void,(Ptr{GClosure},),x.handle)
            end)""" |> test_expr
    @test "function \$A end" |> test_expr
    @test "&ctx->exe_ctx_ref" |> test_expr
    @test ":(\$(docstr).\$(TEMP_SYM)[\$(key)])" |> test_expr
    @test "SpecialFunctions.\$(fsym)(n::Dual)" |> test_expr
    @test "(Base.@_pure_meta;)" |> test_expr
    @test "@M a b->(@N c = @O d e f->g)" |> test_expr
    @test "! = f" |> test_expr
    @test "[a=>1, b=>2]" |> test_expr
    @test "a.\$(b)" |> test_expr
    @test "a.\$f()" |> test_expr
    @test "4x/y" |> test_expr
    @test """
    ccall(:jl_finalize_th, Void, (Ptr{Void}, Any,),
            Core.getptls(), o)
    """ |> test_expr
    @test """
    A[if n == d
    i
    else
    (indices(A,n) for n = 1:nd)
    end...]
    """ |> test_expr
    @test """
    @spawnat(p,
    let m = a
        isa(m, Exception) ? m : nothing
    end)
    """ |> test_expr #
    @test "[@spawn f(R, first(c), last(c)) for c in splitrange(length(R), nworkers())]" |> test_expr
    @test "M.:(a)" |> test_expr
    @test """
        begin
            for i in I for j in J
                if cond
                    a
                end
            end end
        end""" |> test_expr
    @test "-f.(a.b + c)" |> test_expr
    @test ":(import Base: @doc)" |> test_expr
    @test "[a for a in A for b in B]" |> test_expr
    @test "+(a,b,c...)" |> test_expr
    @test """@testset a for t in T
    t
    end""" |> test_expr
    @test "import Base.==" |> test_expr
    @test "a`text`" |> test_expr
    @test "a``" |> test_expr
    @test "a`text`b" |> test_expr
    @test "[a; a 0]" |> test_expr
    @test "[a, b; c]" |> test_expr
    @test "t{a; b} " |> test_expr
    @test "a ~ b + c -d" |> test_expr
    @test "y[j=1:10,k=3:2:9; isodd(j+k) && k <= 8]" |> test_expr
    @test "(8=>32.0, 12=>33.1, 6=>18.2)" |> test_expr
    @test "(a,b = c,d)" |> test_expr
    @test "[ -1 -2;]" |> test_expr
    @test "-2y" |> test_expr # precedence
    @test "'''" |> test_expr # tokenize
    @test """
    if j+k <= deg +1
    end
    """ |> test_expr
    @test "function f() ::T end" |> test_expr # ws closer
    if VERSION > v"1.10-"
        # import Base: .+ is no longer valid with Julia 1.10
        @test "import Base: +, -" |> test_expr
    else
        @test "import Base: +, -, .+, .-" |> test_expr
    end
    if VERSION > v"1.6-"
        @test "import Base.:+" |> test_expr
        @test "import Base.:⋅" |> test_expr
        @test "import Base.:sin, Base.:-" |> test_expr
    end
    @test "[a +   + l]" |> test_expr # ws closer
    @test "@inbounds C[i,j] = - α[i] * αjc" |> test_expr
    @test "@inbounds C[i,j] = - n * p[i] * pj" |> test_expr
    @test """
    if ! a
        b
    end
    """ |> test_expr # ws closer
    @test "[:-\n:+]" |> test_expr
    @test "::a::b" |> test_expr
    @test "-[1:nc]" |> test_expr
    @test "@assert .!(isna(res[2]))" |> test_expr # v0.6
    @test "-((attr.rise / PANGO_SCALE)pt).value" |> test_expr
    @test "!(a = b)" |> test_expr
    @test "-(1)a" |> test_expr
    @test "!(a)::T" |> test_expr
    @test "a::b where T<:S" |> test_expr
    @test "+(x::Bool, y::T)::promote_type(Bool,T) where T<:AbstractFloat" |> test_expr
    @test "T where V<:(T where T)" |> test_expr
    @test "function ^(z::Complex{T}, p::Complex{T})::Complex{T} where T<:AbstractFloat end" |> test_expr
    @test "function +(a) where T where S end" |> test_expr
    @test "function -(x::Rational{T}) where T<:Signed end" |> test_expr
    @test "\$(a)(b)" |> test_expr
    @test "if !(a) break end" |> test_expr
    @test "module a() end" |> test_expr
    if VERSION > v"1.3-"
        @test """module var"#43932#" end""" |> test_expr
    end
    @test "M.r\"str\" " |> test_expr
    @test "f(a for a in A if cond)" |> test_expr
    @test "\"dimension \$d is not 1 ≤ \$d ≤ \$nd\" " |> test_expr
    @test "-(-x)^1" |> test_expr
    @test """
    "\\\\\$ch"
    """ |> test_expr
    @test "µs" |> test_expr # normalize unicode
    if VERSION >= v"1.10-"
        @test "ℏħ" |> test_expr # normalize unicode
    end
    @test """
    (x, o; p = 1) -> begin
        return o, p
    end
    """ |> test_expr # normalize unicode
    @test """
    (x, o...; p...) -> begin
        return o, p
    end
    """ |> test_expr # normalize unicode
    @test "function func() where {A where T} x + 1 end" |> test_expr # nested where
    @test "(;x)" |> test_expr # issue 39
    @test """
    let f = ((; a = 1, b = 2) -> ()),
        m = first(methods(f))
        @test DSE.keywords(f, m) == [:a, :b]
    end
    """ |> test_expr
    @test "-1^a" |> test_expr
    @test "function(f, args...; kw...) end" |> test_expr
    @test "function(f, args...=1; kw...) end" |> test_expr
    @test "2a * b" |> test_expr
    @test "(g1090(x::T)::T) where {T} = x+1.0" |> test_expr
    @test "(:) = Colon()" |> test_expr
    @test "a + in[1]" |> test_expr
    @test "function f(ex) +a end" |> test_expr
    @test "x`\\\\`" |> test_expr
    @test "x\"\\\\\"" |> test_expr
    @test "x\"\\\\ \"" |> test_expr
    @test "a.{1}" |> test_expr
    @test "@~" |> test_expr
    @test "\$\$(x)" |> test_expr
    @test "\$\$(x)" |> test_expr
    @test CSTParser.headof(CSTParser.parse("=")) === :errortoken
    @test CSTParser.headof(CSTParser.parse("~")) === :OPERATOR
    @test "(1:\n2)" |> test_expr
    @test "a[: ]" |> test_expr
    @test ".~b" |> test_expr
    if VERSION > v"1.1-"
        @test "a .~ b" |> test_expr
    end
    @test "A[a~b]" |> test_expr
    @test "[a~b]" |> test_expr
    if VERSION >= v"1.6"
        @test "[a ~b]" |> test_expr
    end
    @test "[a ~ b]" |> test_expr
    @test "[a~ b]" |> test_expr
    @test "1 .< 2 .< 3" |> test_expr
    @test "(;)" |> test_expr
    if VERSION > v"1.5"
        @test "@M{a}-b" |> test_expr
        @test "@M{a,b}-b" |> test_expr
    end
    @test "@M[a]-b" |> test_expr
end

@testitem "interpolation error catching" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    x = CSTParser.parse("\"a \$ b\"")
    @test x.fullspan == 7
    @test CSTParser.headof(x[3]) === :errortoken
    x = CSTParser.parse("\"a \$# b\"")
    @test x.fullspan == 8
    @test CSTParser.headof(x[3]) === :errortoken
end



@testitem "string interpolation" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    if VERSION >= v"1.6"
        @test test_expr(raw""""$("asd")" """)
        @test test_expr(raw""""$("asd")a" """)
        @test test_expr(raw""""a$("asd")" """)
        @test test_expr(raw""""a$("asd")a" """)
        @test test_expr(raw"""`$("asd")` """)
        @test test_expr(raw"""`$("asd")a` """)
        @test test_expr(raw"""`a$("asd")` """)
        @test test_expr(raw"""`a$("asd")a` """)
    end
end
@testitem "string whitespace handling" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    if VERSION >= v"1.6"
        @test test_expr("""\"\"\"\n\\t\"\"\" """)
        @test test_expr("""\"\"\"\n\\t\n\"\"\" """)
        @test test_expr("""\"\"\"\n\\t\\n\"\"\" """)
        @test test_expr(raw"""\"\"\"\n\\t\"\"\" """)
        @test test_expr(raw"""\"\"\"\n\\t\n\"\"\" """)
        @test test_expr(raw"""\"\"\"\n\\t\\n\"\"\" """)
    end
end

@testitem "cmd interpolation" begin
    using CSTParser: remlineinfo!, valof
    include("../shared.jl")

    @test test_expr("`a \$b c`")
    @test test_expr(raw"`a \"\$b $b\" c`")
    @test test_expr("`a b c`")
    x = CSTParser.parse("`a \$b c`")
    @test x.args[1].head == :globalrefcmd
    @test x.args[3].head == :string
    @test valof(x.args[3].args[1]) == "a "
    @test valof(x.args[3].args[2]) == "b"
    @test valof(x.args[3].args[3]) == " c"
end

@testitem "multiple ; in kwargs" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("f(a; b=1; c=2)")
    @test test_expr("f(a; b=1; c=2) = 2")
    @test test_expr("f( ; b=1; c=2)")
    @test test_expr("f(a; b=1; c=2)")
    @test test_expr("f(a; b=1, c=2; d=3)")
    @test test_expr("f(a; b=1; c=2, d=3)")
    @test test_expr("f(a; b=1; c=2; d=3)")
end

@testitem "Broken things" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test_broken "\$(a) * -\$(b)" |> test_expr_broken
end

# test_fsig_decl(str) = (x->x.id).(CSTParser._get_fsig(CSTParser.parse(str)).defs)
# @testitem "func-sig variable declarations" begin
#     @test test_fsig_decl("f(x) = x") == [:x]
#     @test test_fsig_decl("""function f(x)
#         x
#     end""") == [:x]

#     @test test_fsig_decl("f{T}(x::T) = x") == [:T, :x]
#     @test test_fsig_decl("""function f{T}(x::T)
#         x
#     end""") == [:T, :x]

#     @test test_fsig_decl("f(x::T) where T = x") == [:T, :x]
#     @test test_fsig_decl("""function f(x::T) where T
#         x
#     end""") == [:T, :x]


#     @test test_fsig_decl("f(x::T{S}) where T where S = x") == [:T, :S, :x]
#     @test test_fsig_decl("""function f(x::T{S}) where T where S
#         x
#     end""") == [:T, :S, :x]
# end

@testitem "Spans" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    CSTParser.parse(raw"""
    "ABC$(T)"
    """).fullspan >= 9
    CSTParser.parse("\"_\"").fullspan == 3
    CSTParser.parse("T.mutable && print(\"Ok\")").fullspan == 24
    CSTParser.parse("(\"\$T\")").fullspan == 6
    CSTParser.parse("\"\"\"\$T is not supported\"\"\"").fullspan == 25
    CSTParser.parse("using Compat: @compat\n").fullspan == 22
    CSTParser.parse("primitive = 1").fullspan == 13
end

@testitem "Command or string with unicode" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "```αhelloworldω```" |> test_expr
    @test "\"αhelloworldω\"" |> test_expr
end

@testitem "conversion of floats with underscore" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "30.424_876_125_859_513" |> test_expr
end

@testitem "errors" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test headof(CSTParser.parse("1? b : c ").args[1]) === :errortoken
    @test headof(CSTParser.parse("1 ?b : c ").trivia[1]) === :errortoken
    @test headof(CSTParser.parse("1 ? b :c ").trivia[2]) === :errortoken
    @test headof(CSTParser.parse("1:\n2").args[1]) === :errortoken
    @test headof(CSTParser.parse("1.a").args[2]) === :errortoken
    @test headof(CSTParser.parse("f ()")) === :errortoken
    @test headof(CSTParser.parse("f{t} ()")) === :errortoken
    @test headof(CSTParser.parse(": a").trivia[1]) === :errortoken
    @test headof(CSTParser.parse("const a").args[1]) === :errortoken
end

@testitem "colons" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("(if true I elseif false J else : end for i in 1:5)")
    @test test_expr("if true; : end")
    @test test_expr("a + :")
end

@testitem "tuple params" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "1,2,3" |> test_expr
    @test "1;2,3" |> test_expr
    @test "1,2;3" |> test_expr
    @test "(1,2,3)" |> test_expr
    @test "(1;2,3)" |> test_expr
    @test "(1,2;3)" |> test_expr
    @test "f(;)" |> test_expr
end

@testitem "docs" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "\"doc\"\nT" |> test_expr
    @test "@doc \"doc\" T" |> test_expr
    @test "@doc \"doc\"\nT" |> test_expr
    @test "@doc \"doc\n\n\n\"\nT" |> test_expr
    @test "begin\n@doc \"doc\"\n\nT\nend" |> test_expr
    @test "begin\n@doc \"doc\"\nT\nend" |> test_expr
    @test "begin\n@doc \"doc\" T\nend" |> test_expr
    @test "if true\n@doc \"doc\"\n\nT\nend" |> test_expr
    @test "if true\n@doc \"doc\"\nT\nend" |> test_expr
    @test "if true\n@doc \"doc\" T\nend" |> test_expr
    @test "@doc \"I am a module\" ModuleMacroDoc" |> test_expr
    @test """
    @doc(foo)
    """ |> test_expr
    @test """
    @doc foo
    """ |> test_expr
end

@testitem "braces" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "{a}" |> test_expr
    @test "{a, b}" |> test_expr
    @test "{a, b; c}" |> test_expr
    @test "{a, b; c = 1}" |> test_expr
    @test "{a b}" |> test_expr
    @test "{a b; c}" |> test_expr
    @test "{a b; c = 1}" |> test_expr
end

@testitem "import preceding dot whitespace" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "using . M" |> test_expr
    @test "using .. M" |> test_expr
    @test "using ... M" |> test_expr
end

@testitem "issue #116" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test """
    function foo() where {A <:B}
    body
    end""" |> test_expr

    @test """
    function foo() where {A <: B}
    body
    end""" |> test_expr
end

@testitem "issue #165" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    x = CSTParser.parse("""
    a ? b
    function f end""")
    @test length(x) == 5 # make sure we always give out an EXPR of the right length
    @test headof(x.args[3]) === :errortoken
end

@testitem "issue #182" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    x = CSTParser.parse("""
    quote
        \"\"\"
        txt
        \"\"\"
        sym
    end""")
    @test x.args[1].args[1].args[1].head === :globalrefdoc
end

@testitem "issue #198" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    if VERSION > v"1.3.0-"
        @test test_expr(":var\"id\"")
    end
end
@testitem "vscode issue #1632" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("\"\$( a)\"")
    @test test_expr("\"\$(#=comment=# a)\"")
end
@testitem "issue #210" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("function f(a; where = false) end")
end

@testitem "suffixed ops" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("a +₊ b *₊ c")
    @test test_expr("a *₊ b +₊ c")
end


@testitem "import .. as .. syntax" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @static if VERSION > v"1.6-"
        @test test_expr("import a as b")
        @test test_expr("import a as b, c")
        @test test_expr("import M: a as b")
        @test test_expr("import M: a as b, c")
        @test CSTParser.parse("using a as b")[2].head === :errortoken
        @test test_expr("using M: a as b")
        @test test_expr("using M: a as b, c")
        @test test_expr(raw":(import $foo as $bar)")
    end
end
@testitem "exor #201" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr(raw"$return(x)")
end



@testitem "@var #236" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    if VERSION > v"1.3.0-"
        s = raw"""@var" " a"""
        @test test_expr(s)
        @test CSTParser.ismacroname(CSTParser.parse(s).args[1])
    end
end

@testitem "nonstandard identifier (var\"blah\") parsing" begin
using CSTParser: remlineinfo!
    include("../shared.jl")

    if VERSION > v"1.3.0-"
        @test """var"asd" """ |> test_expr
        @test """var"#asd" """ |> test_expr
        @test """var"#asd#" """ |> test_expr
        @test """M.var"asd" """ |> test_expr
        @test """M.var"#asd" """ |> test_expr
        @test """M.var"#asd#" """ |> test_expr
    end
end
@testitem "bad uint" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test to_codeobject(CSTParser.parse("0x.")) == Expr(:error)
end

@testitem "endswithtrivia" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    x = CSTParser.parse("\"some long title \$label1 \$label2\" \na")
    @test x[3].span < x[3].fullspan
    @test CSTParser.lastchildistrivia(x[3])
end

@testitem "bad interp with following newline" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    s = "\"\"\"\$()\n\"\"\""
    x = CSTParser.parse(s)
    @test sizeof(s) == x.fullspan
end

@testitem "minimal_reparse" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    s0 = """
    testsettravx=nothing;
        ) fx;ifxend)
            # parsing works?"""
    s1 = """
    testsettravx=nothing;
        ) ;ifxend)
            # parsing works?"""
    x0 = CSTParser.parse(s0, true)
    x1 = CSTParser.parse(s1, true)
    x2 = CSTParser.minimal_reparse(s0, s1, x0, x1)
    @test CSTParser.comp(x1, x2)
end

@testitem "primes" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("""
    f() do x
        end'
    """)
    @test CSTParser.has_error(cst"begin end'")
    @test !CSTParser.has_error(cst"[]'")
    @test !CSTParser.has_error(cst"'a''")
    @test test_expr("(a)'")
    @test test_expr("a.a'")
    if VERSION >= v"1.6"
        @test test_expr("a'ᵀ")
        @test test_expr(":(a'ᵀ)")
    end
    @test test_expr("a'")
    @test test_expr("a''")
    @test test_expr("a'''")
    # @test test_expr(":.'")
    # @test test_expr(":?'")
    # @test test_expr(":a'")
end

@testitem "end as id juxt" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("a[1end]")
    if VERSION >= v"1.4"
        @test test_expr("a[2begin:1end]")
    end
end

@testitem "last child is trivia for :string" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test !CSTParser.lastchildistrivia(cst"""("a $(A) a"  )"""[2])
end

@testitem "toplevel strings" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr(""""a" in b && c""")
end

@testitem "@doc cont" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("module a\n@doc doc\"\"\"doc\"\"\"\nx\nend")
end

@testitem "char escape" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr(raw"'\$'")
    @test test_expr(raw"'\a'")
    @test test_expr(raw"'\3'")
    @test test_expr(raw"'\000'")
    @test test_expr(raw"'\033'")
    @test test_expr(raw"'\177'")
    @test test_expr(raw"'\u222'")
    @test test_expr(raw"'\ufff'")
    @test test_expr(raw"'\x2'")
    @test test_expr(raw"'\x22'")
    @test test_expr(raw"'\u22'")
    @test test_expr(raw"'\u2222'")
    @test test_expr(raw"'\U2222'")
    @test test_expr(raw"'\U22222'")
    @test test_expr(raw"'\U00000001'")
    if VERSION > v"1.9-"
        @test test_expr(raw"'\xff'")
        @test test_expr(raw"'\xc0\x80'")
    end

    @test CSTParser.parse(raw"'\200'").head == :errortoken
    @test CSTParser.parse(raw"'\300'").head == :errortoken
    @test CSTParser.parse(raw"'\377'").head == :errortoken
    @test CSTParser.parse(raw"'\600'").head == :errortoken
    @test CSTParser.parse(raw"'\777'").head == :errortoken
    @test CSTParser.parse(raw"'\x222'").head == :errortoken
    @test CSTParser.parse(raw"'\u22222'").head == :errortoken
    @test CSTParser.parse(raw"'\U222222'").head == :errortoken
    @test CSTParser.parse(raw"'\asdd'").head == :errortoken
    @test CSTParser.parse(raw"'\α'").head == :errortoken
    @test CSTParser.parse(raw"'\αsdd'").head == :errortoken
    @test CSTParser.parse(raw"'\u222ää'").head == :errortoken
    @test CSTParser.parse(raw"'\x222ää'").head == :errortoken
    @test CSTParser.parse(raw"'\U222ää'").head == :errortoken
    @test CSTParser.parse(raw"'\U10000001'").head == :errortoken
    for c in rand(Char, 1000)
        c == '\\' && continue
        @test test_expr(string("'", c, "'"))
    end
end

@testitem "invalid char in string" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test CSTParser.parse(raw"\"\U222222222\"").head == :errortoken
end

@testitem "string macros" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr(raw"""test"asd"asd""")
    @test test_expr(raw"""Mod.test"asd"asd""")
    if VERSION >= v"1.6"
        @test test_expr(raw"""test"asd"0""")
        @test test_expr(raw"""test"asd"0o0""")
        @test test_expr(raw"""test"asd"0x0""")
        @test test_expr(raw"""test"asd"0.0""")
    end
    # this regressed in JuliaSyntax: https://github.com/JuliaLang/JuliaSyntax.jl/issues/401
    if VERSION <= v"1.10-"
        @test test_expr(raw"""test"asd"true""")
        @test test_expr(raw"""test""true""")
    end
end

@testitem "number parsing" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("0b00000000")
    @test test_expr("0b000000000")
    @test test_expr("0b0000000000000000")
    @test test_expr("0b00000000000000000")
    @test test_expr("0b00000000000000000000000000000000")
    @test test_expr("0b000000000000000000000000000000000")
    @test test_expr("0b0000000000000000000000000000000000000000000000000000000000000000")
    @test test_expr("0b00000000000000000000000000000000000000000000000000000000000000000")
    @test test_expr("0b00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000")
    if VERSION >= v"1.6"
        @test test_expr("0b000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000")
    end
    @test test_expr("0b11111111")
    @test test_expr("0b111111111")
    @test test_expr("0b1111111111111111")
    @test test_expr("0b11111111111111111")
    @test test_expr("0b11111111111111111111111111111111")
    @test test_expr("0b111111111111111111111111111111111")
    @test test_expr("0b1111111111111111111111111111111111111111111111111111111111111111")
    @test test_expr("0b11111111111111111111111111111111111111111111111111111111111111111")
    @test test_expr("0b11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111")
    if VERSION >= v"1.6"
        @test test_expr("0b111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111")
    end

    @test test_expr("0o0")
    @test test_expr("0o00")
    @test test_expr("0o0000")
    @test test_expr("0o00000")
    @test test_expr("0o000000000")
    @test test_expr("0o0000000000")
    @test test_expr("0o00000000000000000000")
    @test test_expr("0o000000000000000000000")
    @test test_expr("0o00000000000000000000000000000000000000000")
    @test test_expr("0o0000000000000000000000000000000000000000000")
    @test test_expr("0o1")
    @test test_expr("0o11")
    @test test_expr("0o1111")
    @test test_expr("0o11111")
    @test test_expr("0o111111111")
    @test test_expr("0o1111111111")
    @test test_expr("0o11111111111111111111")
    @test test_expr("0o111111111111111111111")
    @test test_expr("0o11111111111111111111111111111111111111111")
    @test test_expr("0o111111111111111111111111111111111111111111")
    @test test_expr("0o377777777777777777777777777777777777777777")
    @test test_expr("0o1111111111111111111111111111111111111111111")
    @test test_expr("0o077")
    @test test_expr("0o377")
    @test test_expr("0o400")
    @test test_expr("0o077777")
    @test test_expr("0o177777")
    @test test_expr("0o200000")
    @test test_expr("0o00000000000")
    @test test_expr("0o17777777777")
    @test test_expr("0o40000000000")
    @test test_expr("0o0000000000000000000000")
    @test test_expr("0o1000000000000000000000")
    @test test_expr("0o2000000000000000000000")
    @test test_expr("0o0000000000000000000000000000000000000000000")
    @test test_expr("0o1000000000000000000000000000000000000000000")
    @test test_expr("0o2000000000000000000000000000000000000000000")

    @test test_expr("0x00")
    @test test_expr("0x000")
    @test test_expr("0x0000")
    @test test_expr("0x00000")
    @test test_expr("0x00000000")
    @test test_expr("0x000000000")
    @test test_expr("0x0000000000000000")
    @test test_expr("0x00000000000000000")
    @test test_expr("0x00000000000000000000000000000000")
    if VERSION >= v"1.6"
        @test test_expr("0x000000000000000000000000000000000")
    end

    @test test_expr("0x11")
    @test test_expr("0x111")
    @test test_expr("0x1111")
    @test test_expr("0x11111")
    @test test_expr("0x11111111")
    @test test_expr("0x111111111")
    @test test_expr("0x1111111111111111")
    @test test_expr("0x11111111111111111")
    @test test_expr("0x11111111111111111111111111111111")
    if VERSION >= v"1.6"
        @test test_expr("0x111111111111111111111111111111111")
    end
end

@testitem "#302" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    str = """
    const _examples = PlotExample[
    PlotExample( # 1
        "Lines",
        "A simple line plot of the columns.",
        [:(
            begin
                plot(Plots.fakedata(50, 5), w = 3)
            end
        )],
    ),
    ]
    """
    @test test_expr(str)
    x, ps = CSTParser.parse(CSTParser.ParseState(str), true)
    @test ps.errored == false
end

@testitem "#304" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    str = """
    const _examples = PlotExample[
        PlotExample( # 40
            "Lens",
            "A lens lets you easily magnify a region of a plot. x and y coordinates refer to the to be magnified region and the via the `inset` keyword the subplot index and the bounding box (in relative coordinates) of the inset plot with the magnified plot can be specified. Additional attributes count for the inset plot.",
            [
                quote
                    begin
                        plot(
                            [(0, 0), (0, 0.9), (1, 0.9), (2, 1), (3, 0.9), (80, 0)],
                            legend = :outertopright,
                        )
                        plot!([(0, 0), (0, 0.9), (2, 0.9), (3, 1), (4, 0.9), (80, 0)])
                        plot!([(0, 0), (0, 0.9), (3, 0.9), (4, 1), (5, 0.9), (80, 0)])
                        plot!([(0, 0), (0, 0.9), (4, 0.9), (5, 1), (6, 0.9), (80, 0)])
                        lens!(
                            [1, 6],
                            [0.9, 1.1],
                            inset = (1, bbox(0.5, 0.0, 0.4, 0.4)),
                        )
                    end
                end,
            ],
        ),
    ]
    """
    @test test_expr(str)
    x, ps = CSTParser.parse(CSTParser.ParseState(str), true)
    @test ps.errored == false
end

@testitem "#310" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    x, ps = CSTParser.parse(CSTParser.ParseState("""import a.notvar"papa" """), true)
    @test ps.errored == true
    x, ps = CSTParser.parse(CSTParser.ParseState("""import notvar"papa" """), true)
    @test ps.errored == true
end

@testitem "#311" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr(raw"import a.$b.c")
end

@testitem "kw interpolation" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr(raw""""foo $bar" """)
    @test test_expr(raw""""foo $type" """)
    @test test_expr(raw""""foo $function" """)
    @test test_expr(raw""""foo $begin" """)
    @test test_expr(raw""""foo $quote" """)
end

@testitem "broadcasted && and ||" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    if VERSION > v"1.7-"
        @test test_expr(raw"""a .&& b""")
        @test test_expr(raw"""a .< b .&& b .> a""")
        @test test_expr(raw"""a .|| b""")
        @test test_expr(raw"""a .< b .|| b .> a""")
    end
end


@testitem "normalized unicode ops" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    if VERSION > v"1.7-"
        @test "(·) == (·) == (⋅) == 5" |> test_expr
        @test "(−) == (-) == 6" |> test_expr
    end
end

@testitem "pair tuple" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("a => b")
    @test test_expr("a => b, c, d")
    @test test_expr("a, a => b, c, d")
end

@testitem "global" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("global a")
    @test test_expr("global a = 1")
    @test test_expr("global a = 1, b")
    @test test_expr("global a, b")
    @test test_expr("global a, b = 2")
end

@testitem "dollar quote with prime" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test raw":($a'+2')" |> test_expr
    @test raw":($(a)'+2')" |> test_expr
    @test raw":($a')" |> test_expr
    @test raw":($(a)')" |> test_expr
end

# Terminals
function julia_normalization_map(c::Int32, x::Ptr{Nothing})::Int32
    return c == 0x025B ? 0x03B5 : # latin small letter open e -> greek small letter epsilon
           c == 0x00B5 ? 0x03BC : # micro sign -> greek small letter mu
           c == 0x00B7 ? 0x22C5 : # middot char -> dot operator (#25098)
           c == 0x0387 ? 0x22C5 : # Greek interpunct -> dot operator (#25098)
           c == 0x2212 ? 0x002D : # minus -> hyphen-minus (#26193)
           c == 0x210F ? 0x0127 : # hbar -> small letter h with stroke (#48870)
           c
end

# Note: This code should be in julia base
function utf8proc_map_custom(str::String, options)
    norm_func = @cfunction julia_normalization_map Int32 (Int32, Ptr{Nothing})
    nwords = ccall(:utf8proc_decompose_custom, Int, (Ptr{UInt8}, Int, Ptr{UInt8}, Int, Cint, Ptr{Nothing}, Ptr{Nothing}),
                   str, sizeof(str), C_NULL, 0, options, norm_func, C_NULL)
    nwords < 0 && Base.Unicode.utf8proc_error(nwords)
    buffer = Base.StringVector(nwords * 4)
    nwords = ccall(:utf8proc_decompose_custom, Int, (Ptr{UInt8}, Int, Ptr{UInt8}, Int, Cint, Ptr{Nothing}, Ptr{Nothing}),
                   str, sizeof(str), buffer, nwords, options, norm_func, C_NULL)
    nwords < 0 && Base.Unicode.utf8proc_error(nwords)
    nbytes = ccall(:utf8proc_reencode, Int, (Ptr{UInt8}, Int, Cint), buffer, nwords, options)
    nbytes < 0 && Base.Unicode.utf8proc_error(nbytes)
    return String(resize!(buffer, nbytes))
end

function normalize_julia_identifier(str::AbstractString)
    options = Base.Unicode.UTF8PROC_STABLE | Base.Unicode.UTF8PROC_COMPOSE
    utf8proc_map_custom(String(str), options)
end


function sized_uint_literal(s::AbstractString, b::Integer)
    # We know integers are all ASCII, so we can use sizeof to compute
    # the length of ths string more quickly
    l = (sizeof(s) - 2) * b
    l <= 8   && return Base.parse(UInt8,   s)
    l <= 16  && return Base.parse(UInt16,  s)
    l <= 32  && return Base.parse(UInt32,  s)
    l <= 64  && return Base.parse(UInt64,  s)
    # l <= 128 && return Base.parse(UInt128, s)
    if l <= 128
        @static if VERSION >= v"1.1"
            return Expr(:macrocall, GlobalRef(Core, Symbol("@uint128_str")), nothing, s)
        else
            return Expr(:macrocall, Symbol("@uint128_str"), nothing, s)
        end
    end
    return Expr(:macrocall, GlobalRef(Core, Symbol("@big_str")), nothing, s)
end

function sized_uint_oct_literal(s::AbstractString)
    s[3] == 0 && return sized_uint_literal(s, 3)
    len = sizeof(s)
    (len < 5  || (len == 5  && s <= "0o377")) && return Base.parse(UInt8, s)
    (len < 8  || (len == 8  && s <= "0o177777")) && return Base.parse(UInt16, s)
    (len < 13 || (len == 13 && s <= "0o37777777777")) && return Base.parse(UInt32, s)
    (len < 24 || (len == 24 && s <= "0o1777777777777777777777")) && return Base.parse(UInt64, s)
    # (len < 45 || (len == 45 && s <= "0o3777777777777777777777777777777777777777777")) && return Base.parse(UInt128, s)
    # return Base.parse(BigInt, s)
    if (len < 45 || (len == 45 && s <= "0o3777777777777777777777777777777777777777777"))
        @static if VERSION >= v"1.1"
            return Expr(:macrocall, GlobalRef(Core, Symbol("@uint128_str")), nothing, s)
        else
            return Expr(:macrocall, Symbol("@uint128_str"), nothing, s)
        end
    end
    return Meta.parse(s)
end

function _literal_expr(x)
    if headof(x) === :TRUE
        return true
    elseif headof(x) === :FALSE
        return false
    elseif is_nothing(x)
        return nothing
    elseif headof(x) === :INTEGER || headof(x) === :BININT || headof(x) === :HEXINT || headof(x) === :OCTINT
        return Expr_int(x)
    elseif isfloat(x)
        return Expr_float(x)
    elseif ischar(x)
        return Expr_char(x)
    elseif headof(x) === :MACRO
        return Symbol(valof(x))
    elseif headof(x) === :STRING || headof(x) === :TRIPLESTRING
        return valof(x)
    elseif headof(x) === :CMD
        return Expr_cmd(x)
    elseif headof(x) === :TRIPLECMD
        return Expr_tcmd(x)
    end
end

const TYPEMAX_INT64_STR = string(typemax(Int))
const TYPEMAX_INT128_STR = string(typemax(Int128))
function Expr_int(x)
    is_hex = is_oct = is_bin = false
    val = replace(valof(x), "_" => "")
    if sizeof(val) > 2 && val[1] == '0'
        c = val[2]
        c == 'x' && (is_hex = true)
        c == 'o' && (is_oct = true)
        c == 'b' && (is_bin = true)
    end
    is_hex && return sized_uint_literal(val, 4)
    is_oct && return sized_uint_oct_literal(val)
    is_bin && return sized_uint_literal(val, 1)
    # sizeof(val) <= sizeof(TYPEMAX_INT64_STR) && return Base.parse(Int64, val)
    return Meta.parse(val)
    # # val < TYPEMAX_INT64_STR && return Base.parse(Int64, val)
    # sizeof(val) <= sizeof(TYPEMAX_INTval < TYPEMAX_INT128_STR128_STR) && return Base.parse(Int128, val)
    # # val < TYPEMAX_INT128_STR && return Base.parse(Int128, val)
    # Base.parse(BigInt, val)
end

function Expr_float(x)
    if !startswith(valof(x), "0x") && 'f' in valof(x)
        return Base.parse(Float32, replace(replace(valof(x), 'f' => 'e'), '_' => ""))
    end
    Base.parse(Float64, replace(valof(x), "_" => ""))
end
function Expr_char(x)
    val = _unescape_string(valof(x)[2:prevind(valof(x), lastindex(valof(x)))])
    if VERSION < v"1.9-"
        # one byte e.g. '\xff' maybe not valid UTF-8
        # but we want to use the raw value as a codepoint in this case
        sizeof(val) == 1 && return Char(codeunit(val, 1))
    end
    length(val) == 1 || error("Invalid character literal: $(Vector{UInt8}(valof(x)))")
    val[1]
end


# Expressions
to_codeobject(args...) = Expr(args...)

"""
    to_codeobject(x::EXPR)

Convert an `EXPR` into the object that `Meta.parse` would have produced from
the original string, which could e.g. be an `Expr`, `Symbol`, or literal.
"""
function to_codeobject(x::EXPR)
    if isidentifier(x)
        if headof(x) === :NONSTDIDENTIFIER
            if startswith(valof(x.args[1]), "@")
                Symbol("@", normalize_julia_identifier(valof(x.args[2])))
            else
                Symbol(normalize_julia_identifier(valof(x.args[2])))
            end
        else
            return Symbol(normalize_julia_identifier(valof(x)))
        end
    elseif iskeyword(x)
        if headof(x) === :BREAK
            return Expr(:break)
        elseif headof(x) === :CONTINUE
            return Expr(:continue)
        else
            return Symbol(lowercase(string(headof(x))))
        end
    elseif isoperator(x)
        return Symbol(normalize_julia_identifier(valof(x)))
    elseif ispunctuation(x)
        if headof(x) === :DOT
            if x.args === nothing
                return :(.)
            elseif length(x.args) == 1 && isoperator(x.args[1])
                return Expr(:(.), to_codeobject(x.args[1]))
            else
                Expr(:error)
            end
        else
            # We only reach this if we have a malformed expression.
            Expr(:error)
        end
    elseif isliteral(x)
        return _literal_expr(x)
    elseif isbracketed(x)
        return to_codeobject(x.args[1])
    elseif x.head isa EXPR
        Expr(to_codeobject(x.head), to_codeobject.(x.args)...)
    elseif x.head === :quotenode
        # quote nodes in import/using are unwrapped by the Julia parser
        if x.parent isa EXPR &&
            x.parent.parent isa EXPR &&
            is_dot(x.parent.head) &&
            x.parent.parent.head in (:import, :using)
            to_codeobject(x.args[1])
        else
            QuoteNode(to_codeobject(x.args[1]))
        end
    elseif x.head === :globalrefdoc
        GlobalRef(Core, Symbol("@doc"))
    elseif x.head === :globalrefcmd
        if VERSION >= v"1.1"
            GlobalRef(Core, Symbol("@cmd"))
        else
            Symbol("@cmd")
        end
    elseif x.head === :macrocall && is_getfield_w_quotenode(x.args[1]) && !ismacroname(x.args[1].args[2].args[1])
        # Shift '@' to the right
        valofrhs = valof(x.args[1].args[2].args[1])
        valofrhs = valofrhs === nothing ? "" : valofrhs
        new_name = Expr(:., remove_at(x.args[1].args[1]), QuoteNode(Symbol("@", valofrhs)))
        Expr(:macrocall, new_name, to_codeobject.(x.args[2:end])...)
    elseif x.head === :macrocall && isidentifier(x.args[1]) && valof(x.args[1]) == "@."
        Expr(:macrocall, Symbol("@__dot__"), to_codeobject.(x.args[2:end])...)
    elseif x.head === :macrocall && length(x.args) == 3 && x.args[1].head === :globalrefcmd && x.args[3].head == :string
        Expr(:macrocall, to_codeobject(x.args[1]), to_codeobject(x.args[2]), x.args[3].meta)
    elseif x.head === :string && length(x.args) > 0 && (x.args[1].head === :STRING || x.args[1].head === :TRIPLESTRING) && isempty(valof(x.args[1]))
        # Special conversion needed - the initial text section is treated as empty for the represented string following lowest-common-prefix adjustments, but exists in the source.
        Expr(:string, to_codeobject.(x.args[2:end])...)
    elseif x.args === nothing
        # for ncat/nrow etc
        int = tryparse(Int, String(x.head))
        int !== nothing && return int

        Expr(Symbol(lowercase(String(x.head))))
    elseif VERSION < v"1.7.0-DEV.1129" && x.head === :ncat
        dim = tryparse(Int, String(x.args[1].head))
        dim === nothing && return Expr(:error)
        head = dim == 1 ? :hcat : :vcat
        Expr(head, to_codeobject.(x.args[2:end])...)
    elseif x.head === :errortoken
        Expr(:error)
    else
        Expr(Symbol(lowercase(String(x.head))), to_codeobject.(x.args)...)
    end
end

function remove_at(x)
    if isidentifier(x) && valof(x) !== nothing && first(valof(x)) == '@'
        return Symbol(valof(x)[2:end])
    elseif is_getfield_w_quotenode(x)
        Expr(:., remove_at(x.args[1]), QuoteNode(remove_at(x.args[2].args[1])))
    else
        to_codeobject(x)
    end
end

# cross compatability for line number insertion in macrocalls
if VERSION > v"1.1-"
    Expr_cmd(x) = Expr(:macrocall, GlobalRef(Core, Symbol("@cmd")), nothing, valof(x))
    Expr_tcmd(x) = Expr(:macrocall, GlobalRef(Core, Symbol("@cmd")), nothing, valof(x))
else
    Expr_cmd(x) = Expr(:macrocall, Symbol("@cmd"), nothing, valof(x))
    Expr_tcmd(x) = Expr(:macrocall, Symbol("@cmd"), nothing, valof(x))
end


function clear_at!(x)
    if x isa Expr && x.head == :.
        if x.args[2] isa QuoteNode && string(x.args[2].value)[1] == '@'
            x.args[2].value = Symbol(string(x.args[2].value)[2:end])
        end
        if x.args[1] isa Symbol && string(x.args[1])[1] == '@'
            x.args[1] = Symbol(string(x.args[1])[2:end])
        else
            clear_at!(x.args[1])
        end
    end
end


"""
    remlineinfo!(x)
Removes line info expressions. (i.e. Expr(:line, 1))
"""
function remlineinfo!(x)
    if isa(x, Expr)
        if x.head == :macrocall && x.args[2] !== nothing
            id = findall(map(x -> (isa(x, Expr) && x.head == :line) || (@isdefined(LineNumberNode) && x isa LineNumberNode), x.args))
            deleteat!(x.args, id)
            for j in x.args
                remlineinfo!(j)
            end
            insert!(x.args, 2, nothing)
        else
            id = findall(map(x -> (isa(x, Expr) && x.head == :line) || (@isdefined(LineNumberNode) && x isa LineNumberNode), x.args))
            deleteat!(x.args, id)
            for j in x.args
                remlineinfo!(j)
            end
        end
        if x.head == :elseif && x.args[1] isa Expr && x.args[1].head == :block && length(x.args[1].args) == 1
            x.args[1] = x.args[1].args[1]
        end
    end
    x
end

const EmptyWS = Tokens.EMPTY_WS
const SemiColonWS = Tokens.SEMICOLON_WS
const NewLineWS = Tokens.NEWLINE_WS
const WS = Tokens.WS
const EmptyWSToken = RawToken(EmptyWS, (0, 0), (0, 0), -1, -1)

mutable struct Closer
    newline::Bool
    semicolon::Bool
    tuple::Bool
    comma::Bool
    paren::Bool
    brace::Bool
    inmacro::Bool
    insquare::Bool
    inref::Bool
    inwhere::Bool
    square::Bool
    block::Bool
    ifop::Bool
    range::Bool
    ws::Bool
    wsop::Bool
    unary::Bool
    for_generator::Bool
    precedence::Int
end
Closer() = Closer(true, true, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, -1)

function Base.show(io::IO, c::Closer)
    println(io, "Closer(")
    for f in fieldnames(Closer)
        println(io, "  ", f, " = ", getfield(c, f), ",")
    end
    print(io, ")")
end

const IOT = typeof(IOBuffer().data)
mutable struct ParseState
    l::Lexer{Base.GenericIOBuffer{IOT},RawToken}
    done::Bool # Remove this
    lt::RawToken
    t::RawToken
    nt::RawToken
    nnt::RawToken
    lws::RawToken
    ws::RawToken
    nws::RawToken
    nnws::RawToken
    closer::Closer
    errored::Bool
    flags::UInt64
end
function ParseState(str::Union{IOBuffer,String})
    ps = ParseState(tokenize(str, RawToken), false, RawToken(), RawToken(), RawToken(), RawToken(), RawToken(), RawToken(), RawToken(), RawToken(), Closer(), false, 0)
    return next(next(ps))
end

function ParseState(str::Union{IOBuffer,String}, loc::Int)
    ps = ParseState(str)
    prevpos = position(ps)
    while ps.nt.startbyte < loc
        next(ps)
        prevpos = loop_check(ps, prevpos)
    end
    return ps
end

module ParserFlags
    const AllowConstWithoutAssignment = 0x1
    const InQuote = 0x2
end

enable!(ps::ParseState, flag::Integer) = ps.flags |= flag
disable!(ps::ParseState, flag::Integer) = ps.flags &= ~flag
has_flag(ps::ParseState, flag::Integer) = ps.flags & flag > 0

function Base.show(io::IO, ps::ParseState)
    println(io, "ParseState at $(position(ps.l.io))")
    println(io, "last    : ", kindof(ps.lt), " ($(ps.lt))", "    ($(wstype(ps.lws)))")
    println(io, "current : ", kindof(ps.t), " ($(ps.t))", "    ($(wstype(ps.ws)))")
    println(io, "next    : ", kindof(ps.nt), " ($(ps.nt))", "    ($(wstype(ps.nws)))")
end
peekchar(ps::ParseState) = peekchar(ps.l)
if !applicable(Base.peek, Tuple{IOBuffer, Char})
    function _peek(s::IO, ::Type{T}) where T
        mark(s)
        try read(s, T)::T
        finally
            reset(s)
        end
    end
    peekchar(io) = _peek(io, Char)
else
    peekchar(io) = peek(io, Char)
end

wstype(t::AbstractToken) = kindof(t) == EmptyWS ? "empty" :
                    kindof(t) == NewLineWS ? "ws w/ newline" :
                    kindof(t) == SemiColonWS ? "ws w/ semicolon" : "ws"

function next(ps::ParseState)
    #  shift old tokens
    ps.lt = ps.t
    ps.t = ps.nt
    ps.nt = ps.nnt
    ps.lws = ps.ws
    ps.ws = ps.nws
    ps.nws = ps.nnws

    ps.nnt = Tokenize.Lexers.next_token(ps.l)

    # combines whitespace, comments and semicolons
    if iswhitespace(peekchar(ps.l)) || peekchar(ps.l) == '#' || peekchar(ps.l) == ';'
        ps.nnws = lex_ws_comment(ps.l, readchar(ps.l))
    else
        ps.nnws = EmptyWSToken
    end

    return ps
end

function Base.seek(ps::ParseState, offset)
    seek(ps.l, offset)
    next(next(ps))
end

Base.position(ps::ParseState) = ps.nt.startbyte

current_line(ps::ParseState) = ps.nt.startpos[1]
"""
    lex_ws_comment(l::Lexer, c)

Having hit an initial whitespace/comment/semicolon continues collecting similar
`Chars` until they end. Returns a WS token with an indication of newlines/ semicolons. Indicating a semicolons takes precedence over line breaks as the former is equivalent to the former in most cases.
"""
function read_ws_comment(l, c::Char)
    newline = c == '\n'
    semicolon = c == ';'
    if c == '#'
        newline = read_comment(l)
    else
        newline, semicolon = read_ws(l, newline, semicolon)
    end
    while iswhitespace(peekchar(l)) || peekchar(l) == '#' || peekchar(l) == ';'
        c = readchar(l)
        if c == '#'
            read_comment(l)
            newline = newline || peekchar(l) == '\n'
            semicolon = semicolon || peekchar(l) == ';'
        elseif c == ';'
            semicolon = true
        else
            newline |= c == '\n'
            newline, semicolon = read_ws(l, newline, semicolon)
        end
    end
    return newline, semicolon
end

function lex_ws_comment(l::Lexer, c::Char)
    newline, semicolon = read_ws_comment(l, c)
    return emit(l, semicolon ? SemiColonWS :
                   newline ? NewLineWS : WS)
end


function read_ws(l, newline, semicolon)
    while iswhitespace(peekchar(l))
        c = readchar(l)
        c == '\n' && (newline = true)
        c == ';' && (semicolon = true)
    end
    return newline, semicolon
end

function read_comment(l)
    if peekchar(l) != '='
        while true
            pc = peekchar(l)
            if pc == '\n' || eof(pc)
                return true
            end
            readchar(l)
        end
    else
        c = readchar(l) # consume the '='
        n_start, n_end = 1, 0
        while true
            if eof(c)
                return false
            end
            nc = readchar(l)
            if c == '#' && nc == '='
                n_start += 1
            elseif c == '=' && nc == '#'
                n_end += 1
            end
            if n_start == n_end
                return false
            end
            c = nc
        end
    end
end

# Functions relating to tokens
isemptyws(t::AbstractToken) = kindof(t) == EmptyWS
isnewlinews(t::AbstractToken) = kindof(t) === NewLineWS
isendoflinews(t::AbstractToken) = kindof(t) == SemiColonWS || kindof(t) == NewLineWS
@inline val(token::AbstractToken, ps::ParseState) = String(ps.l.io.data[token.startbyte + 1:token.endbyte + 1])
both_symbol_and_op(t::AbstractToken) = kindof(t) === Tokens.WHERE || kindof(t) === Tokens.IN || kindof(t) === Tokens.ISA
isprefixableliteral(t::AbstractToken) = (kindof(t) === Tokens.STRING || kindof(t) === Tokens.TRIPLE_STRING || kindof(t) === Tokens.CMD || kindof(t) === Tokens.TRIPLE_CMD)
isassignmentop(t::AbstractToken) = Tokens.begin_assignments < kindof(t) < Tokens.end_assignments

isidentifier(t::AbstractToken) = kindof(t) === Tokens.IDENTIFIER
isliteral(t::AbstractToken) = Tokens.begin_literal < kindof(t) < Tokens.end_literal
isbool(t::AbstractToken) =  Tokens.TRUE ≤ kindof(t) ≤ Tokens.FALSE
iscomma(t::AbstractToken) =  kindof(t) === Tokens.COMMA
iscolon(t::AbstractToken) =  kindof(t) === Tokens.COLON
iskeyword(t::AbstractToken) = Tokens.iskeyword(kindof(t))
isinstance(t::AbstractToken) = isidentifier(t) || isliteral(t) || isbool(t) || iskeyword(t)
ispunctuation(t::AbstractToken) = iscomma(t) || kindof(t) === Tokens.END || Tokens.LSQUARE ≤ kindof(t) ≤ Tokens.RPAREN || kindof(t) === Tokens.AT_SIGN
isnumberliteral(t::AbstractToken) = isliteral(t) && (Tokens.INTEGER ≤ kindof(t) ≤ Tokens.FLOAT)

# terminals
isidentifier(x::EXPR) = headof(x) === :IDENTIFIER || headof(x) === :NONSTDIDENTIFIER
isoperator(x::EXPR) = headof(x) === :OPERATOR
isnonstdid(x::EXPR) = headof(x) === :NONSTDIDENTIFIER
iskeyword(x::EXPR) = headof(x) in (:ABSTRACT, :BAREMODULE, :BEGIN, :BREAK, :CATCH, :CONST, :CONTINUE, :DO, :ELSE, :ELSEIF, :END, :EXPORT, :FINALLY, :FOR, :FUNCTION, :GLOBAL, :IF, :IMPORT, :importall, :LET, :LOCAL, :MACRO, :MODULE, :MUTABLE, :NEW, :OUTER, :PRIMITIVE, :PUBLIC, :QUOTE, :RETURN, :STRUCT, :TRY, :TYPE, :USING, :WHILE)
isliteral(x::EXPR) = isstringliteral(x) || iscmd(x) || ischar(x) || headof(x) in (:INTEGER, :BININT, :HEXINT, :OCTINT, :FLOAT,  :NOTHING, :TRUE, :FALSE)
ispunctuation(x::EXPR) = is_comma(x) || is_lparen(x) || is_rparen(x) || is_lsquare(x) || is_rsquare(x) || is_lbrace(x) || is_rbrace(x) || headof(x) === :ATSIGN  || headof(x) === :DOT
isstringliteral(x) = headof(x) === :STRING || headof(x) === :TRIPLESTRING
isstring(x) = headof(x) === :string || isstringliteral(x)
iscmd(x) = headof(x) === :CMD || headof(x) === :TRIPLECMD
ischar(x) = headof(x) === :CHAR
isinteger(x) = headof(x) === :INTEGER
isfloat(x) = headof(x) === :FLOAT
isnumber(x) = isinteger(x) || isfloat(x)
is_nothing(x) = headof(x) === :NOTHING
is_either_id_op_interp(x::EXPR) = isidentifier(x) || isoperator(x) || isinterpolant(x)
is_id_or_macroname(x::EXPR) = isidentifier(x) || ismacroname(x)

# expressions
iscall(x::EXPR) = headof(x) === :call
isunarycall(x::EXPR) = (headof(x) === :call && length(x) == 2 && (isoperator(x.args[1]) || isoperator(x.args[2])))
isunarysyntax(x::EXPR) =  (isoperator(x.head) && length(x.args) == 1)
isbinarycall(x::EXPR) = headof(x) === :call && length(x) == 3 && isoperator(x.args[1])
isbinarycall(x::EXPR, op) = headof(x) === :call && length(x) == 3 && isoperator(x.args[1]) && valof(x.args[1]) == op
isbinarysyntax(x::EXPR) =  (isoperator(x.head) && length(x.args) == 2)
ischainedcall(x::EXPR) = headof(x) === :call && isoperator(x.args[1]) && (valof(x.args[1]) == "+" || valof(x.args[1]) == "*") && hastrivia(x) && isoperator(first(x.trivia))
iswhere(x::EXPR) = headof(x) === :where
istuple(x::EXPR) = headof(x) === :tuple
ismacrocall(x::EXPR) = headof(x) === :macrocall
ismacroname(x::EXPR) = (headof(x) === :NONSTDIDENTIFIER && startswith(valof(first(x.args)), "@") || (isidentifier(x) && valof(x) !== nothing && !isempty(valof(x)) && first(valof(x)) == '@')) || (is_getfield_w_quotenode(x) && (ismacroname(unquotenode(rhs_getfield(x))) || ismacroname(x.args[1])))

iskwarg(x::EXPR) = headof(x) === :kw
isparameters(x::EXPR) = headof(x) === :parameters
iscurly(x::EXPR) = headof(x) === :curly
isbracketed(x::EXPR) = headof(x) === :brackets


isassignment(x::EXPR) = isbinarysyntax(x) && valof(x.head) == "="
isdeclaration(x::EXPR) = isbinarysyntax(x) && valof(x.head) == "::"
isinterpolant(x::EXPR) = isunarysyntax(x) && valof(x.head) == "\$"
issplat(x::EXPR) = isunarysyntax(x) && valof(x.head) == "..."


isbeginorblock(x::EXPR) = headof(x) === :begin || headof(unwrapbracket(x)) == :block


"""
    is_getfield(x::EXPR)

Is this an expression of the form `a.b`.
"""
is_getfield(x::EXPR) = x.head isa EXPR && isoperator(x.head) && valof(x.head) == "." && length(x.args) == 2
is_getfield_w_quotenode(x) = is_getfield(x) && headof(x.args[2]) === :quotenode && length(x.args[2].args) > 0
rhs_getfield(x) = x.args[2]
unquotenode(x) = x.args[1]

function get_rhs_of_getfield(ret::EXPR)
    if headof(ret.args[2]) === :quotenode || headof(ret.args[2]) === :quote
        ret.args[2].args[1]
    else
        ret.args[2]
    end
end


"""
    is_wrapped_assignment(x::EXPR)

Is `x` an assignment expression, ignoring any surrounding parentheses.
"""
is_wrapped_assignment(x::EXPR) = isassignment(x) || (isbracketed(x) && is_wrapped_assignment(x.args[1]))


function is_func_call(x::EXPR)
    if isoperator(x.head) && !issplat(x)
        if length(x.args) == 2
            return is_decl(x.head) && is_func_call(x.args[1])
        elseif length(x.args) == 1
            return !(is_exor(x.head) || is_decl(x.head))
        end
    elseif x.head === :call
        return true
    elseif x.head === :where || isbracketed(x)
        return is_func_call(x.args[1])
    end
    return false
end


fcall_name(x::EXPR) = iscall(x) && length(x.args) > 0 && valof(x.args[1])
hasparent(x::EXPR) = parentof(x) isa EXPR

# OPERATOR
is_approx(x::EXPR) = isoperator(x) && valof(x) == "~"
is_exor(x) = isoperator(x) && valof(x) == "\$"
is_decl(x) = isoperator(x) && valof(x) == "::"
is_issubt(x) = isoperator(x) && valof(x) == "<:"
is_issupt(x) = isoperator(x) && valof(x) == ">:"
is_and(x) = isoperator(x) && valof(x) == "&"
is_not(x) = isoperator(x) && valof(x) == "!"
is_plus(x) = isoperator(x) && valof(x) == "+"
is_minus(x) = isoperator(x) && valof(x) == "-"
is_star(x) = isoperator(x) && valof(x) == "*"
is_eq(x) = isoperator(x) && valof(x) == "="
is_dot(x) = isoperator(x) && valof(x) == "."
is_ddot(x) = isoperator(x) && valof(x) == ".."
is_dddot(x) = isoperator(x) && valof(x) == "..."
is_pairarrow(x) = isoperator(x) && valof(x) == "=>"
is_in(x) = isoperator(x) && valof(x) == "in"
is_elof(x) = isoperator(x) && valof(x) == "∈"
is_colon(x) = isoperator(x) && valof(x) == ":"
is_prime(x) = isoperator(x) && maybe_strip_suffix(valof(x)) == "'"
is_cond(x) = isoperator(x) && valof(x) == "?"
is_where(x) = isoperator(x) && valof(x) == "where"
is_anon_func(x) = isoperator(x) && valof(x) == "->"

is_comma(x) = headof(x) === :COMMA
is_lparen(x) = headof(x) === :LPAREN
is_rparen(x) = headof(x) === :RPAREN
is_lbrace(x) = headof(x) === :LBRACE
is_rbrace(x) = headof(x) === :RBRACE
is_lsquare(x) = headof(x) === :LSQUARE
is_rsquare(x) = headof(x) === :RSQUARE

# KEYWORD
is_if(x) = iskeyword(x) && headof(x) === :IF
is_import(x) = iskeyword(x) && headof(x) === :IMPORT


# Literals

issubtypedecl(x::EXPR) = isoperator(x.head) && valof(x.head) == "<:"

rem_subtype(x::EXPR) = issubtypedecl(x) ? x.args[1] : x
rem_decl(x::EXPR) = isdeclaration(x) ? x.args[1] : x
rem_curly(x::EXPR) = headof(x) === :curly ? x.args[1] : x
rem_call(x::EXPR) = headof(x) === :call ? x.args[1] : x
rem_where(x::EXPR) = iswhere(x) ? x.args[1] : x
rem_wheres(x::EXPR) = iswhere(x) ? rem_wheres(x.args[1]) : x
rem_where_subtype(x::EXPR) = (iswhere(x) || issubtypedecl(x)) ? x.args[1] : x
rem_wheres_subtypes(x::EXPR) = (iswhere(x) || issubtypedecl(x)) ? rem_wheres_subtypes(x.args[1]) : x
rem_where_decl(x::EXPR) = (iswhere(x) || isdeclaration(x)) ? x.args[1] : x
rem_wheres_decls(x::EXPR) = (iswhere(x) || isdeclaration(x)) ? rem_wheres_decls(x.args[1]) : x
rem_invis(x::EXPR) = isbracketed(x) ? rem_invis(x.args[1]) : x
rem_dddot(x::EXPR) = issplat(x) ? x.args[1] : x
const rem_splat = rem_dddot
rem_kw(x::EXPR) = headof(x) === :kw ? x.args[1] : x
unwrapbracket(x::EXPR) = isbracketed(x) ? unwrapbracket(x.args[1]) : x

is_some_call(x) = headof(x) === :call || isunarycall(x)
is_eventually_some_call(x) = is_some_call(x) || ((isdeclaration(x) || iswhere(x)) && is_eventually_some_call(x.args[1]))

defines_function(x::EXPR) = headof(x) === :function || (isassignment(x) && is_eventually_some_call(x.args[1]))
defines_macro(x) = headof(x) == :macro
defines_datatype(x) = defines_struct(x) || defines_abstract(x) || defines_primitive(x)
defines_struct(x) = headof(x) === :struct
defines_mutable(x) = defines_struct(x) && x.args[1].head == :TRUE
defines_abstract(x) = headof(x) === :abstract
defines_primitive(x) = headof(x) === :primitive
defines_module(x) = headof(x) === :module
defines_anon_function(x) = isoperator(x.head) && valof(x.head) == "->"

has_sig(x::EXPR) = defines_datatype(x) || defines_function(x) || defines_macro(x) || defines_anon_function(x)

"""
    get_sig(x)

Returns the full signature of function, macro and datatype definitions.
Should only be called when has_sig(x) == true.
"""
function get_sig(x::EXPR)
    if headof(x) isa EXPR # headof(headof(x)) === :OPERATOR valof(headof(x)) == "="
        return x.args[1]
    elseif headof(x) === :struct || headof(x) === :mutable
        return x.args[2]
    elseif headof(x) === :function || headof(x) === :macro
        return rem_invis(x.args[1])
    elseif headof(x) === :abstract || headof(x) === :primitive
        return x.args[1]
    end
end

function get_name(x::EXPR)
    if defines_datatype(x)
        sig = get_sig(x)
        sig = rem_subtype(sig)
        sig = rem_wheres(sig)
        sig = rem_subtype(sig)
        sig = rem_curly(sig)
    elseif defines_module(x)
        sig = x.args[2]
    elseif defines_function(x) || defines_macro(x)
        sig = get_sig(x)
        sig = rem_wheres(sig)
        sig = rem_decl(sig)
        sig = rem_call(sig)
        sig = rem_curly(sig)
        sig = rem_invis(sig)
        # if isbinarysyntax(sig) && is_dot(sig.head)
        if is_getfield_w_quotenode(sig)
            sig = sig.args[2].args[1]
        end
        return sig
    elseif is_getfield_w_quotenode(x)
        return x.args[2].args[1]
    elseif isbinarycall(x)
        sig = x.args[1]
        if isunarycall(sig)
            return get_name(sig.args[1])
        end
        sig = rem_wheres(sig)
        sig = rem_decl(sig)
        sig = rem_call(sig)
        sig = rem_curly(sig)
        sig = rem_invis(sig)
        return get_name(sig)
    elseif isbinarysyntax(x) && valof(x.head) == "<:"
        return get_name(x.args[1])
    elseif isunarysyntax(x) && valof(x.head) == "..."
        return get_name(x.args[1])
    else
        sig = x
        if isunarycall(sig)
            sig = sig.args[1]
        end
        sig = rem_wheres(sig)
        sig = rem_decl(sig)
        sig = rem_call(sig)
        sig = rem_curly(sig)
        rem_invis(sig)
    end
end

function get_arg_name(arg::EXPR)
    arg = rem_kw(arg)
    arg = rem_dddot(arg)
    arg = rem_where(arg)
    arg = rem_decl(arg)
    arg = rem_subtype(arg)
    arg = rem_curly(arg)
    rem_invis(arg)
end

function Base.show(io::IO, x::EXPR, offset = 0, d = 0, er = false)
    T = headof(x)
    c =  T === :errortoken || er ? :red : :normal
    # Print span as 1-based range of the source string. This presentation is
    # simple to understand when strings are presented to CSTParser.parse().
    print(io, lpad(offset + 1, 3), ":", rpad(offset + x.fullspan, 3), " ")
    if isidentifier(x)
        printstyled(io, " "^d, headof(x) == :NONSTDIDENTIFIER ? valof(x.args[2]) : valof(x), color = :yellow)
        x.meta !== nothing && show(io, x.meta)
        print(io)
    elseif isoperator(x)
        printstyled(io, " "^d, "OP: ", valof(x), color = c)
    elseif iskeyword(x)
        printstyled(io, " "^d, headof(x), color = :magenta)
    elseif ispunctuation(x)
        printstyled(io, " "^d, punctuationprinting[headof(x)], color = c)
    elseif isliteral(x)
        printstyled(io, " "^d, "$(headof(x)): ", valof(x) === nothing ? "nothing" : valof(x), color = c)
    else
        printstyled(io, " "^d, T, color=c)
        if x.meta !== nothing
            print(io, "( ")
            show(io, x.meta)
            print(io, ")")
        end
        x.args === nothing && return
        for a in x.args
            println(io)
            show(io, a, offset, d + 1, er)
            offset += a.fullspan
        end
    end
end

const punctuationprinting = Dict(
    :COMMA => ",",
    :LPAREN => "(",
    :RPAREN => ")",
    :LSQUARE => "[",
    :RSQUARE => "]",
    :LBRACE => "{",
    :RBRACE => "}",
    :ATSIGN => "@",
    :DOT => "."
)

struct CSTInfiniteLoop <: Exception
    msg::AbstractString
end

function Base.showerror(io::IO, ex::CSTInfiniteLoop)
    print(io, ex.msg)
end

@testitem "Abstract" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")
    
    @test "abstract type t end" |> test_expr
    @test "abstract type t{T} end" |> test_expr
    @test "abstract type t <: S end" |> test_expr
    @test "abstract type t{T} <: S end" |> test_expr
end

@testitem "primitive" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")
    
    @test "primitive type Int 64 end" |> test_expr
    @test "primitive type Int 4*16 end" |> test_expr
end

@testitem "Structs" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")
    
    @test "struct a end" |> test_expr
    @test "struct a; end" |> test_expr
    @test "struct a; b;end" |> test_expr
    @test """struct a
        arg1
    end""" |> test_expr
    @test """struct a <: T
        arg1::Int
        arg2::Int
    end""" |> test_expr
    @test """struct a
        arg1::T
    end""" |> test_expr
    @test """struct a{T}
        arg1::T
        a(args) = new(args)
    end""" |> test_expr
    @test """struct a <: Int
        arg1::Vector{Int}
    end""" |> test_expr
    @test """mutable struct a <: Int
        arg1::Vector{Int}
    end""" |> test_expr
    if VERSION > v"1.8-"
        @test """mutable struct A
            const arg1::Vector{Int}
            arg2
        end""" |> test_expr
        @test """mutable struct A
            const arg1
            arg2
        end""" |> test_expr
        @test """struct A
            const arg1
            arg2
        end""" |> test_expr
        @test """@eval struct A
            const arg1
            arg2
        end""" |> test_expr
    end
end

using CSTParser: @cst_str, headof, parentof, check_span, EXPR, to_codeobject

jl_parse(s) = CSTParser.remlineinfo!(Meta.parse(s))

function check_parents(x::EXPR)
    if x.args isa Vector{EXPR}
        for a in x.args
            @test a.parent == x
            check_parents(a)
        end
    end
    if x.trivia isa Vector{EXPR}
        for a in x.trivia
            @test a.parent == x
        end
    end
end

function test_iter(ex)
    total = 0
    for x in ex
        @test x isa EXPR
        test_iter(x)
        total += x.fullspan
    end
    if length(ex) > 0
        @test total == ex.fullspan
    end
end

function test_expr(s, head, n, endswithtrivia = false)
    x = CSTParser.parse(s)
    head === nothing || @test headof(x) === head
    @test length(x) === n
    @test x.args === nothing || all(x === parentof(a) for a in x.args)
    @test x.trivia === nothing || all(x === parentof(a) for a in x.trivia)
    @test to_codeobject(x) == jl_parse(s)
    @test isempty(check_span(x))
    check_parents(x)
    test_iter(x)
    @test endswithtrivia ? (x.fullspan-x.span) == (last(x.trivia).fullspan - last(x.trivia).span) : (x.fullspan-x.span) == (last(x.args).fullspan - last(x.args).span)
end

randop() = rand(["-->", "→",
                 "||",
                 "&&",
                 "<", "==", "<:", ">:",
                 "<|", "|>",
                 ":",
                 "+", "-",
                 ">>", "<<",
                 "*", "/",
                 "//",
                 "^", "↑",
                 "::",
                 ".", "->"])

test_expr_broken(str) = test_expr(str, false)

function traverse(x)
    try
        for a in x
            @test traverse(a)
        end
        return true
    catch err
        @error "EXPR traversal failed." expr = x exception = err
        return false
    end
end

function test_expr(str, show_data=true)
    x, ps = CSTParser.parse(ParseState(str))

    x0 = to_codeobject(x)
    x1 = remlineinfo!(Meta.parse(str))

    @test x.args === nothing || all(x === parentof(a) for a in x.args)
    @test x.trivia === nothing || all(x === parentof(a) for a in x.trivia)
    @test isempty(check_span(x))
    check_parents(x)
    @test traverse(x)
    @test x.fullspan == sizeof(str)

    if CSTParser.has_error(ps) || x0 != x1
        if show_data
            println("Mismatch between flisp and CSTParser when parsing string $str")
            println("ParserState:\n $ps\n")
            println("CSTParser Expr:\n $x\n")
            println("Converted CSTParser Expr:\n $x0\n")
            println("Base EXPR:\n $x1\n")
        end
        return false
    end
    return true
end

function test_iter_spans(x)
    n = 0
    for i = 1:length(x)
        a  = x[i]
        if !(a isa EXPR)
            @info i, headof(x), to_codeobject(x)
        end
        @test a isa EXPR
        test_iter_spans(a)
        n += a.fullspan
    end
    length(x) > 0 && @test n == x.fullspan
end

@testitem "show" begin
    x = CSTParser.parse("a + (b*c) - d")
    @test sprint(show, x) ===
    "  1:13  call\n  1:2    OP: -\n  3:12   call\n  3:4     OP: +\n  5:6     a\n  7:12    brackets\n  7:9      call\n  7:7       OP: *\n  8:8       b\n  9:9       c\n 13:13   d"
end

"""
    parse_kw(ps::ParseState)

Dispatch function for when the parser has reached a keyword.
"""
function parse_kw(ps::ParseState; is_toplevel = false)
    k = kindof(ps.t)
    if ps.closer.precedence == 20 && ps.lt.kind === Tokens.EX_OR && k !== Tokens.END
        return EXPR(:IDENTIFIER, ps)
    end
    if k === Tokens.IF
        return @default ps @closer ps :block parse_if(ps)
    elseif k === Tokens.LET
        return @default ps @closer ps :block parse_blockexpr(ps, :let)
    elseif k === Tokens.TRY
        return @default ps @closer ps :block parse_try(ps)
    elseif k === Tokens.FUNCTION
        return @default ps @closer ps :block parse_blockexpr(ps, :function)
    elseif k === Tokens.MACRO
        return @default ps @closer ps :block parse_blockexpr(ps, :macro)
    elseif k === Tokens.BEGIN
        @static if VERSION < v"1.4"
            return @default ps @closer ps :block parse_blockexpr(ps, :begin)
        else
            if ps.closer.inref
                ret = EXPR(ps)
            else
                return @default ps @closer ps :block parse_blockexpr(ps, :begin)
            end
        end
    elseif k === Tokens.QUOTE
        return @default ps @nocloser ps :inref @closer ps :block parse_blockexpr(ps, :quote)
    elseif k === Tokens.FOR
        return @default ps @closer ps :block parse_blockexpr(ps, :for)
    elseif k === Tokens.WHILE
        return @default ps @closer ps :block parse_blockexpr(ps, :while)
    elseif k === Tokens.BREAK
        return EXPR(ps)
    elseif k === Tokens.CONTINUE
        return EXPR(ps)
    elseif k === Tokens.IMPORT
        return parse_imports(ps)
    elseif k === Tokens.IMPORTALL
        # Old keyword..
        return EXPR(:IDENTIFIER, ps)
    elseif k === Tokens.USING
        return parse_imports(ps)
    elseif k === Tokens.EXPORT
        return parse_export(ps)
    elseif k === Tokens.MODULE
        return @default ps @closer ps :block parse_blockexpr(ps, :module)
    elseif k === Tokens.BAREMODULE
        return @default ps @closer ps :block parse_blockexpr(ps, :baremodule)
    elseif k === Tokens.CONST
        return @default ps parse_const(ps)
    elseif k === Tokens.GLOBAL
        return @default ps parse_local_global(ps, false)
    elseif k === Tokens.LOCAL
        return @default ps parse_local_global(ps)
    elseif k === Tokens.RETURN
        return @default ps parse_return(ps)
    elseif k === Tokens.END
        if ps.closer.square
            ret = EXPR(ps)
        else
            ret = mErrorToken(ps, EXPR(:IDENTIFIER, ps), UnexpectedToken)
        end
        return ret
    elseif k === Tokens.ELSE || k === Tokens.ELSEIF || k === Tokens.CATCH || k === Tokens.FINALLY
        return mErrorToken(ps, EXPR(:IDENTIFIER, ps), UnexpectedToken)
    elseif k === Tokens.ABSTRACT
        return @default ps parse_abstract(ps)
    elseif k === Tokens.PRIMITIVE
        return @default ps parse_primitive(ps)
    elseif k === Tokens.PUBLIC
        if is_toplevel && !isemptyws(ps.ws) && VERSION > v"1.11-"
            return @default ps parse_public(ps)
        else
            return EXPR(:IDENTIFIER, ps)
        end
    elseif k === Tokens.TYPE
        return EXPR(:IDENTIFIER, ps)
    elseif k === Tokens.STRUCT
        enable!(ps, ParserFlags.AllowConstWithoutAssignment)
        ret = @default ps @closer ps :block parse_blockexpr(ps, :struct)
        disable!(ps, ParserFlags.AllowConstWithoutAssignment)
        return ret
    elseif k === Tokens.MUTABLE
        return @default ps @closer ps :block parse_mutable(ps)
    elseif k === Tokens.OUTER
        return EXPR(:IDENTIFIER, ps)
    else
        return mErrorToken(ps, Unknown)
    end
end

function parse_const(ps::ParseState)
    kw = EXPR(ps)
    lt = ps.lt
    nt = ps.nt
    arg = parse_expression(ps)
    allow_no_assignment = has_flag(ps, ParserFlags.AllowConstWithoutAssignment) ||
        has_flag(ps, ParserFlags.InQuote) && (kindof(nt) === Tokens.GLOBAL || kindof(lt) === Tokens.GLOBAL)
    if !allow_no_assignment && !(isassignment(unwrapbracket(arg)) || (headof(arg) === :global && length(arg.args) > 0 && isassignment(unwrapbracket(arg.args[1]))))
        arg = mErrorToken(ps, arg, ExpectedAssignment)
    end
    ret = EXPR(:const, EXPR[arg], EXPR[kw])
    return ret
end

function parse_local_global(ps::ParseState, islocal = true)
    kw = EXPR(ps)
    if ps.nt.kind === Tokens.CONST
        arg1 = parse_const(next(ps))
        EXPR(:const, EXPR[EXPR(islocal ? :local : :global, arg1.args, EXPR[kw])], arg1.trivia)
    else
        args, trivia = EXPR[], EXPR[kw]
        arg = parse_expression(ps)
        if isassignment(unwrapbracket(arg))
            push!(args, arg)
        elseif arg.head === :tuple
            append!(args, arg.args)
            append!(trivia, arg.trivia)
        else
            push!(args, arg)
        end
        EXPR(islocal ? :local : :global, args, trivia)
    end
end


function parse_return(ps::ParseState)
    kw = EXPR(ps)
    # Note to self: Nothing could be treated as implicit and added
    # during conversion to Expr.
    arg = closer(ps) ? EXPR(:NOTHING, 0, 0, "") : @precedence ps AssignmentOp - 1 parse_expression(ps)

    return EXPR(:return, EXPR[arg], EXPR[kw])
end

function parse_abstract(ps::ParseState)
    if kindof(ps.nt) === Tokens.TYPE
        kw1 = EXPR(ps)
        kw2 = EXPR(next(ps))
        sig = @closer ps :block parse_expression(ps)
        ret = EXPR(:abstract, EXPR[sig], EXPR[kw1, kw2, accept_end(ps)])
    else
        ret = EXPR(:IDENTIFIER, ps)
    end
    return ret
end

function parse_primitive(ps::ParseState)
    if kindof(ps.nt) === Tokens.TYPE
        kw1 = EXPR(ps)
        kw2 = EXPR(next(ps))
        sig = @closer ps :ws @closer ps :wsop parse_expression(ps)
        arg = @closer ps :block parse_expression(ps)
        ret = EXPR(:primitive, EXPR[sig, arg], EXPR[kw1, kw2, accept_end(ps)])
    else
        ret = EXPR(:IDENTIFIER, ps)
    end
    return ret
end

function parse_public(ps::ParseState)
    args = EXPR[]
    trivia = EXPR[EXPR(ps)]

    push!(args, parse_importexport_item(ps))

    prevpos = position(ps)
    while iscomma(ps.nt)
        push!(trivia, EXPR(next(ps)))
        arg = parse_importexport_item(ps)
        push!(args, arg)
        prevpos = loop_check(ps, prevpos)
    end

    return EXPR(:public, args, trivia)
end

function parse_mutable(ps::ParseState)
    if kindof(ps.nt) === Tokens.STRUCT
        kw = EXPR(ps)
        next(ps)

        enable!(ps, ParserFlags.AllowConstWithoutAssignment)
        ret = parse_blockexpr(ps, :mutable)
        disable!(ps, ParserFlags.AllowConstWithoutAssignment)

        pushfirst!(ret.trivia, setparent!(kw, ret))
        update_span!(ret)
    else
        ret = EXPR(:IDENTIFIER, ps)
    end
    return ret
end

function parse_imports(ps::ParseState)
    kw = EXPR(ps)
    allow_as = is_import(kw)
    kwt = allow_as ? :import : :using

    arg = parse_dot_mod(ps, false, allow_as)
    if !iscomma(ps.nt) && !iscolon(ps.nt)
        ret = EXPR(kwt, EXPR[arg], EXPR[kw])
    elseif iscolon(ps.nt)
        ret = EXPR(kwt, EXPR[EXPR(EXPR(:OPERATOR, next(ps)), EXPR[arg])], EXPR[kw])

        arg = parse_dot_mod(ps, true, true)
        push!(ret.args[1], arg)
        prevpos = position(ps)
        while iscomma(ps.nt)
            pushtotrivia!(ret.args[1], accept_comma(ps))
            arg = parse_dot_mod(ps, true, true)
            push!(ret.args[1], arg)
            prevpos = loop_check(ps, prevpos)
        end
        update_span!(ret)
    else
        ret = EXPR(kwt, EXPR[arg], EXPR[kw])
        prevpos = position(ps)
        while iscomma(ps.nt)
            pushtotrivia!(ret, accept_comma(ps))
            arg = parse_dot_mod(ps, false, allow_as)
            push!(ret, arg)
            prevpos = loop_check(ps, prevpos)
        end
    end

    return ret
end

function parse_export(ps::ParseState)
    args = EXPR[]
    trivia = EXPR[EXPR(ps)]
    push!(args, parse_importexport_item(ps))

    prevpos = position(ps)
    while iscomma(ps.nt)
        push!(trivia, EXPR(next(ps)))
        arg = parse_importexport_item(ps)
        push!(args, arg)
        prevpos = loop_check(ps, prevpos)
    end

    return EXPR(:export, args, trivia)
end

"""
    parse_blockexpr_sig(ps::ParseState, head)

Utility function to parse the signature of a block statement (i.e. any statement preceding
the main body of the block). Returns `nothing` in some cases (e.g. `begin end`)
"""
function parse_blockexpr_sig(ps::ParseState, head)
    if head === :struct || head == :mutable || head === :while
        return @closer ps :ws parse_expression(ps)
    elseif head === :for
        iters, trivia = EXPR[], EXPR[]
        parse_iterators(ps, iters, trivia)
        if length(iters) == 1
            return first(iters)
        else
            return EXPR(:block, iters, trivia)
        end
    elseif head === :function || head === :macro
        sig = @closer ps :inwhere @closer ps :ws parse_expression(ps)
        if convertsigtotuple(sig)
            sig = EXPR(:tuple, sig.args, sig.trivia)
        end
        prevpos = position(ps)
        while kindof(ps.nt) === Tokens.WHERE && kindof(ps.ws) != Tokens.NEWLINE_WS
            sig = @closer ps :inwhere @closer ps :ws parse_operator_where(ps, sig, INSTANCE(next(ps)), false)
            prevpos = loop_check(ps, prevpos)
        end
        return sig
    elseif head === :let
        if isendoflinews(ps.ws)
            return EXPR(:block, EXPR[], nothing)
        else
            arg = @closer ps :comma @closer ps :ws parse_expression(ps)
            if iscomma(ps.nt) || !(is_wrapped_assignment(arg) || isidentifier(arg))
                arg = EXPR(:block, EXPR[arg])
                prevpos = position(ps)
                while iscomma(ps.nt)
                    pushtotrivia!(arg, accept_comma(ps))
                    nextarg = @closer ps :comma @closer ps :ws parse_expression(ps)
                    push!(arg, nextarg)
                    prevpos = loop_check(ps, prevpos)
                end
            end
            return arg
        end
    elseif head === :do
        args, trivia = EXPR[], EXPR[]
        prevpos = position(ps)
        @closer ps :comma @closer ps :block while !closer(ps)
            push!(args, @closer ps :ws a = parse_expression(ps))
            if kindof(ps.nt) === Tokens.COMMA
                push!(trivia, accept_comma(ps))
            elseif @closer ps :ws closer(ps)
                break
            end
            prevpos = loop_check(ps, prevpos)
        end
        return EXPR(:tuple, args, trivia)
    elseif head === :module || head === :baremodule
        return if isidentifier(ps.nt)
            if is_nonstd_identifier(ps)
                parse_nonstd_identifier(ps)
            else
                EXPR(:IDENTIFIER, next(ps))
            end
        else
            @precedence ps 15 @closer ps :ws parse_expression(ps)
        end
    end
    return nothing
end

function parse_do(ps::ParseState, pre::EXPR)
    args, trivia = EXPR[pre], EXPR[EXPR(next(ps))]
    args1, trivia1 = EXPR[], EXPR[]

    @closer ps :comma @closer ps :block while !closer(ps)
        push!(args1, @closer ps :ws a = parse_expression(ps))
        if kindof(ps.nt) === Tokens.COMMA
            push!(trivia1, accept_comma(ps))
        elseif @closer ps :ws closer(ps)
            break
        else
            # we've errored, let's add a dummy comma
            push!(trivia1, EXPR(:COMMA, 0, 0))
        end
    end
    blockargs = parse_block(ps, EXPR[], (Tokens.END,))
    push!(args, (EXPR(EXPR(:OPERATOR, 0, 0, "->"), EXPR[EXPR(:tuple, args1, trivia1), EXPR(:block, blockargs, nothing)])))
    push!(trivia, accept_end(ps))
    return EXPR(:do, args, trivia)
end

"""
    parse_blockexpr(ps::ParseState, head)

General function for parsing block expressions comprised of a series of statements
terminated by an `end`.
"""
function parse_blockexpr(ps::ParseState, head)
    kw = EXPR(ps)
    sig = parse_blockexpr_sig(ps, head)
    blockargs = parse_block(ps, EXPR[], (Tokens.END,), docable(head))
    if head === :begin
        EXPR(:block, blockargs, EXPR[kw, accept_end(ps)])
    elseif sig === nothing
        EXPR(head, EXPR[EXPR(:block, blockargs, nothing)], EXPR[kw, accept_end(ps)])
    elseif (head === :function || head === :macro) && is_either_id_op_interp(sig)
        if isempty(blockargs)
            EXPR(head, EXPR[sig], EXPR[kw, accept_end(ps)])
        else
            sig = mErrorToken(ps, sig, SignatureOfFunctionDefIsNotACall)
            EXPR(head, EXPR[sig, EXPR(:block, blockargs, nothing)], EXPR[kw, accept_end(ps)])
        end
    elseif head === :mutable
        EXPR(:struct, EXPR[EXPR(:TRUE, 0, 0), sig, EXPR(:block, blockargs, nothing)], EXPR[kw, accept_end(ps)])
    elseif head === :module
        EXPR(head, EXPR[EXPR(:TRUE, 0, 0), sig, EXPR(:block, blockargs, nothing)], EXPR[kw, accept_end(ps)])
    elseif head === :baremodule
        EXPR(:module, EXPR[EXPR(:FALSE, 0, 0), sig, EXPR(:block, blockargs, nothing)], EXPR[kw, accept_end(ps)])
    elseif head === :struct
        EXPR(head, EXPR[EXPR(:FALSE, 0, 0), sig, EXPR(:block, blockargs, nothing)], EXPR[kw, accept_end(ps)])
    else
        EXPR(head, EXPR[sig, EXPR(:block, blockargs, nothing)], EXPR[kw, accept_end(ps)])
    end
end


"""
    parse_if(ps, nested=false)

Parse an `if` block.
"""
function parse_if(ps::ParseState, nested = false)
    args = EXPR[]
    trivia = EXPR[EXPR(ps)]

    push!(args, isendoflinews(ps.ws) ? mErrorToken(ps, MissingConditional) : @closer ps :ws parse_expression(ps))
    push!(args, EXPR(:block, parse_block(ps, EXPR[], (Tokens.END, Tokens.ELSE, Tokens.ELSEIF)), nothing))

    elseblockargs = EXPR[]
    if kindof(ps.nt) === Tokens.ELSEIF
        push!(args, parse_if(next(ps), true))
    end
    elsekw = kindof(ps.nt) === Tokens.ELSE
    if kindof(ps.nt) === Tokens.ELSE
        push!(trivia, EXPR(next(ps)))
        parse_block(ps, elseblockargs)
    end

    # Construction
    if !(isempty(elseblockargs) && !elsekw)
        push!(args, EXPR(:block, elseblockargs, nothing))
    end
    !nested && push!(trivia, accept_end(ps))

    return EXPR(nested ? :elseif : :if, args, trivia)
end


function parse_try(ps::ParseState)
    kw = EXPR(ps)
    args = EXPR[]
    trivia = EXPR[kw]
    tryblockargs = parse_block(ps, EXPR[], (Tokens.END, Tokens.CATCH, Tokens.ELSE, Tokens.FINALLY))
    push!(args, EXPR(:block, tryblockargs, nothing))

    #  catch block
    if kindof(ps.nt) === Tokens.CATCH
        push!(trivia, EXPR(next(ps)))
        # catch closing early
        if kindof(ps.nt) === Tokens.FINALLY || kindof(ps.nt) === Tokens.END
            caught = EXPR(:FALSE, 0, 0, "")
            catchblock = EXPR(:block, EXPR[])
        else
            if isendoflinews(ps.ws)
                caught = EXPR(:FALSE, 0, 0, "")
            else
                caught = @closer ps :ws parse_expression(ps)
            end

            catchblockargs = parse_block(ps, EXPR[], (Tokens.END, Tokens.FINALLY, Tokens.ELSE))
            if !(is_either_id_op_interp(caught) || headof(caught) === :FALSE)
                pushfirst!(catchblockargs, caught)
                caught = EXPR(:FALSE, 0, 0, "")
            end
            catchblock = EXPR(:block, catchblockargs, nothing)
        end
    else
        push!(trivia, EXPR(:CATCH, 0, 0))
        caught = EXPR(:FALSE, 0, 0, "")
        catchblock = EXPR(:block, EXPR[], nothing)
    end
    push!(args, caught)
    push!(args, catchblock)

    else_trivia = else_arg = nothing
    # else block
    if kindof(ps.nt) === Tokens.ELSE
        if isempty(catchblock.args)
            args[3] = EXPR(:block, 0, 0, "")
        end
        else_trivia = EXPR(next(ps))
        else_arg = EXPR(:block, parse_block(ps, EXPR[], (Tokens.FINALLY,Tokens.END)))
    end

    has_finally = false
    if kindof(ps.nt) === Tokens.FINALLY
        has_finally = true

        if isempty(catchblock.args) && else_trivia === nothing && caught.head === :FALSE
            args[3] = EXPR(:FALSE, 0, 0, "")
        end
        push!(trivia, EXPR(next(ps)))
        push!(args, EXPR(:block, parse_block(ps)))
    end

    if else_trivia !== nothing
        if !has_finally
            push!(trivia, EXPR(:FALSE, 0, 0, ""))
            push!(args, EXPR(:FALSE, 0, 0, ""))
        end
        push!(trivia, else_trivia)
        push!(args, else_arg)
    end

    push!(trivia, accept_end(ps))
    return EXPR(:try, args, trivia)
end

@testitem ":local" begin
    include("shared.jl")

    test_expr("local a", :local, 2)
end

@testitem ":global" begin
    include("shared.jl")

    test_expr("global a", :global, 2)
    test_expr("global a, b", :global, 4)
    test_expr("global a, b = 2", :global, 2)
    test_expr("global const a = 1", :const, 2)
    test_expr("global const a = 1, b", :const, 2)
end

@testitem ":const" begin
    include("shared.jl")

    test_expr("const a = 1", :const, 2)
    test_expr("const global a = 1", :const, 2)
end

@testitem ":return" begin
    include("shared.jl")

    test_expr("return a", :return, 2)
end

@testitem ":abstract" begin
    include("shared.jl")

    test_expr("abstract type sig end", :abstract, 4, true)
end

@testitem ":primitive" begin
    include("shared.jl")

    test_expr("primitive type sig spec end", :primitive, 5, true)
end

@testitem ":call" begin
    include("shared.jl")

    test_expr("f()", :call, 3, true)
    test_expr("f(a, b)", :call, 6, true)
    test_expr("a + b", :call, 3, false)
end

@testitem ":brackets" begin
    include("shared.jl")

    test_expr("(a)", :brackets, 3, true)
end

@testitem ":begin" begin
    include("shared.jl")

    test_expr("begin end", :block, 2, true)
    test_expr("begin a end", :block, 3, true)
    test_expr("quote end", :quote, 3, true)
    test_expr("while cond end", :while, 4, true)
    test_expr("for i = I end", :for, 4, true)
    test_expr("module m end", :module, 5, true)
    test_expr("function f() end", :function, 4, true)
    test_expr("macro f() end", :macro, 4, true)
    test_expr("struct T end", :struct, 5, true)
    test_expr("mutable struct T end", :struct, 6, true)
end

@testitem ":export" begin
    include("shared.jl")

    test_expr("export a", :export, 2, false)
    test_expr("export a, b", :export, 4, false)
end

@testitem ":import" begin
    include("shared.jl")

    test_expr("import a", :import, 2, false)
    test_expr("import a, b", :import, 4, false)
    test_expr("import a.b", :import, 2, false)
    test_expr("import a.b, c", :import, 4, false)
    test_expr("import a:b", :import, 2, false)
    test_expr("import a:b.c", :import, 2, false)
    test_expr("import a:b.c, d", :import, 2, false)
end

@testitem ":kw" begin
    include("shared.jl")

    test_expr("f(a=1)", :call, 4, false)
    if VERSION <= v"1.12-"
        # currently broken due to JuliaSyntax inserting a begin-end block
        # on the RHS of the kwarg
        test_expr("f(::typeof(a)=1)", :call, 4, false)
    end
    test_expr("f(a::typeof(a)=1)", :call, 4, false)
    test_expr("f(::a=1)", :call, 4, false)
    test_expr("f(a::a=1)", :call, 4, false)

    test_expr("f(; a::typeof(a)=1)", :call, 4, false)
    test_expr("f(; a::a=1)", :call, 4, false)
end

@testitem ":tuple" begin
    include("shared.jl")

    test_expr("a,b ", :tuple, 3, false)
    test_expr("(a,b) ", :tuple, 5, true)
    test_expr("a,b,c ", :tuple, 5, false)
    test_expr("(a,b),(c) ", :tuple, 3, false)
end

@testitem ":curly" begin
    include("shared.jl")

    test_expr("x{a}", :curly, 4, true)
    test_expr("x{a,b}", :curly, 6, true)
end

@testitem "operators" begin
    include("shared.jl")

    test_expr("!a", :call, 2, false)
    test_expr("&a", nothing, 2, false)
    test_expr(":a", :quotenode, 2, false)
    test_expr("a + 1", :call, 3, false)
    test_expr(":(a + 1)", :quote, 2, false)
    test_expr("a ? b : c", :if, 5, false)
    test_expr("a:b", :call, 3, false)
    test_expr("a:b:c", :call, 5, false)
    test_expr("a = b", nothing, 3, false)
    test_expr("a += b", nothing, 3, false)
    test_expr("a < b", :call, 3, false)
    test_expr("a < b < c", :comparison, 5, false)
    test_expr("a^b", :call, 3, false)
    test_expr("!a^b", nothing, 2, false)
    test_expr("a.b", nothing, 3, false)
    test_expr("a.:b", nothing, 3, false)
    test_expr("a + b + c", :call, 5, false)
    test_expr("a where b", :where, 3, false)
    test_expr("a where {b }", :where, 5, true)
    test_expr("a where {b,c }  ", :where, 7, true)
    test_expr("a...", nothing, 2, false)
    @test let x = cst"a... "; x.fullspan - x.span == 1 end
    test_expr("a <: b", nothing, 3, false)

    # https://github.com/julia-vscode/CSTParser.jl/issues/278
    test_expr("*(a)*b*c", :call, 5, false)
    test_expr("+(a)+b+c", :call, 5, false)
    test_expr("(\na +\nb +\nc +\n d\n)", :brackets, 3, true)
end

@testitem ":parameters" begin
    include("shared.jl")

    test_expr("f(a;b = 1)", nothing, 5, true)
end

@testitem "lists :vect" begin
    include("shared.jl")

    test_expr("[]", :vect, 2, true)
    test_expr("[a]", :vect, 3, true)
    test_expr("[a, b]", :vect, 5, true)
    test_expr("[a ]", :vect, 3, true)
end

@testitem "lists :vcat" begin
    include("shared.jl")

    test_expr("[a\nb]", :vcat, 4, true)
    test_expr("[a;b]", :vcat, 4, true)
    test_expr("[a b\nc d]", :vcat, 4, true)
    test_expr("[a\nc d]", :vcat, 4, true)
    test_expr("[a;c d]", :vcat, 4, true)
end

@testitem "lists :hcat" begin
    include("shared.jl")

    test_expr("[a b]", :hcat, 4, true)
end

@testitem "lists :ref" begin
    include("shared.jl")

    test_expr("T[a]", :ref, 4, true)
    test_expr("T[a,b]", :ref, 6, true)
end

@testitem "lists :typed_hcat" begin
    include("shared.jl")

    test_expr("T[a b]", :typed_hcat, 5, true)
end

@testitem "lists :typed_vcat" begin
    include("shared.jl")

    test_expr("T[a;b]", :typed_vcat, 5, true)
end

@testitem ":let" begin
    include("shared.jl")

    test_expr("let\n end", :let, 4, true)
    test_expr("let x = 1 end", :let, 4, true)
    test_expr("let x = 1, y =1  end", :let, 4, true)
end

@testitem ":try" begin
    include("shared.jl")

    test_expr("try catch end", :try, 6, true)
    test_expr("try a catch end", :try, 6, true)
    test_expr("try catch e end", :try, 6, true)
    test_expr("try a catch e end", :try, 6, true)
    test_expr("try a catch e b end", :try, 6, true)
    test_expr("try a catch e b end", :try, 6, true)
    test_expr("try finally end", :try, 8, true)
    test_expr("try finally a end", :try, 8, true)
    test_expr("try a catch e b finally c end", :try, 8, true)
end

@testitem ":macrocall" begin
    include("shared.jl")

    test_expr("@m", :macrocall, 2, false)
    test_expr("@m a", :macrocall, 3, false)
    test_expr("@m a b", :macrocall, 4, false)
end

@testitem ":if" begin
    include("shared.jl")

    test_expr("if c end", :if, 4, true)
    test_expr("if c a end", :if, 4, true)
    test_expr("if c a else end", :if, 6, true)
    test_expr("if c a else b end", :if, 6, true)
    test_expr("if c elseif c end", :if, 5, true)
    test_expr("if c a elseif c b end", :if, 5, true)
    test_expr("if c a elseif c b else d end", :if, 5, true)
end

@testitem ":do" begin
    include("shared.jl")

    test_expr("f() do x end", :do, 4, true)
    test_expr("f() do x,y end", :do, 4, true)
end

@testitem "strings" begin
    include("shared.jl")

    test_expr("a\"txt\"", :macrocall, 3, false)
    test_expr("a\"txt\"b", :macrocall, 4, false)
end


@testitem ":string" begin
    include("shared.jl")

    test_expr("\"\$a\"", :string, 4, false)
    test_expr("\" \$a\"", :string, 4, false)
    test_expr("\" \$a \"", :string, 4, false)
end

@testitem ":for" begin
    include("shared.jl")

    test_expr("for i = I end", :for, 4, true)
    test_expr("for i in I end", :for, 4, true)
    test_expr("for i ∈ I end", :for, 4, true)
    test_expr("for i ∈ I, j in J end", :for, 4, true)
end

@testitem "docs" begin
    include("shared.jl")

    test_expr("\"doc\"\nT", :macrocall, 4, false)
end

@testitem ":generator" begin
    include("shared.jl")

    test_expr("(arg for x in X)", :brackets, 3, true)
    test_expr("(arg for x in X if x)", :brackets, 3, true)
    test_expr("(arg for x in X, y in Y)", :brackets, 3, true)
    test_expr("(arg for x in X, y in Y if x)", :brackets, 3, true)
    test_expr("(arg for x in X for  y in Y)", :brackets, 3, true)
    test_expr("(arg for x in X for  y in Y if x)", :brackets, 3, true)
    test_expr("(arg for x in X for y in Y for z in Z)", :brackets, 3, true)
end

@testitem ":cmd" begin
    include("shared.jl")

    let s = "``"
        x = CSTParser.parse(s)
        x1 = jl_parse(s)
        @test x1 == to_codeobject(x)
    end
    let s = "`a`"
        x = CSTParser.parse(s)
        x1 = jl_parse(s)
        @test x1 == to_codeobject(x)
    end
    let s = "`a \$a`"
        x = CSTParser.parse(s)
        x1 = jl_parse(s)
        @test x1 == to_codeobject(x)
    end
    test_expr("a``", nothing, 3, false)
    test_expr("a`a`", nothing, 3, false)
end

@testitem "macrocall" begin
    include("shared.jl")

    test_expr("@m", :macrocall, 2, false)
    test_expr("@m a", :macrocall, 3, false)
    test_expr("@m(a)", :macrocall, 5, false)
    test_expr("@horner(r) + r", nothing, 3, false)
end

@testitem "_str" begin
    include("shared.jl")

    test_expr("a\"txt\"", :macrocall, 3, false)
    test_expr("a.b\"txt\"", :macrocall, 3, false)
end

@testitem "Parsing files in Base" begin
    include("shared.jl")

    function norm_ast(a::Any)
        if isa(a, Expr)
            for (i, arg) in enumerate(a.args)
                a.args[i] = norm_ast(arg)
            end
            if a.head === :line
                return Expr(:line, a.args[1], :none)
            end
            if a.head === :macrocall
                fa = a.args[1]
                long_enough = length(a.args) >= 3
                if fa === Symbol("@int128_str") && long_enough
                    return Base.parse(Int128, a.args[3])
                elseif fa === Symbol("@uint128_str") && long_enough
                    return Base.parse(UInt128, a.args[3])
                elseif fa === Symbol("@bigint_str") && long_enough
                    return Base.parse(BigInt, a.args[3])
                elseif fa == Symbol("@big_str") && long_enough
                    s = a.args[3]
                    n = tryparse(BigInt, s)
                    if !(n === nothing)
                        return (n)
                    end
                    n = tryparse(BigFloat, s)
                    if !(n === nothing)
                        return isnan((n)) ? :NaN : (n)
                    end
                    return s
                end
            elseif length(a.args) >= 2 && Meta.isexpr(a, :call) && a.args[1] == :- && isa(a.args[2], Number)
                return -a.args[2]
            end
            return a
        elseif isa(a, QuoteNode)
            return Expr(:quote, norm_ast(a.value))
        elseif isa(a, AbstractFloat) && isnan(a)
            return :NaN
        end
        return a
    end

    function meta_parse_has_error(x::Expr)
        if x.head == :incomplete
            return true
        else
            for a in x.args
                if meta_parse_has_error(a)
                    return true
                end
            end
        end
        return false
    end
    meta_parse_has_error(_) = false

    function meta_parse_file(str)
        pos = 1
        x1 = Expr(:file)
        try
            while pos <= sizeof(str)
                x, pos = Meta.parse(str, pos)
                push!(x1.args, x)
            end
        catch er
            isa(er, InterruptException) && rethrow(er)

            return x1, true
        end
        if length(x1.args) > 0 && x1.args[end] === nothing
            pop!(x1.args)
        end
        x1 = norm_ast(x1)
        CSTParser.remlineinfo!(x1)
        return x1, meta_parse_has_error(x1)
    end

    find_error(x, offset=0) =
        if CSTParser.headof(x) === :errortoken
            @show offset
        else
            for a in x
                find_error(a, offset)
                offset += a.fullspan
            end
        end

    function cst_parse_file(str)
        x, ps = CSTParser.parse(CSTParser.ParseState(str), true)
        sp = CSTParser.check_span(x)
        # remove leading/trailing nothings
        if length(x.args) > 0 && CSTParser.is_nothing(x.args[1])
            popfirst!(x.args)
        end

        if !isempty(sp)
            @error "CST spans inconsistent!"
        end

        x0 = norm_ast(to_codeobject(x))
        x0, CSTParser.has_error(ps), isempty(sp)
    end

    _compare(x, y) = x == y

    function _compare(x::Expr, y::Expr)
        if x == y
            return true
        else
            if x.head != y.head || length(x.args) != length(y.args)
                printstyled(x, bold=true, color=:light_red)
                println()
                printstyled(y, bold=true, color=:light_green)
                println()
            end
            for i = 1:min(length(x.args), length(y.args))
                if !_compare(x.args[i], y.args[i])
                    printstyled(x.args[i], bold=true, color=:light_red)
                    println()
                    printstyled(y.args[i], bold=true, color=:light_green)
                    println()
                end
            end
            return false
        end
    end

    if VERSION >= v"1.6"

        dir = joinpath(Sys.BINDIR, Base.DATAROOTDIR)
        for (root, _, files) in walkdir(dir; follow_symlinks=true)
            for fpath in files
                file = joinpath(root, fpath)
                endswith(file, ".jl") || continue

                # filter out irrelevant files, like e.g. ._julia-config.jl in the macos tarballs
                startswith(file, ".") && continue
                startswith(file, "_") && continue

                str = read(file, String)

                isvalid(str) || continue

                @info "parsing $file"

                cst = CSTParser.parse(str, true)
                cst_expr, cst_err, span_err = cst_parse_file(str)
                meta_expr, meta_err = meta_parse_file(str)
                @test cst_err == meta_err
                @test span_err
                @test cst.fullspan == sizeof(str)

                if cst_err || meta_err
                    if cst_err && !meta_err
                        @error "CSTParser.parse errored, but Meta.parse didn't." file
                    elseif !cst_err && meta_err
                        @error "Meta.parse errored, but CSTParser.parse didn't." file
                    end
                    @test false
                else
                    if cst_expr == meta_expr
                        @test true
                    else
                        @error "parsing difference" file = file
                        # _compare(cst_expr, meta_expr)
                        # 1.10 introduced a bunch of changes to the canonical AST, which
                        # CSTParser does not support right now. This does not mean that we
                        # cannot parse that file though, just that Expr conversion doesn't
                        # work well
                        if v"1.10-" <= VERSION < v"1.13-" && basename(file) == "syntax.jl"
                            @test_broken false
                        elseif VERSION >= v"1.12-"
                            @test_broken false
                        else
                            @test false
                        end
                    end
                end
            end
        end
    end
end

@testitem "Imports " begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "import ModA" |> test_expr
    @test "import .ModA" |> test_expr
    @test "import ..ModA.a" |> test_expr
    @test "import ModA.subModA" |> test_expr
    @test "import ModA.subModA: a" |> test_expr
    @test "import ModA.subModA: a, b" |> test_expr
    @test "import ModA.subModA: a, b.c" |> test_expr
    @test "import .ModA.subModA: a, b.c" |> test_expr
    @test "import ..ModA.subModA: a, b.c" |> test_expr
end

@testitem "Export " begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "export ModA" |> test_expr
    @test "export a, b, c" |> test_expr
end

module Iterating
using ..CSTParser: EXPR, headof, hastrivia, isoperator, valof, isstringliteral, is_exor, is_lparen, is_rparen

function Base.getindex(x::EXPR, i)
    try
        a = _getindex(x, i)
        if a === nothing
            error("indexing error for $(x.head) expression at $i")
        end
        return a
    catch
        rethrow()
        error("indexing error for $(x.head) expression at $i. args: $(x.args !== nothing ? headof.(x.args) : []) trivia: $(x.trivia !== nothing ? headof.(x.trivia) : [])")
    end
end

function _getindex(x::EXPR, i)
    if headof(x) === :abstract
        _abstract(x, i)
    elseif headof(x) === :as
        odda_event(x, i)
    elseif headof(x) === :block
        _block(x, i)
    elseif headof(x) === :braces
        _braces(x, i)
    elseif headof(x) === :brackets
        oddt_evena(x, i)
    elseif headof(x) === :call
        _call(x, i)
    elseif headof(x) === :comparison || headof(x) === :file
        x.args[i]
    elseif headof(x) === :comprehension
        tat(x, i)
    elseif headof(x) === :const
        _const(x, i)
    elseif headof(x) === :curly
        _curly(x, i)
    elseif headof(x) === :do
        odda_event(x, i)
    elseif headof(x) === :elseif
        _elseif(x, i)
    elseif headof(x) === :errortoken
        x.args[i]
    elseif headof(x) === :export
        oddt_evena(x, i)
    elseif headof(x) === :public
        oddt_evena(x, i)
    elseif headof(x) === :filter
        _filter(x, i)
    elseif headof(x) === :flatten
        _flatten(x, i)
    elseif headof(x) === :for
        taat(x, i)
    elseif headof(x) === :function || headof(x) === :macro
        _function(x, i)
    elseif headof(x) === :generator
        odda_event(x, i)
    elseif headof(x) === :global || headof(x) === :local
        _global(x, i)
    elseif headof(x) === :if
        if isoperator(first(x.trivia)) # ternary op
            odda_event(x, i)
        else
            _if(x, i)
        end
    elseif headof(x) === :kw
        _kw(x, i)
    elseif headof(x) === :let
        taat(x, i)
    elseif headof(x) === :return
        oddt_evena(x, i)
    elseif headof(x) === :macrocall
        _macrocall(x, i)
    elseif headof(x) === :module
        _module(x, i)
    elseif headof(x) === :outer
        ta(x, i)
    elseif headof(x) === :parameters
        if length(x.args) > 1 && headof(x.args[1]) === :parameters
            if i == length(x)
                x.args[1]
            elseif iseven(i)
                x.trivia[div(i, 2)]
            else
                x.args[div(i + 1, 2) + 1]
            end
        elseif length(x.args) > 1 && headof(x.args[2]) === :parameters
            if i == length(x)
                x.args[2]
            elseif i == 1
                x.args[1]
            elseif isodd(i)
                x.args[div(i + 1, 2) + 1]
            else
                x.trivia[div(i, 2)]
            end
        else
            odda_event(x, i)
        end
        # if hastrivia(x)
        #     odda_event(x, i)
        # else
        #     x.args[i]
        # end
    elseif headof(x) === :primitive
        _primitive(x, i)
    elseif headof(x) === :quote
        _quote(x, i)
    elseif headof(x) === :quotenode
        _quotenode(x, i)
    elseif headof(x) === :ref
        _call(x, i)
    elseif headof(x) === :row || headof(x) === :nrow
        x.args[i]
    elseif headof(x) === :string
        _string(x, i)
    elseif headof(x) === :struct
        _struct(x, i)
    elseif headof(x) === :toplevel
        x.args[i]
    elseif headof(x) === :try
        _try(x, i)
    elseif headof(x) === :tuple
        _tuple(x, i)
    elseif headof(x) === :typed_comprehension
        odda_event(x, i)
    elseif headof(x) === :typed_vcat || headof(x) === :typed_hcat || headof(x) === :typed_ncat
        _typed_vcat(x, i)
    elseif headof(x) === :using || headof(x) === :import
        _using(x, i)
    elseif headof(x) === :vcat || headof(x) === :hcat || headof(x) === :ncat || headof(x) === :bracescat
        _vcat(x, i)
    elseif headof(x) === :vect
        _vect(x, i)
    elseif headof(x) === :where
        _where(x, i)
    elseif headof(x) === :while
        taat(x, i)
    elseif isoperator(headof(x))
        if valof(headof(x)) == ":"
            _colon_in_using(x, i)
        elseif valof(headof(x)) == "."
            _dot(x, i)
        elseif valof(headof(x)) == "=" && hastrivia(x)
            # a loop that has been lowered from in/∈ to = at parse time
            if i == 1
                x.args[1]
            elseif i == 2
                x.trivia[1]
            elseif i == 3
                x.args[2]
            end
        elseif valof(headof(x)) == "->" && headof(x).fullspan == 0
            # anon function as used in a 'do' block
            if i == 1
                x.args[1]
            else
                x.args[2]
            end
        elseif length(x) == 2 && (valof(headof(x)) == "\$" || valof(headof(x)) == "::" || valof(headof(x)) == "<:" || valof(headof(x)) == ">:"  || valof(headof(x)) == "&")
            if i == 1
                x.head
            else
                x.args[1]
            end
        elseif !hastrivia(x)
            if i == 1
                x.args[1]
            elseif i == 2
                x.head
            elseif i == 3
                x.args[2]
            end
        else
            if i == 1
                x.head
            elseif i == 2
                x.trivia[1]
            elseif i == length(x)
                last(x.trivia)
            elseif isodd(i)
                x.args[div(i+1, 2) - 1]
            else
                x.trivia[div(i, 2)]
            end
        end
    else
        error("Indexing $x at $i")
    end
end
Base.iterate(x::EXPR) = length(x) == 0 ? nothing : (x[1], 1)
Base.iterate(x::EXPR, s) = s < length(x) ? (x[s + 1], s + 1) : nothing
Base.firstindex(x::EXPR) = 1
Base.lastindex(x::EXPR) = x.args === nothing ? 0 : length(x)

# Base.setindex!(x::EXPR, val, i) = Base.setindex!(x.args, val, i)
# Base.first(x::EXPR) = x.args === nothing ? nothing : first(x.args)
# Base.last(x::EXPR) = x.args === nothing ? nothing : last(x.args)


function ta(x, i)
    if i == 1
        x.trivia[1]
    elseif i == 2
        x.args[1]
    end
end
function tat(x, i)
    if i == 1
        x.trivia[1]
    elseif i == 2
        x.args[1]
    elseif i == 3
        x.trivia[2]
    end
end

function taat(x, i)
    if i == 1
        x.trivia[1]
    elseif i == 2
        x.args[1]
    elseif i == 3
        x.args[2]
    elseif i == 4
        x.trivia[2]
    end
end


function oddt_evena(x, i)
    if isodd(i)
        x.trivia[div(i + 1, 2)]
    else
        x.args[div(i, 2)]
    end
end

function odda_event(x, i)
    if isodd(i)
        x.args[div(i + 1, 2)]
    else
        x.trivia[div(i, 2)]
    end
end


function _const(x, i)
    if length(x.trivia) === 1
        ta(x, i)
    elseif length(x.trivia) === 2
        #global const
        if i < 3
            x.trivia[i]
        elseif i == 3
            x.args[1]
        end
    end
end

function _global(x, i)
    if length(x.trivia) > length(x.args) # probably :tuple
        if i <= 2
            x.trivia[i]
        elseif isodd(i)
            ai = div(i - 1, 2)
            if ai > length(x.args) # trailing comma
                x.trivia[div(i - 1, 2) + 2]
            else
                x.args[ai]
            end
        else
            x.trivia[div(i - 2, 2) + 2]
        end
    else
        if hastrivia(x) && (headof(first(x.trivia)) === :GLOBAL || headof(first(x.trivia)) === :LOCAL)
            oddt_evena(x, i)
        else
            odda_event(x, i)
        end
    end
end

function _abstract(x, i)
    if i < 3
        x.trivia[i]
    elseif i == 3
        x.args[1]
    elseif i == 4
        x.trivia[3]
    end
end

function _primitive(x, i)
    if i < 3
        x.trivia[i]
    elseif i == 3
        x.args[1]
    elseif i == 4
        x.args[2]
    elseif i == 5
        x.trivia[3]
    end
end

function _struct(x, i)
    if length(x.trivia) == 2
        if i == 1
            x.trivia[1]
        elseif 1 < i < 5
            x.args[i - 1]
        elseif i == 5
            x.trivia[2]
        end
    elseif length(x.trivia) == 3 # mutable
        if i < 3
            x.trivia[i]
        elseif 2 < i < 6
            x.args[i - 2]
        elseif i == 6
            x.trivia[3]
        end
    end
end

function _block(x, i)
    if hastrivia(x) # We have a begin block
        if headof(x.trivia[1]) === :BEGIN
            if i == 1
                x.trivia[1]
            elseif 1 < i < length(x)
                x.args[i - 1]
            elseif i == length(x)
                x.trivia[2]
            end
        elseif headof(x.trivia[1]) === :COMMA # comma sep list as in :let block or iterators
            odda_event(x, i)
        end
    else
        x.args[i]
    end
end

function _quote(x, i)
    if x.trivia !== nothing && length(x.trivia) == 1
        if i == 1
            x.trivia[1]
        elseif i == 2
            x.args[1]
        end
    elseif x.trivia !== nothing && length(x.trivia) == 2
        tat(x, i)
    elseif x.trivia === nothing
        x.args[i]
    else
        error()
    end
end

function _quotenode(x, i)
    if hastrivia(x)
        if i == 1
            x.trivia[1]
        elseif i == 2
            x.args[1]
        end
    elseif i == 1
        x.args[1]
    end
end

function _function(x, i)
    if length(x.args) == 1
        tat(x, i)
    else length(x.args) == 2
        taat(x, i)
    end
end

function _braces(x, i)
    if length(x.args) > 0 && headof(x.args[1]) === :parameters
        if i == 1
            x.trivia[1]
        elseif i == length(x)
            last(x.trivia)
        elseif i == length(x) - 1
            x.args[1]
        elseif iseven(i)
            x.args[div(i, 2) + 1]
        else
            x.trivia[div(i + 1, 2)]
        end
    else
        if i == length(x)
            last(x.trivia)
        else
            oddt_evena(x, i)
        end
    end
end

function _curly(x, i)
    if i == 1
        x.args[1]
    elseif i == length(x)
        last(x.trivia)
    elseif length(x.args) > 1 && headof(x.args[2]) === :parameters
        if i == length(x) - 1
            x.args[2]
        elseif isodd(i)
            x.args[div(i + 1, 2) + 1]
        else
            x.trivia[div(i, 2)]
        end
    else
        if isodd(i)
            x.args[div(i + 1, 2)]
        else
            x.trivia[div(i, 2)]
        end
    end
end

function _using(x, i)
    oddt_evena(x, i)
end

function _colon_in_using(x, i)
    if i == 1
        x.args[1]
    elseif i == 2
        x.head
    elseif isodd(i)
        x.args[div(i + 1, 2)]
    else
        x.trivia[div(i, 2) - 1]
    end
end

function count_continuous(f, itr)
    cnt = 0
    for x in itr
        !f(x) && break
        cnt += 1
    end
    return cnt
end

function _dot(x, i)
    if x.head.span == 0 # Empty dot op, in using statement
        ndots = count_continuous(a -> valof(a) == ".", x.args)
        if i <= ndots
            x.args[i]
        elseif iseven(ndots)
            if isodd(i)
                x.args[ndots + div(i - ndots + 1, 2)]
            else
                x.trivia[div(i - ndots, 2)]
            end
        else
            if iseven(i)
                x.args[ndots + div(i - ndots + 1, 2)]
            else
                x.trivia[div(i - ndots, 2)]
            end
        end
    elseif length(x) == 2
        if i == 1
            x.head
        elseif i == 2
            x.args[1]
        end
    else
        if i == 1
            x.args[1]
        elseif i == 2
            x.head
        elseif i == 3
            x.args[2]
        end
    end
end

function _call(x, i)
    if isoperator(x.args[1])
        if length(x) == 2 # unary op call
            x.args[i]
        elseif length(x) == 3 && !hastrivia(x)# binary
            if i == 1
                x.args[2]
            elseif i == 2
                x.args[1]
            elseif i == 3
                x.args[3]
            end
        elseif hastrivia(x) && headof(x.trivia[1]) === :LPAREN # op call w/ brackets
            _curly(x, i)
        else # chained call: a + b + c + d + ...
            if i == 1
                x.args[2]
            elseif i == 2
                x.args[1]
            elseif i == 3
                x.args[3]
            elseif hastrivia(x)
                if iseven(i)
                    x.trivia[div(i - 2, 2)]
                else
                    x.args[div(i - 3, 2) + 3]
                end
            end
        end
    elseif hastrivia(x)
        _curly(x, i)
    else
        x.args[i]
    end
end

function _kw(x, i)
    if i == 1
        x.args[1]
    elseif i == 2
        x.trivia[1]
    elseif i == 3
        x.args[2]
    end
end

function _tuple(x, i)
    hasparams = x.args !== nothing && length(x.args) > 0 && headof(x.args[1]) === :parameters
    if hasparams
        if i == 1
            first(x.trivia)
        elseif i == length(x)
            last(x.trivia)
        elseif i == length(x) - 1
            first(x.args)
        elseif isodd(i)
            x.trivia[div(i + 1, 2)]
        else
            x.args[div(i, 2) + 1]
        end
    else
        if isempty(x.args)
            x.trivia[i]
        elseif hastrivia(x)
            if first(x.trivia).head === :LPAREN
                if i == length(x)
                    last(x.trivia)
                else
                    oddt_evena(x, i)
                end
            else
                odda_event(x, i)
            end
        else
            x.args[i]
        end
        # if isempty(x.args)
        #     x.trivia[i]
        # elseif length(x.trivia) == length(x.args) - 1  # No brackets, no trailing comma
        #     odda_event(x, i)
        # elseif length(x.trivia) - 1 == length(x.args) # Brackets, no trailing comma
        #     oddt_evena(x, i)
        # elseif length(x.trivia) - 2 == length(x.args) # Brackets, trailing comma
        #     if i == length(x)
        #         last(x.trivia)
        #     elseif i == length(x) - 1
        #         x.trivia[end-1]
        #     else
        #         oddt_evena(x, i)
        #     end
        # else
        #     odda_event(x, i)
        # end
    end
end

function _if(x, i)
    if length(x) == 4 # if c expr end
        taat(x, i)
    elseif length(x) == 5 # if c expr elseif... end
    if i == 1
        x.trivia[1]
    elseif i == 2
        x.args[1]
    elseif i == 3
        x.args[2]
    elseif i == 4
        x.args[3]
    elseif i == 5
        x.trivia[2]
    end
    elseif length(x) == 6 # if c expr else expr end
        if i == 1
            x.trivia[1]
        elseif i == 2
            x.args[1]
        elseif i == 3
            x.args[2]
        elseif i == 4
            x.trivia[2]
        elseif i == 5
            x.args[3]
        elseif i == 6
            x.trivia[3]
        end
    end
end

function _elseif(x, i)
    if length(x) == 3 || length(x) == 5
        if i == 1
            x.trivia[1]
        elseif i == 2
            x.args[1]
        elseif i == 3
            x.args[2]
        elseif i == 4
            x.trivia[2]
        elseif i == 5
            x.args[3]
        end
    elseif length(x) == 4
        if i == 1
            x.trivia[1]
        else
            x.args[i - 1]
        end
    end
end

function _string(x, i)
    # TODO: this is mega slow
    ai, ti = 1,1
    arg = isstringliteral(x.args[1])# && sizeof(valof(x.args[1])) !== x.args[1].fullspan
    isinterpolant = !arg
    bracket = false
    if hastrivia(x) && (x.trivia[1].head === :STRING || x.trivia[1].head === :TRIPLESTRING) && isempty(x.trivia[1].val)
        if i == 1
            return x.trivia[1]
        end
        arg = false
    end
    if i == length(x) && hastrivia(x) && (last(x.trivia).head === :STRING || last(x.trivia).head === :TRIPLESTRING || last(x.trivia).head === :errortoken) && isempty(last(x.trivia).val)
        return last(x.trivia)
    end
    for j = 1:i
        if j == i
            return arg ? x.args[ai] : x.trivia[ti]
        end

        if arg
            ai += 1
            if isinterpolant
                arg = !bracket
                if ai <= length(x.args) && !(isstringliteral(x.args[ai]) || x.args[ai].head === :errortoken)
                    # interpolated value immediately followed by xor
                    arg = false
                end
                bracket = false
                isinterpolant = false

            else
                arg = false
            end
        else
            if is_exor(x.trivia[ti]) || (x.trivia[ti].head === :errortoken && x.trivia[ti].args[1].head === :OPERATOR && valof(x.trivia[ti].args[1]) == "\$")
                if ti < length(x.trivia) && is_lparen(x.trivia[ti + 1])
                    #
                else
                    isinterpolant = true
                    arg = true
                end
            elseif is_lparen(x.trivia[ti])
                isinterpolant = true
                arg = true
                bracket = true
            elseif is_rparen(x.trivia[ti])
                isinterpolant = false
                arg = !(ai <= length(x.args) && !(isstringliteral(x.args[ai])) || x.args[ai].head == :errortoken)
                bracket = false
            end
            ti += 1
        end
    end
end

function _macrocall(x, i)
    if !hastrivia(x)
        x.args[i]
    else
        if i < 3
            x.args[i]
        elseif i == length(x)
            last(x.trivia)
        elseif length(x.args) > 2 && headof(x.args[3]) === :parameters
            if i == length(x) - 1
                x.args[3]
            elseif i == length(x)
                last(x.trivia)
            elseif isodd(i)
                x.trivia[div(i, 2)]
            else
                x.args[div(i + 1, 2) + 2]
            end
        else
            if isodd(i)
                x.trivia[div(i, 2)]
            else
                x.args[div(i + 1, 2) + 1]
            end
        end
    end
end

function _vect(x, i)
    _braces(x, i)
end

function _vcat(x, i)
    if i == 1
        x.trivia[1]
    elseif i == length(x)
        x.trivia[2]
    elseif (i-1) > length(x.args)
        # TODO Remove once we have figured out what is causing this bug
        error("Illegal indexing into CSTParser. x.head: '$(x.head)', x.trivia: '$(x.trivia)', x.args: '$(x.args)'.")
    else
        x.args[i - 1]
    end
end

function _typed_vcat(x, i)
    if i == 1
        x.args[1]
    elseif i == 2
        x.trivia[1]
    elseif i == length(x)
        x.trivia[2]
    else
        x.args[i - 1]
    end

end

function _module(x, i)
    if i == 1
        x.trivia[1]
    elseif i == 2
        x.args[1]
    elseif i == 3
        x.args[2]
    elseif i == 4
        x.args[3]
    elseif i == 5
        x.trivia[2]
    end
end

function _filter(x, i)
    if i == length(x)
        x.args[1]
    elseif iseven(i)
        x.trivia[div(i, 2)]
    else
        x.args[div(i + 1, 2) + 1]
    end
end

function _try(x, i)
    if i == 1
        x.trivia[1]
    elseif i == 2
        x.args[1]
    elseif length(x) == 6 # try expr catch e expr end
        if i == 3
            x.trivia[2]
        elseif i == 4
            x.args[2]
        elseif i == 5
            x.args[3]
        elseif i == 6
            x.trivia[3]
        end
    elseif length(x) == 7 # try expr catch finally end
        if i == 3
            x.args[2]
        elseif i == 4
            x.args[3]
        elseif i == 5
            x.trivia[2]
        elseif i == 6
            x.args[4]
        elseif i == 7
            x.trivia[3]
        end
    elseif length(x) == 8 # 'try expr catch e expr finally expr end' or 'else end'
        if i == 3
            x.trivia[2]
        elseif i == 4
            x.args[2]
        elseif i == 5
            x.args[3]
        elseif i == 6
            x.trivia[3]
        elseif i == 7
            x.args[4]
        elseif i == 8
            x.trivia[4]
        end
    elseif length(x) == 10 # try expr catch e expr else expr finally expr end
        if i == 3
            x.trivia[2]
        elseif i == 4
            x.args[2]
        elseif i == 5
            x.args[3]
        elseif i == 6
            x.trivia[4]
        elseif i == 7
            x.args[5]
        elseif i == 8
            x.trivia[3]
        elseif i == 9
            x.args[4]
        elseif i == 10
            x.trivia[5]
        end
    end
end

function _where(x, i)
    if i == 1
        x.args[1]
    elseif i == 2
        x.trivia[1]
    elseif i == 3 && length(x) == 3 && length(x.trivia) == 1
        return x.args[2]
    elseif i == length(x)
        last(x.trivia)
    elseif length(x.args) > 1 && headof(x.args[2]) === :parameters
        if i == length(x) - 1
            x.args[2]
        elseif isodd(i)
            x.trivia[div(i + 1, 2)]
        else
            x.args[div(i, 2) + 1]
        end
    else
        oddt_evena(x, i)
    end
end


function _flatten(x, i)
    lhs = _flatten_lhs(x)
    lhs[i]
end

function _flatten_lhs(x, ret = [])
    if x.args[1].head === :generator || x.args[1].head === :flatten
        if headof(x) !== :flatten
            for i = 2:length(x)
                push!(ret, x[i])
            end
        end
        _flatten_lhs(x.args[1], ret)
    else
        for i = 2:length(x)
            push!(ret, x[i])
        end
        pushfirst!(ret, x.args[1])
    end
end

end

module CSTParser

using Tokenize
import Tokenize.Tokens
import Tokenize.Tokens: RawToken, AbstractToken, iskeyword, isliteral, isoperator, untokenize
import Tokenize.Lexers: Lexer, peekchar, iswhitespace, readchar, emit, emit_error,  accept_batch, eof

include("packagedef.jl")

end

function accept_rparen(ps)
    if kindof(ps.nt) === Tokens.RPAREN
        return EXPR(next(ps))
    else
        return mErrorToken(ps, EXPR(:RPAREN, 0, 0), UnexpectedToken)
    end
end
accept_rparen(ps::ParseState, args) = push!(args, accept_rparen(ps))

function accept_rsquare(ps)
    if kindof(ps.nt) === Tokens.RSQUARE
        return EXPR(next(ps))
    else
        return mErrorToken(ps, EXPR(:RSQUARE, 0, 0), UnexpectedToken)
    end
end
accept_rsquare(ps::ParseState, args) = push!(args, accept_rsquare(ps))

function accept_rbrace(ps)
    if kindof(ps.nt) === Tokens.RBRACE
        return EXPR(next(ps))
    else
        return mErrorToken(ps, EXPR(:RBRACE, 0, 0), UnexpectedToken)
    end
end
accept_rbrace(ps::ParseState, args) = push!(args, accept_rbrace(ps))

function accept_end(ps::ParseState)
    if kindof(ps.nt) === Tokens.END
        return EXPR(next(ps))
    else
        return mErrorToken(ps, EXPR(:END, 0, 0), UnexpectedToken)
    end
end
accept_end(ps::ParseState, args) = push!(args, accept_end(ps))

function accept_comma(ps)
    if iscomma(ps.nt)
        return EXPR(next(ps))
    else
        return EXPR(:RPAREN, 0, 0)
    end
end
accept_comma(ps::ParseState, args) = push!(args, accept_comma(ps))

function requires_ws(x, ps)
    if x.span == x.fullspan
        return mErrorToken(ps, x, Unknown)
    else
        return x
    end
end

function requires_no_ws(x, ps)
    if !(kindof(ps.nt) === Tokens.RPAREN ||
        kindof(ps.nt) === Tokens.RBRACE ||
        kindof(ps.nt) === Tokens.RSQUARE || kindof(ps.nt) === Tokens.END) && x.span != x.fullspan
        return mErrorToken(ps, x, UnexpectedWhiteSpace)
    else
        return x
    end
end

@testitem "Simple Calls" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "f(x)" |> test_expr
    @test "f(x,y)" |> test_expr
    @test "f(g(x))" |> test_expr
    @test "f((x,y))" |> test_expr
    @test "f((x,y), z)" |> test_expr
    @test "f(z, (x,y), z)" |> test_expr
    @test "f{a}(x)" |> test_expr
    @test "f{a<:T}(x::T)" |> test_expr
end

@testitem "Keyword Arguments" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "f(x=1)" |> test_expr
    @test "f(x=1,y::Int = 1)" |> test_expr
end

@testitem "Compact Declaration" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "f(x) = x" |> test_expr
    @test "f(x) = g(x)" |> test_expr
    @test "f(x) = (x)" |> test_expr
    @test "f(x) = (x;y)" |> test_expr
    @test "f(g(x)) = x" |> test_expr
    @test "f(g(x)) = h(x)" |> test_expr
end

@testitem "Standard Declaration" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "function f end" |> test_expr
    @test "function f(x) x end" |> test_expr
    @test "function f(x); x; end" |> test_expr
    @test "function f(x) x; end" |> test_expr
    @test "function f(x); x end" |> test_expr
    @test "function f(x) x;y end" |> test_expr
    @test """function f(x) x end""" |> test_expr
    @test """function f(x,y =1) x end""" |> test_expr
    @test """function f(x,y =1;z =2) x end""" |> test_expr
end
@testitem "Anonymous" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "x->y" |> test_expr
    @test "(x,y)->x*y" |> test_expr
    @test """function ()
        return
    end""" |> test_expr
    @test """
    function (a,b)
        a+b
    end
    """ |> test_expr
    @test """
    function (a,b;c=2)
        a+b
    end
    """ |> test_expr
    @test """
    function (a,b;c)
        a+b
    end
    """ |> test_expr
    @test """
    function (;a,b=2)
        a+b
    end
    """ |> test_expr
    @test """
    function (b=2)
        a+b
    end
    """ |> test_expr
end

using TestItemRunner

include("iterate/test_iterators.jl")
include("iterate/test_selftest.jl")
include("parser/test_function_calls.jl")
include("parser/test_keyword_blocks.jl")
include("parser/test_modules.jl")
include("parser/test_operators.jl")
include("parser/test_parser.jl")
include("parser/test_square.jl")
include("parser/test_types.jl")
include("test_check_base.jl")
include("test_display.jl")
include("test_errparse.jl")
include("test_interface.jl")
include("test_spec.jl")

@run_package_tests

# Operator hierarchy
const AssignmentOp  = 1
const ConditionalOp = 2
const ArrowOp       = 3
const LazyOrOp      = 4
const LazyAndOp     = 5
const ComparisonOp  = 6
const PipeOp        = 7
const ColonOp       = 8
const PlusOp        = 9
@static if Base.operator_precedence(:<<) == 12
    const BitShiftOp    = 10
    const TimesOp       = 11
    const RationalOp    = 12
else
    const TimesOp       = 10
    const RationalOp    = 11
    const BitShiftOp    = 12
end
const PowerOp       = 13
const DeclarationOp = 14
const WhereOp       = 15
const DotOp         = 16
const PrimeOp       = 16
const DddotOp       = 7
const AnonFuncOp    = 14

@enum(ErrorKind,
    UnexpectedToken,
    CannotJuxtapose,
    UnexpectedWhiteSpace,
    UnexpectedNewLine,
    ExpectedAssignment,
    UnexpectedAssignmentOp,
    MissingConditional,
    MissingCloser,
    MissingColon, # We didn't get a colon (`:`) when we expected to while parsing a `?` expression.
    InvalidIterator,
    StringInterpolationWithTrailingWhitespace,
    InvalidChar,
    EmptyChar,
    InvalidString,
    Unknown,
    SignatureOfFunctionDefIsNotACall,
    MalformedMacroName)

"""
`EXPR` represents Julia expressions overlaying a span of bytes in the source
text. The full span starts at the first syntactically significant token and
includes any trailing whitespace/comments.

Iterating or directly indexing `EXPR` results in a sequence of child `EXPR` in
source order, including most syntax trivia but not including whitespace,
comments and semicolons.

The fields of `EXPR` are:

* `head` represents the type of the expression
  - For internal tree nodes it usually matches the associated `Expr`'s head
    field. But not always because there's some additional heads, for example
    `:brackets` for grouping parentheses, `:globalrefdoc`, `:quotenode`, etc
  - For leaf nodes (ie, individual tokens), it's capitalized. Eg,
    `:INTEGER` for integer tokens, `:END` for `end`, `:LPAREN` for `[`,
    etc.
  - For syntactic operators such as `=` and `<:` (which have the operator
    itself as the expression head in normal `Expr`), the head is an `EXPR`.

* `args` are the significant subexpressions, in the order used by `Base.Expr`.
   For leaf nodes, this is `nothing`.

* `trivia` are any nontrivial tokens which are trivial after parsing.
  - This includes things like the parentheses in `(1 + 2)`, and the
    keywords in `begin x end`
  - Whitespace and comments are not included in `trivia`

* `fullspan` is the total number of bytes of text covered by this expression,
  including any trailing whitespace or comment trivia.

* `span` is the number of bytes of text covered by the syntactically
    relevant part of this expression (ie, not including trailing whitespace
    or comment trivia).

* `val` is the source text covered by `span`

* `parent` is the parent node in the expression tree, or `Nothing` for the root.

* `meta` contains metadata. This includes some ad-hoc information supplied by
  the parser. (But can also be used downstream in linting or static analysis.)

Whitespace, comments and semicolons are not represented explicitly. Rather,
they're tacked onto the end of leaf tokens in `args` or `trivia`, in the last
`fullspan-span` bytes of the token.
"""
mutable struct EXPR
    head::Union{Symbol,EXPR}
    args::Union{Nothing,Vector{EXPR}}
    trivia::Union{Nothing,Vector{EXPR}}
    fullspan::Int
    span::Int
    val::Union{Nothing,String}
    parent::Union{Nothing,EXPR}
    meta
end

function EXPR(head::Union{Symbol,EXPR}, args::Vector{EXPR}, trivia::Union{Vector{EXPR},Nothing}, fullspan::Int, span::Int)
    ex = EXPR(head, args, trivia, fullspan, span, nothing, nothing, nothing)
    if head isa EXPR
        setparent!(head, ex)
    end
    for c in args
        setparent!(c, ex)
    end
    if trivia isa Vector{EXPR}
        for c in trivia
            setparent!(c, ex)
        end
    end
    ex
end

function EXPR(head::Union{Symbol,EXPR}, args::Vector{EXPR}, trivia::Union{Vector{EXPR},Nothing} = EXPR[])
    ret = EXPR(head, args, trivia, 0, 0)
    update_span!(ret)
    ret
end

# These methods are for terminal/childless expressions.
@noinline EXPR(head::Union{Symbol,EXPR}, fullspan::Int, span::Int, val = nothing) = EXPR(head, nothing, nothing, fullspan, span, val, nothing, nothing)
@noinline EXPR(head::Union{Symbol,EXPR}, ps::ParseState) = EXPR(head, ps.nt.startbyte - ps.t.startbyte, ps.t.endbyte - ps.t.startbyte + 1, val(ps.t, ps))
@noinline EXPR(ps::ParseState) = EXPR(tokenkindtoheadmap(kindof(ps.t)), ps)

@noinline function mLITERAL(ps::ParseState)
    if kindof(ps.t) === Tokens.STRING || kindof(ps.t) === Tokens.TRIPLE_STRING ||
        kindof(ps.t) === Tokens.CMD || kindof(ps.t) === Tokens.TRIPLE_CMD
        return parse_string_or_cmd(ps)
    else
        v = val(ps.t, ps)
        if kindof(ps.t) === Tokens.CHAR && length(v) > 3 && !(v[2] == '\\' && valid_escaped_seq(v[2:prevind(v, end)]))
            return mErrorToken(ps, EXPR(:CHAR, ps.nt.startbyte - ps.t.startbyte, ps.t.endbyte - ps.t.startbyte + 1, string(v[1:2], '\'')), InvalidChar)
        elseif kindof(ps.t) === Tokens.CHAR && length(v) == 2
            return mErrorToken(ps, EXPR(:CHAR, ps.nt.startbyte - ps.t.startbyte, ps.t.endbyte - ps.t.startbyte + 1, string(v[1:2], '\'')), EmptyChar)
        end
        return EXPR(literalmap(kindof(ps.t)), ps.nt.startbyte - ps.t.startbyte, ps.t.endbyte - ps.t.startbyte + 1, v)
    end
end

span(x::EXPR) = x.span

function update_span!(x::EXPR)
    (x.args isa Nothing || isempty(x.args)) && !hastrivia(x) && return
    x.fullspan = 0
    for i = 1:length(x.args)
        x.fullspan += x.args[i].fullspan
    end
    if hastrivia(x)
        for i = 1:length(x.trivia)
            x.fullspan += x.trivia[i].fullspan
        end
    end
    if x.head isa EXPR
        x.fullspan += x.head.fullspan
        # TODO: special case for trailing unary ops?
    end
    if x.head isa EXPR && isoperator(x.head) && (is_dddot(x.head) || is_prime(x.head))
        # trailing unary operator
        x.span  = x.fullspan - x.head.fullspan + x.head.span
    elseif hastrivia(x) && lastchildistrivia(x)
        x.span = x.fullspan - last(x.trivia).fullspan + last(x.trivia).span
    elseif !isempty(x.args)
        x.span = x.fullspan - last(x.args).fullspan + last(x.args).span
    end
    return
end

function Base.push!(e::EXPR, arg::EXPR)
    e.span = e.fullspan + arg.span
    e.fullspan += arg.fullspan
    setparent!(arg, e)
    push!(e.args, arg)
end

function pushtotrivia!(e::EXPR, arg::EXPR)
    e.span = e.fullspan + arg.span
    e.fullspan += arg.fullspan
    setparent!(arg, e)
    push!(e.trivia, arg)
end

function Base.pushfirst!(e::EXPR, arg::EXPR)
    e.fullspan += arg.fullspan
    setparent!(arg, e)
    pushfirst!(e.args, arg)
end

function Base.pop!(e::EXPR)
    arg = pop!(e.args)
    e.fullspan -= arg.fullspan
    if isempty(e.args)
        e.span = 0
    else
        e.span = e.fullspan - last(e.args).fullspan + last(e.args).span
    end
    arg
end

function Base.append!(e::EXPR, args::Vector{EXPR})
    append!(e.args, args)
    for arg in args
        setparent!(arg, e)
    end
    update_span!(e)
end

function Base.append!(a::EXPR, b::EXPR)
    append!(a.args, b.args)
    for arg in b.args
        setparent!(arg, a)
    end
    a.fullspan += b.fullspan
    a.span = a.fullspan + last(b.span)
end


function INSTANCE(ps::ParseState)
    if isidentifier(ps.t)
        return EXPR(:IDENTIFIER, ps)
    elseif isliteral(ps.t)
        return mLITERAL(ps)
    elseif iskeyword(ps.t)
        return EXPR(ps)
    elseif isoperator(ps.t)
        return EXPR(:OPERATOR, ps)
    elseif ispunctuation(ps.t)
        return EXPR(ps)
    elseif kindof(ps.t) === Tokens.ERROR
        ps.errored = true
        return EXPR(:errortoken, nothing, nothing, ps.nt.startbyte - ps.t.startbyte, ps.t.endbyte - ps.t.startbyte + 1, val(ps.t, ps), nothing, Unknown)
    else
        return mErrorToken(ps, Unknown)
    end
end

function mErrorToken(ps::ParseState, k::ErrorKind)
    ps.errored = true
    return EXPR(:errortoken, EXPR[], nothing, 0, 0, nothing, nothing, k)
end
function mErrorToken(ps::ParseState, x::EXPR, k)
    ps.errored = true
    ret = EXPR(:errortoken, EXPR[x], nothing, x.fullspan, x.span, nothing, nothing, k)
    setparent!(ret.args[1], ret)
    return ret
end


headof(x::EXPR) = x.head
valof(x::EXPR) = x.val
kindof(t::Tokens.AbstractToken) = t.kind
parentof(x::EXPR) = x.parent
errorof(x::EXPR) = errorof(x.meta)
errorof(x) = x

function setparent!(c, p)
    c.parent = p
    return c
end
hastrivia(x::EXPR) = x.trivia !== nothing && length(x.trivia) > 0

function lastchildistrivia(x::EXPR)

    if headof(x) === :string
        isstringliteral(last(x.trivia)) && sizeof(valof(last(x.trivia))) < last(x.trivia).span
        # This section checks whether last trivia stringliteral has a span that accounts for closing quotation mark(s)
    else
        hastrivia(x) && (last(x.trivia).head in (:END, :RPAREN, :RSQUARE, :RBRACE) || (x.head in (:parameters, :tuple) && length(x.args) <= length(x.trivia)))
    end
end

function Base.length(x::EXPR)
    headof(x) === :NONSTDIDENTIFIER && return 0
    headof(x) === :flatten && return length(Iterating._flatten_lhs(x))
    n = x.args === nothing ? 0 : length(x.args)
    n += x.trivia === nothing ? 0 : length(x.trivia)
    x.head isa EXPR && !(x.head.span === 0) && (n += 1)
    return n
end

function literalmap(k::Tokens.Kind)
    if k === Tokens.INTEGER
        return :INTEGER
    elseif k === Tokens.BIN_INT
        return :BININT
    elseif k === Tokens.HEX_INT
        return :HEXINT
    elseif k === Tokens.OCT_INT
        return :OCTINT
    elseif k === Tokens.FLOAT
        return :FLOAT
    elseif k === Tokens.STRING
        return :STRING
    elseif k === Tokens.TRIPLE_STRING
        return :TRIPLESTRING
    elseif k === Tokens.CHAR
        return :CHAR
    elseif k === Tokens.CMD
        return :CMD
    elseif k === Tokens.TRIPLE_CMD
        return :TRIPLECMD
    elseif k === Tokens.TRUE
        return :TRUE
    elseif k === Tokens.FALSE
        return :FALSE
    end
end



function tokenkindtoheadmap(k::Tokens.Kind)
    if k == Tokens.COMMA
        :COMMA
    elseif k == Tokens.LPAREN
        :LPAREN
    elseif k == Tokens.RPAREN
        :RPAREN
    elseif k == Tokens.LSQUARE
        :LSQUARE
    elseif k == Tokens.RSQUARE
        :RSQUARE
    elseif k == Tokens.LBRACE
        :LBRACE
    elseif k == Tokens.RBRACE
        :RBRACE
    elseif k == Tokens.AT_SIGN
        :ATSIGN
    elseif k == Tokens.DOT
        :DOT
    elseif k === Tokens.ABSTRACT
        return :ABSTRACT
    elseif k === Tokens.BAREMODULE
        return :BAREMODULE
    elseif k === Tokens.BEGIN
        return :BEGIN
    elseif k === Tokens.BREAK
        return :BREAK
    elseif k === Tokens.CATCH
        return :CATCH
    elseif k === Tokens.CONST
        return :CONST
    elseif k === Tokens.CONTINUE
        return :CONTINUE
    elseif k === Tokens.DO
        return :DO
    elseif k === Tokens.ELSE
        return :ELSE
    elseif k === Tokens.ELSEIF
        return :ELSEIF
    elseif k === Tokens.END
        return :END
    elseif k === Tokens.EXPORT
        return :EXPORT
    elseif k === Tokens.FINALLY
        return :FINALLY
    elseif k === Tokens.FOR
        return :FOR
    elseif k === Tokens.FUNCTION
        return :FUNCTION
    elseif k === Tokens.GLOBAL
        return :GLOBAL
    elseif k === Tokens.IF
        return :IF
    elseif k === Tokens.IMPORT
        return :IMPORT
    elseif k === Tokens.IMPORTALL
        return :importall
    elseif k === Tokens.LET
        return :LET
    elseif k === Tokens.LOCAL
        return :LOCAL
    elseif k === Tokens.MACRO
        return :MACRO
    elseif k === Tokens.MODULE
        return :MODULE
    elseif k === Tokens.MUTABLE
        return :MUTABLE
    elseif k === Tokens.NEW
        return :NEW
    elseif k === Tokens.OUTER
        return :OUTER
    elseif k === Tokens.PRIMITIVE
        return :PRIMITIVE
    elseif k === Tokens.PUBLIC
        return :PUBLIC
    elseif k === Tokens.QUOTE
        return :QUOTE
    elseif k === Tokens.RETURN
        return :RETURN
    elseif k === Tokens.STRUCT
        return :STRUCT
    elseif k === Tokens.TRY
        return :TRY
    elseif k === Tokens.TYPE
        return :TYPE
    elseif k === Tokens.USING
        return :USING
    elseif k === Tokens.WHILE
        return :WHILE
    elseif k === Tokens.INTEGER
        return :INTEGER
    elseif k === Tokens.BIN_INT
        return :BININT
    elseif k === Tokens.HEX_INT
        return :HEXINT
    elseif k === Tokens.OCT_INT
        return :OCTINT
    elseif k === Tokens.FLOAT
        return :FLOAT
    elseif k === Tokens.STRING
        return :STRING
    elseif k === Tokens.TRIPLE_STRING
        return :TRIPLESTRING
    elseif k === Tokens.CHAR
        return :CHAR
    elseif k === Tokens.CMD
        return :CMD
    elseif k === Tokens.TRIPLE_CMD
        return :TRIPLECMD
    elseif k === Tokens.TRUE
        return :TRUE
    elseif k === Tokens.FALSE
        return :FALSE
    elseif k === Tokens.ENDMARKER
        return :errortoken
    else
        error("Cannot convert token $k to Expr head")
    end
end

function longest_common_prefix(prefixa, prefixb)
    maxplength = min(sizeof(prefixa), sizeof(prefixb))
    maxplength == 0 && return ""
    idx = findfirst(i -> (prefixa[i] != prefixb[i]), 1:maxplength)
    idx = idx === nothing ? maxplength : idx - 1
    prefixa[1:idx]
end

function skip_to_nl(str, idxend)
    while (idxend < sizeof(str)) && str[idxend] != '\n'
        idxend = nextind(str, idxend)
    end
    idxend > sizeof(str) ? prevind(str, idxend) : idxend
end

tostr(buf::IOBuffer) = _unescape_string(String(take!(buf)))

"""
parse_string_or_cmd(ps)

When trying to make an `INSTANCE` from a string token we must check for
interpolating operators.
"""
function parse_string_or_cmd(ps::ParseState, prefixed=false)
    sfullspan = ps.nt.startbyte - ps.t.startbyte
    sspan = 1 + ps.t.endbyte - ps.t.startbyte

    istrip = (kindof(ps.t) === Tokens.TRIPLE_STRING) || (kindof(ps.t) === Tokens.TRIPLE_CMD)
    iscmd = kindof(ps.t) === Tokens.CMD || kindof(ps.t) === Tokens.TRIPLE_CMD

    lcp = nothing
    exprs_to_adjust = []
    function adjust_lcp(expr::EXPR, last=false)
        if isliteral(expr)
            push!(exprs_to_adjust, expr)
            str = valof(expr)
            (isempty(str) || (lcp !== nothing && isempty(lcp))) && return
            (last && str[end] == '\n') && return (lcp = "")
            idxstart, idxend = 2, 1
            prevpos = idxend
            while nextind(str, idxend) - 1 < sizeof(str) && (lcp === nothing || !isempty(lcp))
                idxend = skip_to_nl(str, idxend)
                idxstart = nextind(str, idxend)
                prevpos1 = idxend
                while nextind(str, idxend) - 1 < sizeof(str)
                    c = str[nextind(str, idxend)]
                    if c == ' ' || c == '\t'
                        idxend += 1
                    elseif c == '\n'
                        # All whitespace lines in the middle are ignored
                        idxend += 1
                        idxstart = idxend + 1
                    else
                        prefix = str[idxstart:idxend]
                        lcp = lcp === nothing ? prefix : longest_common_prefix(lcp, prefix)
                        break
                    end
                    if idxend <= prevpos1
                        throw(CSTInfiniteLoop("Infinite loop in adjust_lcp"))
                    else
                        prevpos1 = idxend
                    end
                end
                if idxend < prevpos
                    throw(CSTInfiniteLoop("Infinite loop in adjust_lcp"))
                else
                    prevpos = idxend
                end
            end
            if idxstart != nextind(str, idxend)
                prefix = str[idxstart:idxend]
                lcp = lcp === nothing ? prefix : longest_common_prefix(lcp, prefix)
            end
        end
    end

    isinterpolated = false
    shoulddropleadingnewline = true
    erroredonlast = false

    t_str = val(ps.t, ps)
    if istrip && length(t_str) == 6
        if iscmd
            return wrapwithcmdmacro(EXPR(:TRIPLESTRING , sfullspan, sspan, ""))
        else
            return EXPR(:TRIPLESTRING, sfullspan, sspan, "")
        end
    elseif length(t_str) == 2
        if iscmd
            return wrapwithcmdmacro(EXPR(:STRING , sfullspan, sspan, ""))
        else
            return EXPR(:STRING, sfullspan, sspan, "")
        end
    elseif prefixed != false
        _val = istrip ? t_str[4:prevind(t_str, sizeof(t_str), 3)] : t_str[2:prevind(t_str, sizeof(t_str))]
        if iscmd
            _val = replace(_val, "\\\\" => "\\")
            _val = replace(_val, "\\`" => "`")
        else
            _val = unescape_prefixed(_val)
        end
        expr = EXPR(istrip ? :TRIPLESTRING : :STRING, sfullspan, sspan, _val)
        if istrip
            adjust_lcp(expr, true)
            ret = EXPR(:string, EXPR[expr], nothing, sfullspan, sspan)
        else
            return iscmd ? wrapwithcmdmacro(expr) : expr
        end
    else
        ret = EXPR(:string, EXPR[], EXPR[], sfullspan, sspan)
        input = IOBuffer(t_str)
        startbytes = istrip ? 3 : 1
        seek(input, startbytes)
        b = IOBuffer()
        prevpos = position(input)
        while !eof(input)
            c = read(input, Char)
            if c == '\\'
                write(b, c)
                write(b, read(input, Char))
            elseif c == '$'
                isinterpolated = true
                lspan = position(b)
                str = String(take!(b))
                ex = EXPR(:STRING, lspan + startbytes, lspan + startbytes, str)
                if position(input) == (istrip ? 3 : 1) + 1
                    # Need to add empty :STRING at start to account for \"
                    pushtotrivia!(ret, ex)
                elseif !isempty(str)
                    push!(ret, ex)
                end
                !iscmd && _rm_escaped_newlines(ex)
                istrip && adjust_lcp(ex)
                startbytes = 0
                op = EXPR(:OPERATOR, 1, 1, "\$")
                if peekchar(input) == '('
                    skip(input, 1) # skip past '('
                    lpfullspan = -position(input)
                    if iswhitespace(peekchar(input)) || peekchar(input) === '#'
                        read_ws_comment(input, readchar(input))
                    end
                    lparen = EXPR(:LPAREN, lpfullspan + position(input) + 1, 1)
                    rparen = EXPR(:RPAREN, 1, 1)

                    prev_input_size = input.size
                    input.size = input.size - (istrip ? 3 : 1)
                    # We're reusing a portion of the string from `ps` so we need to make sure `ps1` knows where the end of the string is.
                    ps1 = ParseState(input)

                    if kindof(ps1.nt) === Tokens.RPAREN
                        push!(ret, EXPR(:errortoken, EXPR[], nothing))
                        pushtotrivia!(ret, op)
                        pushtotrivia!(ret, lparen)
                        pushtotrivia!(ret, rparen)
                        seek(input, ps1.nt.startbyte + 1)
                    else
                        interp_val = @closer ps1 :paren parse_expression(ps1, true)
                        # parse_string_or_cmd unwraps STRING expressions (see below),
                        # but that's not supposed to happen in interpolations, so we rewrap them here:
                        if interp_val.head === :STRING
                            interp_val = EXPR(:string, [interp_val])
                        end

                        push!(ret, interp_val)
                        pushtotrivia!(ret, op)
                        pushtotrivia!(ret, lparen)
                        if kindof(ps1.nt) === Tokens.RPAREN
                            # Need to check the parenthese were actually closed.
                            pushtotrivia!(ret, rparen)
                            seek(input, ps1.nt.startbyte + 1)
                        else
                            pushtotrivia!(ret, EXPR(:RPAREN, 0, 0))
                            seek(input, ps1.nt.startbyte) # We don't skip ahead one as there wasn't a closing paren
                        end
                    end
                    # Compared to flisp/JuliaParser, we have an extra lookahead token,
                    # so we need to back up one here
                    input.size = prev_input_size
                elseif Tokenize.Lexers.iswhitespace(peekchar(input)) || peekchar(input) === '#'
                    pushtotrivia!(ret, op)
                    push!(ret, mErrorToken(ps, StringInterpolationWithTrailingWhitespace))
                elseif sspan == position(input) + (istrip ? 3 : 1)
                    # Error. We've hit the end of the string
                    pushtotrivia!(ret, op)
                    push!(ret, mErrorToken(ps, StringInterpolationWithTrailingWhitespace))
                else
                    pos = position(input)
                    ps1 = ParseState(input)
                    next(ps1)
                    if kindof(ps1.t) === Tokens.WHITESPACE
                        error("Unexpected whitespace after \$ in String")
                    else
                        # foo in $foo is always parsed as an identifier by Julia,
                        # no matter whether it actually is a keyword
                        t = EXPR(:IDENTIFIER, ps1)
                    end
                    # Attribute trailing whitespace to the string
                    t = adjustspan(t)
                    push!(ret, t)
                    pushtotrivia!(ret, op)
                    seek(input, pos + t.fullspan)
                end
            else
                write(b, c)
            end
            prevpos = loop_check(input, prevpos)
        end

        # handle last String section
        lspan = position(b)
        if erroredonlast
            ex = EXPR(istrip ? :TRIPLESTRING : :STRING, (istrip ? 3 : 1) + (ps.nt.startbyte - ps.t.endbyte - 1), istrip ? 3 : 1, "")
            pushtotrivia!(ret, ex)
        elseif b.size == 0
            ex = mErrorToken(ps, Unknown)
            push!(ret, ex)
        else
            str = String(take!(b))

            # This is for error handling only.
            u_str = try
                _unescape_string(str)
            catch err
                return mErrorToken(ps, ret, InvalidString)
            end
            if istrip
                str = str[1:prevind(str, lastindex(str), 3)]
                # only mark non-interpolated triple u_strings
                ex = EXPR(length(ret) == 0 ? :TRIPLESTRING : :STRING, lspan + ps.nt.startbyte - ps.t.endbyte - 1 + startbytes, lspan + startbytes, str)
                # find lcp for escaped string
                !iscmd && _rm_escaped_newlines(ex)
                adjust_lcp(ex, true)
                # we only want to drop the leading new line if it's a literal newline, not if it's `\n`
                if startswith(str, "\\n")
                    shoulddropleadingnewline = false
                end
            else
                str = str[1:prevind(str, lastindex(str))]
                ex = EXPR(:STRING, lspan + ps.nt.startbyte - ps.t.endbyte - 1 + startbytes, lspan + startbytes, str)
            end
            if isempty(str)
                pushtotrivia!(ret, ex)
            else
                push!(ret, ex)
            end
        end
        if iscmd
            str = istrip ?
                t_str[nextind(t_str, 1, 3):prevind(t_str, sizeof(t_str), 3)] :
                t_str[nextind(t_str, 1, 1):prevind(t_str, sizeof(t_str))]
            # remove common prefix:
            if lcp !== nothing
                str = replace(str, "\n$lcp" => "\n")
            end
            # the literal can have escaped '`'s, so let's remove those to get the actual content:
            str = replace(str, "\\`" => "`")
            # remove starting new line:
            if startswith(str, "\n")
                str = str[2:end]
            end
            # save original string into metadata
            ret.meta = str
        end
    end

    single_string_T = (:STRING, :TRIPLESTRING, literalmap(kindof(ps.t)))
    if istrip
        if lcp !== nothing && !isempty(lcp)
            for expr in exprs_to_adjust
                for (i, a) in enumerate(ret.args)
                    if expr == a
                        ret.args[i].val = replace(valof(expr), "\n$lcp" => "\n")
                        break
                    end
                end
            end
        end
        # Drop leading newline
        if !isempty(ret.args) && isliteral(ret.args[1]) && headof(ret.args[1]) in single_string_T &&
                !isempty(valof(ret.args[1])) && valof(ret.args[1])[1] == '\n' && shoulddropleadingnewline
            ret.args[1] = dropleadingnewline(ret.args[1])
        end
    end

    if (length(ret.args) == 1 && isliteral(ret.args[1]) && headof(ret.args[1]) in single_string_T) && !isinterpolated
        unwrapped = ret.args[1]
        if iscmd && ret.meta !== nothing
            unwrapped.val = ret.meta
        end
        ret = unwrapped
    end
    if !iscmd && prefixed == false
        _rm_escaped_newlines(ret)
        _unescape_string_expr(ret)
    end
    update_span!(ret)

    return iscmd ? wrapwithcmdmacro(ret) : ret
end

function _unescape_string_expr(expr)
    if headof(expr) === :STRING || headof(expr) === :TRIPLESTRING
        expr.val = _unescape_string(valof(expr))
    else
        for a in expr
            _unescape_string_expr(a)
        end
    end
end

function _rm_escaped_newlines(expr)
    if headof(expr) === :STRING || headof(expr) === :TRIPLESTRING
        expr.val = replace(valof(expr), r"(?<!\\)((?:\\\\)*)\\\n[\s\n]*" => s"\1")
    else
        for a in expr
            _rm_escaped_newlines(a)
        end
    end
end

function adjustspan(x::EXPR)
    x.fullspan = x.span
    return x
end

dropleadingnewline(x::EXPR) = setparent!(EXPR(headof(x), x.fullspan, x.span, valof(x)[2:end]), parentof(x))

wrapwithcmdmacro(x) = EXPR(:macrocall, EXPR[EXPR(:globalrefcmd, 0, 0), EXPR(:NOTHING, 0, 0), x])

"""
    parse_prefixed_string_cmd(ps::ParseState, ret::EXPR)

Parse prefixed strings and commands such as `pre"text"`.
"""
function parse_prefixed_string_cmd(ps::ParseState, ret::EXPR)
    arg = parse_string_or_cmd(next(ps), ret)

    if ret.head === :IDENTIFIER && valof(ret) == "var" && isstringliteral(arg) && VERSION > v"1.3.0-"
        return EXPR(:NONSTDIDENTIFIER, EXPR[ret, arg], nothing)
    elseif headof(arg) === :macrocall && headof(arg.args[1]) === :globalrefcmd
        mname = EXPR(:IDENTIFIER, ret.fullspan, ret.span, string("@", valof(ret), "_cmd")) # NOTE: sizeof(valof(mname)) != mname.span
        return EXPR(:macrocall, EXPR[mname, EXPR(:NOTHING, 0, 0), arg.args[3]], nothing)
    elseif is_getfield(ret)
        if headof(ret.args[2]) === :quote || headof(ret.args[2]) === :quotenode
            str_type = valof(ret.args[2].args[1]) isa String ? valof(ret.args[2].args[1]) : "" # to handle some malformed case
            if str_type == "var" && isstringliteral(arg) && VERSION > v"1.3.0-"
                var = EXPR(:IDENTIFIER, nothing, nothing, 3, 3, "var", ret, nothing)
                ret.args[2].args[1] = setparent!(EXPR(:NONSTDIDENTIFIER, EXPR[var, arg], nothing), ret.args[2])
                setparent!(var, ret.args[2].args[1])
                update_span!(ret.args[2])
                update_span!(ret)
                return ret
            else
                ret.args[2].args[1] = setparent!(EXPR(:IDENTIFIER, ret.args[2].args[1].fullspan, ret.args[2].args[1].span, string("@", str_type, "_str")), ret.args[2])
            end
        else
            str_type = valof(ret.args[2]) isa String ? valof(ret.args[2]) : "" # to handle some malformed case
            ret.args[2] = EXPR(:IDENTIFIER, ret.args[2].fullspan, ret.args[2].span, string("@", str_type, "_str"))
        end

        return EXPR(:macrocall, EXPR[ret, EXPR(:NOTHING, 0, 0), arg], nothing)
    else
        return EXPR(:macrocall, EXPR[EXPR(:IDENTIFIER, ret.fullspan, ret.span, string("@", valof(ret), "_str")), EXPR(:NOTHING, 0, 0), arg], nothing)
    end
end

function unescape_prefixed(str)
    return replace(str, r"(\\)*(?=\"|$)" => s -> s[1:end÷2])
end

const term_c = (Tokens.RPAREN, Tokens.RSQUARE, Tokens.RBRACE, Tokens.END, Tokens.ELSE, Tokens.ELSEIF, Tokens.CATCH, Tokens.FINALLY, Tokens.ENDMARKER)

"""
Continue parsing statements until an element of `closers` is hit (usually
`end`). Statements are grouped in a `Block` EXPR.
"""
function parse_block(ps::ParseState, ret::Vector{EXPR}=EXPR[], closers=(Tokens.END,), docable=false)
    prevpos = position(ps)
    while kindof(ps.nt) ∉ closers # loop until an expected closer is hit
        if kindof(ps.nt) ∈ term_c # error handling if an unexpected closer is hit
            if kindof(ps.nt) === Tokens.ENDMARKER
                break
            else
                push!(ret, mErrorToken(ps, EXPR(next(ps)), UnexpectedToken))
            end
        else
            if docable
                a = parse_doc(ps)
            else
                a = parse_expression(ps)
            end
            push!(ret, a)
        end
        prevpos = loop_check(ps, prevpos)
    end
    return ret
end

"""
Parses an iterator, allowing for the preceding keyword `outer`. Returns an
error expression if an invalid expression is parsed (anything other than
`=`, `in`, `∈`).
"""
function parse_iterator(ps::ParseState, outer = parse_outer(ps))
    arg = @closer ps :range @closer ps :ws @nocloser ps :wsop parse_expression(ps)
    if !is_range(arg)
        arg = mErrorToken(ps, arg, InvalidIterator)
    else
        arg = adjust_iter(arg)
    end
    if outer !== nothing
        arg.args[1] = setparent!(EXPR(:outer, EXPR[arg.args[1]], EXPR[outer]), arg)
        arg.fullspan += outer.fullspan
        arg.span = outer.fullspan + arg.span
    end
    return arg
end

function adjust_iter(x::EXPR)
    # Assumes x is a valid iterator
    if x.head === :call # isoperator(x.args[1]) && x.args[1].val in ("in", "∈")
        if VERSION > v"1.10-" && x.args[2] isa EXPR && x.args[2].head === :call
            x.args[3] = EXPR(:block, EXPR[x.args[3]])
        end
        return EXPR(EXPR(:OPERATOR, 0, 0, "="), EXPR[x.args[2], x.args[3]], EXPR[x.args[1]])
    elseif VERSION < v"1.10-" && isassignment(x) && length(x.args) == 2 && x.args[1].head == :call && x.args[2].head == :block && length(x.args[2].args) == 1
        x.args[2] = setparent!(x.args[2].args[1], x)
    end
    return x
end

"""
    is_range(x::EXPR)

Is `x` a valid iterator for use in `for` loops or generators?
"""
is_range(x::EXPR) = isassignment(x) || (x.head === :call && (is_in(x.args[1]) || is_elof(x.args[1])))

function parse_outer(ps)
    if kindof(ps.nt) === Tokens.OUTER && kindof(ps.nws) !== EmptyWS && !(Tokens.isoperator(kindof(ps.nnt)) && isbinaryop(ps.nnt) && kindof(ps.nnws) !== EmptyWS)
        EXPR(next(ps))
    end
end

"""
    parse_iterators(ps::ParseState, allowfilter = false)

Parses a group of iterators e.g. used in a `for` loop or generator. Can allow
for a succeeding `Filter` expression.
"""
function parse_iterators(ps::ParseState, iters, trivia)
    push!(iters, parse_iterator(ps))
    if iscomma(ps.nt)
        push!(trivia, accept_comma(ps))
        parse_iterators(ps, iters, trivia)
    end
end

"""
parse_filter(ps::ParseState, arg)

Parse a conditional filter following a generator.
"""
function parse_filter(ps::ParseState, arg)
    if kindof(ps.nt) === Tokens.IF # assumes we're inside a generator
        trivia = EXPR[EXPR(next(ps))]
        cond = @closer ps :range parse_expression(ps)
        if headof(arg) === :block
            arg = EXPR(:filter, EXPR[cond; arg.args], trivia)
        else
            arg = EXPR(:filter, EXPR[cond, arg], trivia)
        end
    end
    return arg
end

"""
    parse_call(ps, ret)

Parses a function call. Expects to start before the opening parentheses and is passed the expression declaring the function name, `ret`.
"""
function parse_call(ps::ParseState, ret::EXPR, ismacro=false)
    if is_minus(ret) || is_not(ret) || is_approx(ret)
        arg = @closer ps :unary @closer ps :inwhere @precedence ps PowerOp parse_expression(ps)
        if istuple(arg)
            pushfirst!(arg.args, ret)
            ret = EXPR(:call, arg.args, arg.trivia)
        else
            ret = EXPR(:call, EXPR[ret, arg], nothing)
        end
    elseif is_and(ret) || is_decl(ret) || is_exor(ret)
        arg = @precedence ps 20 parse_expression(ps)
        if is_exor(ret) && istuple(arg) && length(arg) == 3 && issplat(arg.args[1])
            arg = EXPR(:brackets, arg.args)
        end
        ret = EXPR(ret, EXPR[arg], nothing)
    else
        !ismacro && ismacroname(ret) && (ismacro = true)
        syntaxcall = is_issubt(ret) || is_issupt(ret)
        args = if syntaxcall
            EXPR[]
        elseif ismacro
            EXPR[ret, EXPR(:NOTHING, 0, 0)]
        else
            EXPR[ret]
        end
        # args = ismacro ? EXPR[ret, EXPR(:NOTHING, 0, 0)] : EXPR[ret]
        trivia = EXPR[EXPR(next(ps))]
        @closeparen ps @default ps parse_comma_sep(ps, args, trivia, !ismacro, insert_params_at = ismacro ? 3 : 2)
        accept_rparen(ps, trivia)
        ret = EXPR(ismacro ? :macrocall : syntaxcall ? ret : :call, args, trivia)
    end
    return ret
end

"""
Parses a comma separated list, optionally allowing for conversion of
assignment (`=`) expressions to `Kw`.
"""
function parse_comma_sep(ps::ParseState, args::Vector{EXPR}, trivia::Vector{EXPR}, kw = true, block = false, istuple = false; insert_params_at = 2)
    prevpos = position(ps)
    @nocloser ps :inwhere @nocloser ps :newline @closer ps :comma while !closer(ps)
        a = parse_expression(ps)
        if kw && _do_kw_convert(ps, a)
            b = _do_block_convert(a)
            a = _kw_convert(a, b)
        end

        push!(args, a)
        if iscomma(ps.nt)
            if istuple
                # As soon as we hit a comma in a list we can no longer convert to a block expr
                block = false
            end
            accept_comma(ps, trivia)
        elseif kindof(ps.ws) == SemiColonWS
            break
        elseif !closer(ps)
            # We've not hit a closing token, nor separating punctuation so let's insert an error-wrapped comma
            push!(trivia, EXPR(:errortoken, EXPR[EXPR(:COMMA, 0, 0)], nothing))
        end
        prevpos = loop_check(ps, prevpos)
    end
    if istuple && length(args) > 1
        block = false
    end

    if kindof(ps.ws) == SemiColonWS
        if @nocloser ps :inwhere @nocloser ps :newline @closer ps :comma @nocloser ps :semicolon closer(ps)
            if block && !(length(args) == 0 && ispunctuation(trivia[1])) && !(isunarycall(last(args)) && is_dddot(last(args).args[2]))
                push!(args, EXPR(:block, EXPR[pop!(args)]))
            else
                insert!(args, insert_params_at, EXPR(:parameters, EXPR[], nothing, 0, 0))
            end
        else
            a = @nocloser ps :newline @closer ps :comma @nocloser ps :inwhere parse_expression(ps)
            if block && !(length(args) == 0 && ispunctuation(trivia[1])) && !issplat(last(args)) && !(istuple && iscomma(ps.nt))
                args1 = EXPR[pop!(args), a]
                prevpos = position(ps)
                @nocloser ps :inwhere @nocloser ps :newline @closer ps :comma while @nocloser ps :semicolon !closer(ps)
                    a = parse_expression(ps)
                    push!(args1, a)
                    prevpos = loop_check(ps, prevpos)
                end
                body = EXPR(:block, args1)
                push!(args, body)
                args = body
            else
                parse_parameters(ps, args, EXPR[a], insert_params_at)
            end
        end
    end
    return
end

"""
    parse_parameters(ps::ParseState, args::Vector{EXPR}, args1::Vector{EXPR} = EXPR[]; usekw = true)

Parses parameter arguments for a function call (e.g. following a semicolon).
"""
function parse_parameters(ps::ParseState, args::Vector{EXPR}, args1::Vector{EXPR} = EXPR[], insert_params_at = 2; usekw = true)
    trivia = EXPR[]
    isfirst = isempty(args1)
    prevpos = position(ps)
    @nocloser ps :inwhere @nocloser ps :newline  @closer ps :comma while !isfirst || (@nocloser ps :semicolon !closer(ps))
        a = isfirst ? parse_expression(ps) : first(args1)
        if usekw && _do_kw_convert(ps, a)
            a = _kw_convert(a)
        end
        if isfirst
            push!(args1, a)
        else
            pop!(args1)
            push!(args1, a)
        end
        if iscomma(ps.nt)
            accept_comma(ps, trivia)
        elseif kindof(ps.ws) !== SemiColonWS && !closer(ps)
            push!(trivia, EXPR(:errortoken, EXPR[EXPR(:COMMA, 0, 0)], nothing))
        end
        if kindof(ps.ws) == SemiColonWS
            parse_parameters(ps, args1, EXPR[], 1; usekw=usekw)
        end
        prevpos = isfirst ? loop_check(ps, prevpos) : position(ps)
        isfirst = true
    end
    if !isempty(args1)
        insert!(args, insert_params_at, EXPR(:parameters, args1, trivia))
    end
    return
end

function parse_macroname(ps)
    at = EXPR(ps)
    if isidentifier(ps.nt) || isoperator(ps.nt) || iskeyword(ps.nt)
        if !isemptyws(ps.ws)
            ws = ps.ws.endbyte - ps.ws.startbyte + 1
            mname = INSTANCE(next(ps))
            mname.val = valof(mname) isa String ? string("@", " "^ws, valof(mname)) : string("@", " "^ws)
            mname.span += ws
            mname.fullspan += ws
            mname = mErrorToken(ps, mname, UnexpectedWhiteSpace)
        else
            next(ps)
            if VERSION > v"1.3.0-" && val(ps.t, ps) == "var" && (kindof(ps.nt) === Tokens.STRING || kindof(ps.nt) === Tokens.TRIPLE_STRING)
                mname = EXPR(:IDENTIFIER, max(1, ps.nt.startbyte - ps.t.startbyte + 1), max(1, ps.t.endbyte - ps.t.startbyte + 2), string("@", val(ps.t, ps)))
                arg = parse_string_or_cmd(next(ps), mname)

                EXPR(:NONSTDIDENTIFIER, EXPR[mname, arg], nothing)

            else
                # set span/fullspan min length at 1 to account for the case of a lonely '@'
                EXPR(:IDENTIFIER, max(1, ps.nt.startbyte - ps.t.startbyte + 1), max(1, ps.t.endbyte - ps.t.startbyte + 2), string("@", val(ps.t, ps)))
            end
        end
    else
        mErrorToken(ps, at, MalformedMacroName)
    end
end

"""
    parse_macrocall(ps)

Parses a macro call. Expects to start on the `@`.
"""
function parse_macrocall(ps::ParseState)
    mname = parse_macroname(ps)
    # Handle cases with @ at start of dotted expressions
    if kindof(ps.nt) === Tokens.DOT && isemptyws(ps.ws)
        prevpos = position(ps)
        while kindof(ps.nt) === Tokens.DOT
            op = EXPR(:OPERATOR, next(ps))
            nextarg = EXPR(:IDENTIFIER, next(ps))
            mname = EXPR(op, EXPR[mname, EXPR(:quotenode, EXPR[nextarg], nothing)], nothing)
            prevpos = loop_check(ps, prevpos)
        end
    end

    if iscomma(ps.nt) || isnewlinews(ps.ws)
        return EXPR(:macrocall, EXPR[mname, EXPR(:NOTHING, 0, 0)], nothing, mname.fullspan, mname.span)
    elseif isemptyws(ps.ws) && kindof(ps.nt) === Tokens.LPAREN
        return parse_call(ps, mname, true)
    elseif isemptyws(ps.ws) && kindof(ps.nt) === Tokens.LBRACE
        next(ps)
        return EXPR(:macrocall, EXPR[mname, EXPR(:NOTHING, 0, 0), @default ps @closebrace ps parse_braces(ps)], nothing)
    elseif isemptyws(ps.ws) && kindof(ps.nt) === Tokens.LSQUARE
        next(ps)
        return EXPR(:macrocall, EXPR[mname, EXPR(:NOTHING, 0, 0), @default ps parse_array(ps)], nothing)
    else
        args = EXPR[mname, EXPR(:NOTHING, 0, 0)]
        insquare = ps.closer.insquare
        prevpos = position(ps)
        @default ps while !closer(ps)
            if insquare
                a = @closer ps :insquare @closer ps :inmacro @closer ps :ws @closer ps :wsop parse_expression(ps)
            else
                a = @closer ps :inmacro @closer ps :ws @closer ps :wsop parse_expression(ps)
            end
            push!(args, a)

            if valof(mname) == "@doc" && ps.t.endpos[1] + 1 == ps.nt.startpos[1] && length(args) == 3 && kindof(ps.nt) !== Tokens.ENDMARKER
                a = parse_expression(ps)
                push!(args, a)
                break
            end
            if ps.closer.for_generator && kindof(ps.nt) === Tokens.FOR
                break
            end
            prevpos = loop_check(ps, prevpos)
        end
        return EXPR(:macrocall, args, nothing)
    end
end

"""
parse_generator(ps)

Having hit `for` not at the beginning of an expression return a generator.
Comprehensions are parsed as SQUAREs containing a generator.
"""
function parse_generator(ps::ParseState, first::EXPR)
    kw = EXPR(next(ps))
    iters, trivia = EXPR[], EXPR[]
    @closesquare ps parse_iterators(ps, iters, trivia)
    if kindof(ps.nt) === Tokens.IF # filter
        push!(trivia, EXPR(next(ps)))
        cond = @closer ps :range parse_expression(ps)
        pushfirst!(iters, cond)
        iters = EXPR(:filter, iters, trivia)
        trivia = EXPR[]
    end
    if kindof(ps.nt) === Tokens.FOR
        return EXPR(:flatten, EXPR[EXPR(:generator, EXPR[parse_generator(ps, first); iters], [kw; trivia])], nothing)
    else
        return EXPR(:generator, EXPR[first; iters], EXPR[kw; trivia])
    end
end


function get_appropriate_child_to_expand(x)
    if headof(x) === :generator && !(headof(x.args[1]) in (:generator, :flatten))
        return x, x.args[1]
    elseif headof(x) === :flatten &&  headof(x.args[1]) === :generator && headof(x.args[1].args[1]) === :generator
        x.args[1], x.args[1].args[1]
    else
        get_appropriate_child_to_expand(x.args[1])
    end
end

is_nonstd_identifier(ps) = VERSION > v"1.3.0-" && isidentifier(ps.nt) && isemptyws(ps.nws) && (kindof(ps.nnt) === Tokens.STRING || kindof(ps.nnt) === Tokens.TRIPLE_STRING)

function parse_nonstd_identifier(ps)
    id = INSTANCE(next(ps))
    if valof(id) == "var"
        EXPR(:NONSTDIDENTIFIER, EXPR[id, INSTANCE(next(ps))])
    else
        mErrorToken(ps, EXPR(:NONSTDIDENTIFIER, EXPR[id, INSTANCE(next(ps))]), UnexpectedToken)
    end
end

function parse_public_item(ps::ParseState)
    if kindof(ps.nt) === Tokens.AT_SIGN
        parse_macroname(next(ps))
    elseif kindof(ps.nt) === Tokens.EX_OR
        parse_unary(ps, INSTANCE(next(ps)))
    elseif isoperator(ps.nt)
        next(ps)
        EXPR(:OPERATOR, ps.nt.startbyte - ps.t.startbyte,  1 + ps.t.endbyte - ps.t.startbyte, val(ps.t, ps))
    elseif is_nonstd_identifier(ps)
        parse_nonstd_identifier(ps)
    else
        INSTANCE(next(ps))
    end
end

function parse_importexport_item(ps, is_colon = false)
    if kindof(ps.nt) === Tokens.AT_SIGN
        parse_macroname(next(ps))
    elseif kindof(ps.nt) === Tokens.LPAREN
        a = EXPR(:brackets, EXPR[], EXPR[EXPR(next(ps))])
        push!(a, @closeparen ps parse_expression(ps))
        pushtotrivia!(a, accept_rparen(ps))
        a
    elseif kindof(ps.nt) === Tokens.EX_OR
        @closer ps :ws parse_unary(ps, INSTANCE(next(ps)))
    elseif !is_colon && isoperator(ps.nt)
        next(ps)
        EXPR(:OPERATOR, ps.nt.startbyte - ps.t.startbyte,  1 + ps.t.endbyte - ps.t.startbyte, val(ps.t, ps))
    elseif is_nonstd_identifier(ps)
        parse_nonstd_identifier(ps)
    else
        INSTANCE(next(ps))
    end
end
"""
Helper function for parsing import/using statements.
"""
function parse_dot_mod(ps::ParseState, is_colon=false, allow_as=false)
    ret = EXPR(EXPR(:OPERATOR, 0, 0, "."), EXPR[], EXPR[])

    prevpos = position(ps)
    while kindof(ps.nt) === Tokens.DOT || kindof(ps.nt) === Tokens.DDOT || kindof(ps.nt) === Tokens.DDDOT
        d = EXPR(:OPERATOR, next(ps))
        trailing_ws = d.fullspan - d.span
        if is_dot(d)
            push!(ret, EXPR(:OPERATOR, 1 + trailing_ws, 1, "."))
        elseif is_ddot(d)
            push!(ret, EXPR(:OPERATOR, 1, 1, "."))
            push!(ret, EXPR(:OPERATOR, 1 + trailing_ws, 1, "."))
        elseif is_dddot(d)
            push!(ret, EXPR(:OPERATOR, 1, 1, "."))
            push!(ret, EXPR(:OPERATOR, 1, 1, "."))
            push!(ret, EXPR(:OPERATOR, 1 + trailing_ws, 1, "."))
        end
        prevpos = loop_check(ps, prevpos)
    end

    prevpos = position(ps)
    while true
        push!(ret, parse_importexport_item(ps, is_colon))

        if kindof(ps.nt) === Tokens.DOT
            pushtotrivia!(ret, EXPR(next(ps)))
            if kindof(ps.nt) === Tokens.COLON
                u = parse_unary_colon(ps, EXPR(:IDENTIFIER, next(ps)))
                push!(ret, u)
                return ret
            end
        elseif isoperator(ps.nt) && (ps.nt.dotop || kindof(ps.nt) === Tokens.DOT)
            pushtotrivia!(ret, EXPR(:DOT, 1, 1))
            ps.nt = RawToken(kindof(ps.nt), ps.nt.startpos, ps.nt.endpos, ps.nt.startbyte + 1, ps.nt.endbyte, ps.nt.token_error, false, ps.nt.suffix)
        else
            @static if VERSION > v"1.6-"
                if allow_as && !isnewlinews(ps.ws) && isidentifier(ps.nt) && val(ps.nt, ps) == "as"
                    as = EXPR(:AS, next(ps))
                    as_val = parse_importexport_item(ps, is_colon)
                    ret = EXPR(:as, EXPR[ret, as_val], EXPR[as])
                end
            end
            break
        end
        prevpos = loop_check(ps, prevpos)
    end
    ret
end

"""
parse_tuple(ps, ret)

`ret` is followed by a comma so tries to parse the rest of the
tuple.
"""
function parse_tuple end

iserrorwrapped(x, head) = x.head === head || (x.head === :errortoken && length(x.args) > 0 && iserrorwrapped(x.args[1], head))

function parse_tuple(ps::ParseState, ret::EXPR)
    op = EXPR(next(ps))
    if istuple(ret) && !(length(ret.trivia) > 1 && iserrorwrapped(last(ret.trivia), :RPAREN))
        if (isassignmentop(ps.nt) && kindof(ps.nt) != Tokens.APPROX)
            pushtotrivia!(ret, op)
        elseif closer(ps)
            @static if VERSION > v"1.1-"
                pushtotrivia!(ret, mErrorToken(ps, op, Unknown))
            else
                pushtotrivia!(ret, op)
            end
        else
            nextarg = @closer ps :tuple parse_expression(ps)
            if !(is_lparen(first(ret.trivia)))
                pushtotrivia!(ret, op)
                push!(ret, nextarg)
            else
                ret = EXPR(:tuple, EXPR[ret, nextarg], EXPR[op])
            end
        end
    else
        if (isassignmentop(ps.nt) && kindof(ps.nt) != Tokens.APPROX)
            ret = EXPR(:tuple, EXPR[ret], EXPR[op])
        elseif closer(ps)
            @static if VERSION > v"1.1-"
                ret = mErrorToken(ps, EXPR(:tuple, EXPR[ret], EXPR[op]), Unknown)
            else
                ret = EXPR(:tuple, EXPR[ret], EXPR[op])
            end
        else
            nextarg = @closer ps :tuple parse_expression(ps)
            ret = EXPR(:tuple, EXPR[ret, nextarg], EXPR[op])
        end
    end
    return ret
end

# XXX: Avert thine eyes.
function count_semicolons(ps, check_newline = true)
    dims = 0
    has_newline = false
    old_pos = position(ps.l.io)
    seek(ps.l.io, ps.ws.startbyte)
    while true
        c = readchar(ps.l.io)
        if c == ';'
            dims += 1
        elseif check_newline && c == '\n'
            # technically, only trailing newlines are allowed; we're a bit more lenient here
            has_newline = true
        else
            dims == 0 || break
        end
    end
    seek(ps.l.io, old_pos)
    return dims == 2 && has_newline ? 0 : dims
end

"""
    parse_array(ps)
Having hit '[' return either:
+ A vect
+ A vcat
+ A ncat
+ A comprehension
+ An array (vcat of hcats)
"""
function parse_array(ps::ParseState, isref = false)
    args = EXPR[]
    trivia = EXPR[EXPR(ps)]
    # [] or [;;;]
    if kindof(ps.nt) === Tokens.RSQUARE
        dims = 0
        if kindof(ps.ws) == SemiColonWS
            dims = count_semicolons(ps, false)
        end
        push!(trivia, accept_rsquare(ps))
        if dims > 0
            ret = EXPR(:ncat, args, trivia)
            pushfirst!(ret, EXPR(Symbol(dims), 0, 0, ""))
            return ret
        else
            return EXPR(:vect, args, trivia)
        end
    else
        ret = parse_array_outer(ps::ParseState, trivia, isref)
        pushtotrivia!(ret, accept_rsquare(ps))

        return ret
    end
end

binding_power(ps, nl = true) =
    if kindof(ps.ws) == SemiColonWS
        -count_semicolons(ps, nl)
    elseif kindof(ps.ws) == NewLineWS
        -1
    elseif kindof(ps.ws) == WS
        0
    else
        1
    end

function parse_array_outer(ps::ParseState, trivia, isref)
    args_list = EXPR[]
    trivia_bp = Int[]
    min_bp = 0
    max_bp = -typemax(Int)
    is_start = true
    while kindof(ps.nt) !== Tokens.RSQUARE && kindof(ps.nt) !== Tokens.ENDMARKER
        a = @nocloser ps :semicolon @nocloser ps :newline @closesquare ps @closer ps :insquare @closer ps :ws @closer ps :wsop @closer ps :comma parse_expression(ps)
        if is_start
            args = EXPR[]
            if isref && _do_kw_convert(ps, a)
                a = _kw_convert(a)
            end
            if kindof(ps.nt) === Tokens.RSQUARE
                if headof(a) === :generator || headof(a) === :flatten
                    if isbinarycall(a.args[1]) && is_pairarrow(a.args[1].args[2])
                        return EXPR(:dict_comprehension, EXPR[a], trivia)
                    else
                        return EXPR(:comprehension, EXPR[a], trivia)
                    end
                elseif kindof(ps.ws) == SemiColonWS
                    dims = count_semicolons(ps)
                    push!(args, a)
                    if dims > 1
                        ret = EXPR(:ncat, args, trivia)
                        pushfirst!(ret, EXPR(Symbol(dims), 0, 0, ""))
                        return ret
                    else
                        return EXPR(:vcat, args, trivia)
                    end
                else
                    push!(args, a)
                    return EXPR(:vect, args, trivia)
                end
            elseif iscomma(ps.nt)
                args = EXPR[]
                push!(args, a)
                push!(trivia, accept_comma(ps))
                @closesquare ps parse_comma_sep(ps, args, trivia, isref, insert_params_at = 1)
                return EXPR(:vect, args, trivia)
            elseif kindof(ps.nt) === Tokens.ENDMARKER
                push!(args, a)
                return EXPR(:vect, args, trivia)
            end
        end
        is_start = false

        push!(args_list, a)

        bp = binding_power(ps, max_bp == 0)
        bp < min_bp && (min_bp = bp)
        bp > max_bp && (max_bp = bp)
        if bp <= 0
            push!(trivia_bp, bp)
        end
    end

    if length(trivia_bp) + 1 < length(args_list)
        return EXPR(:hcat, EXPR[EXPR(:errortoken, args_list, nothing)], trivia)
    end

    ret = _process_inner_array(args_list, trivia_bp)
    for t in trivia
        pushtotrivia!(ret, t)
    end

    if ret.head === :nrow
        if min_bp == 0
            popfirst!(ret.args)
            ret.head = :hcat
        elseif min_bp == -1
            popfirst!(ret.args)
            ret.head = :vcat
        else
            ret.head = :ncat
        end
    elseif min_bp == 0
        ret.head = :hcat
    elseif min_bp == -1
        ret.head = :vcat
    end

    return ret
end

function _process_inner_array(args_list, trivia_bp)
    if isempty(trivia_bp)
        if length(args_list) == 1
            arg = first(args_list)
            arg.args = something(arg.args, EXPR[])
            arg.trivia = something(arg.trivia, EXPR[])
            return arg
        else
            return EXPR(:errortoken, EXPR[], EXPR[])
        end
    end
    bp = minimum(trivia_bp)
    if all(==(bp), trivia_bp)
        if bp == 0
            ret = EXPR(:row, EXPR[], EXPR[])
        else
            ret = EXPR(:nrow, copy(args_list), EXPR[])
            pushfirst!(ret, EXPR(Symbol(-bp), 0, 0, ""))
        end
    end
    i = 1
    i0 = 1
    if bp == 0
        ret = EXPR(:row, EXPR[], EXPR[])
    else
        ret = EXPR(:nrow, EXPR[], EXPR[])
        push!(ret, EXPR(Symbol(-bp), 0, 0, ""))
    end
    while true
        i = findnext(==(bp), trivia_bp, i0)
        i === nothing && (i = length(args_list))
        if !checkbounds(Bool, args_list, i0:i) || !checkbounds(Bool, trivia_bp, i0:(i-1))
            return EXPR(:errortoken, args_list, EXPR[])
        end
        inner_args = args_list[i0:i]
        inner_trivia = trivia_bp[i0:(i-1)]
        i0 = i + 1

        push!(ret, _process_inner_array(inner_args, inner_trivia))
        i >= length(args_list) && break
    end
    return ret
end

"""
    parse_ref(ps, ret)

Handles cases where an expression - `ret` - is followed by
`[`. Parses the following bracketed expression and modifies it's
`.head` appropriately.
"""
function parse_ref(ps::ParseState, ret::EXPR)
    next(ps)
    ref = @closer ps :inref @nocloser ps :inwhere parse_array(ps, true)
    if headof(ref) === :vect
        args = EXPR[ret]
        for a in ref.args
            push!(args, a)
        end
        return EXPR(:ref, args, ref.trivia)
    elseif headof(ref) === :hcat
        args = EXPR[ret]
        for a in ref.args
            push!(args, a)
        end
        return EXPR(:typed_hcat, args, ref.trivia)
    elseif headof(ref) === :vcat
        args = EXPR[ret]
        for a in ref.args
            push!(args, a)
        end
        return EXPR(:typed_vcat, args, ref.trivia)
    elseif headof(ref) === :ncat
        args = EXPR[ret]
        for a in ref.args
            push!(args, a)
        end
        return EXPR(:typed_ncat, args, ref.trivia)
    else
        args = EXPR[ret]
        for a in ref.args
            push!(args, a)
        end
        return EXPR(:typed_comprehension, args, ref.trivia)
    end
end

"""
parse_curly(ps, ret)

Parses the juxtaposition of `ret` with an opening brace. Parses a comma
seperated list.
"""
function parse_curly(ps::ParseState, ret::EXPR)
    args = EXPR[ret]
    trivia = EXPR[EXPR(next(ps))]
    parse_comma_sep(ps, args, trivia, true)
    accept_rbrace(ps, trivia)
    return EXPR(:curly, args, trivia)
end

function parse_braces(ps::ParseState)
    return @default ps @nocloser ps :inwhere parse_barray(ps)
end

function parse_barray(ps::ParseState)
    args = EXPR[]
    trivia = EXPR[EXPR(ps)]

    if kindof(ps.nt) === Tokens.RBRACE
        accept_rbrace(ps, trivia)
        ret = EXPR(:braces, args, trivia)
    else
        first_arg = @nocloser ps :newline @closebrace ps  @closer ps :ws @closer ps :wsop @closer ps :comma parse_expression(ps)
        if kindof(ps.nt) === Tokens.RBRACE
            push!(args, first_arg)
            if kindof(ps.ws) == SemiColonWS
                pushfirst!(args, EXPR(:parameters, EXPR[], nothing))
            end
            accept_rbrace(ps, trivia)
            ret = EXPR(:braces, args, trivia)
        elseif iscomma(ps.nt)
            push!(args, first_arg)
            accept_comma(ps, trivia)
            @closebrace ps parse_comma_sep(ps, args, trivia, true, insert_params_at = 1)
            accept_rbrace(ps, trivia)
            return EXPR(:braces, args, trivia)
        elseif kindof(ps.ws) == NewLineWS
            ret = EXPR(:bracescat, args, trivia)
            push!(ret, first_arg)
            prevpos = position(ps)
            while kindof(ps.nt) != Tokens.RBRACE && kindof(ps.nt) !== Tokens.ENDMARKER
                a = @closebrace ps  parse_expression(ps)
                push!(ret, a)
                prevpos = loop_check(ps, prevpos)
            end
            pushtotrivia!(ret, accept_rbrace(ps))
            return ret
        elseif kindof(ps.ws) == WS || kindof(ps.ws) == SemiColonWS
            first_row = EXPR(:row, EXPR[first_arg])
            prevpos = position(ps)
            while kindof(ps.nt) !== Tokens.RBRACE && kindof(ps.ws) !== NewLineWS && kindof(ps.ws) !== SemiColonWS && kindof(ps.nt) !== Tokens.ENDMARKER
                a = @closebrace ps @closer ps :ws @closer ps :wsop parse_expression(ps)
                push!(first_row, a)
                prevpos = loop_check(ps, prevpos)
            end
            if kindof(ps.nt) === Tokens.RBRACE && kindof(ps.ws) != SemiColonWS
                if length(first_row.args) == 1
                    first_row = EXPR(:bracescat, first_row.args)
                end
                push!(args, first_row)
                push!(trivia, INSTANCE(next(ps)))
                return EXPR(:bracescat, args, trivia)
            else
                if length(first_row.args) == 1
                    first_row = first_row.args[1]
                else
                    first_row = EXPR(:row, first_row.args)
                end
                ret = EXPR(:bracescat, EXPR[first_row], trivia)
                prevpos = position(ps)
                while kindof(ps.nt) != Tokens.RBRACE
                    if kindof(ps.nt) === Tokens.ENDMARKER
                        break
                    end
                    first_arg = @closebrace ps @closer ps :ws @closer ps :wsop parse_expression(ps)
                    push!(ret, EXPR(:row, EXPR[first_arg]))
                    prevpos1 = position(ps)
                    while kindof(ps.nt) !== Tokens.RBRACE && kindof(ps.ws) !== NewLineWS && kindof(ps.ws) !== SemiColonWS && kindof(ps.nt) !== Tokens.ENDMARKER
                        a = @closebrace ps @closer ps :ws @closer ps :wsop parse_expression(ps)
                        push!(last(ret.args), a)
                        prevpos1 = loop_check(ps, prevpos1)
                    end
                    # if only one entry dont use :row
                    if length(last(ret.args).args) == 1
                        ret.args[end] = setparent!(ret.args[end].args[1], ret)
                    end
                    update_span!(ret)
                    prevpos = loop_check(ps, prevpos)
                end
                pushtotrivia!(ret, accept_rbrace(ps))
                update_span!(ret)
                return ret
            end
        else
            ret = EXPR(:braces, args, trivia)
            push!(ret, first_arg)
            pushtotrivia!(ret, accept_rbrace(ps))
        end
    end
    return ret
end

@testitem "vect" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "[x]" |> test_expr
    @test "[(1,2)]" |> test_expr
    @test "[x...]" |> test_expr
    @test "[1,2,3,4,5]" |> test_expr
    # this is nonsensical, but iteration should still work
    @test traverse(CSTParser.parse(raw"""[[:alpha:]a←-]"""))
    # unterminated expressions may cause issues
    @test traverse(CSTParser.parse("bind_artifact!(\"../Artifacts.toml\",\"example\",hash,download_info=[(\"file://c:/juliaWork/tarballs/example.tar.gz\"\",tarball_hash)],force=true)\n2+2\n"))
    @test traverse(CSTParser.parse("[2+3+4"))
    @test traverse(CSTParser.parse("[2+3+4+"))
    @test traverse(CSTParser.parse("[\"hi\"\""))
    @test traverse(CSTParser.parse("[\"hi\"\"\n"))
    @test traverse(CSTParser.parse("[(1,2,3])"))

    @test "[2.0^53 2.0^53+2]" |> test_expr
end

@testitem "ref" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "t[i]" |> test_expr
    @test "t[i, j]" |> test_expr
end

@testitem "vcat" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "[x;]" |> test_expr
    @test "[x;y;z]" |> test_expr
    @test """[x
          y
          z]""" |> test_expr
    @test """[x
          y;z]""" |> test_expr
    @test """[x;y
          z]""" |> test_expr
    @test "[x,y;z]" |> test_expr
    @test "[1,2;]" |> test_expr
end

@testitem "typed_vcat" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "t[x;]" |> test_expr
    @test "t[x;y]" |> test_expr
    @test """t[x
           y]""" |> test_expr
    @test "t[x;y]" |> test_expr
    @test "t[x y; z]" |> test_expr
    @test "t[x, y; z]" |> test_expr
end

@testitem "ncat" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    if VERSION > v"1.8-"
        @test "[;]" |> test_expr
        @test "[;;]" |> test_expr
        @test "[;;\n]" |> test_expr
        @test "[\n ;; \n]" |> test_expr
        @test "[;;;;;;;]" |> test_expr
        @test "[x;;;;;]" |> test_expr
        @test "[x;;]" |> test_expr
        @test "[x;; y;;    z]" |> test_expr
        @test "[x;;; y;;;z]" |> test_expr
        @test "[x;;; y;;;z]'" |> test_expr
        @test "[1 2; 3 4]" |> test_expr
        @test "[1;2;;3;4;;5;6;;;;9]" |> test_expr
        if VERSION > v"1.7-"
            @test "[let; x; end;; y]" |> test_expr
            @test "[let; x; end;;;; y]" |> test_expr
        end
    end
end

@testitem "typed_ncat" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    if VERSION > v"1.8-"
        @test "t[;;]" |> test_expr
        @test "t[;;;;;;;]" |> test_expr
        @test "t[x;;;;;]" |> test_expr
        @test "t[x;;]" |> test_expr
        @test "t[x;; y;;    z]" |> test_expr
        @test "t[x;;; y;;;z]" |> test_expr
        @test "t[x;;\ny]" |> test_expr
        @test "t[x y;;\nz a]" |> test_expr
        @test "t[x y;;\nz a]'" |> test_expr
        @test "t[let; x; end;; y]" |> test_expr
        @test "t[let; x; end;;;; y]" |> test_expr
    end
end

@testitem "hcat" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "[x y]" |> test_expr
    @test "[let; x; end y]" |> test_expr
    @test "[let; x; end; y]" |> test_expr
end

@testitem "typed_hcat" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "t[x y]" |> test_expr
    @test "t[let; x; end y]" |> test_expr
    @test "t[let; x; end; y]" |> test_expr
end

@testitem "Comprehension" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "[i for i = 1:10]" |> test_expr
    @test "Int[i for i = 1:10]" |> test_expr
    @test "[let;x;end for x in x]" |> test_expr
    @test "[let; x; end for x in x]" |> test_expr
    @test "[let x=x; x+x; end for x in x]" |> test_expr
    if v"1.7-" < VERSION < v"1.10-"
        @test """[
            [
                let l = min((d-k),k);
                    binomial(d-l,l);
                end; for k in 1:d-1
            ] for d in 2:9
        ]
        """ |> test_expr
    end
    if VERSION > v"1.10-"
        @test """[
            [
                let l = min((d-k),k);
                    binomial(d-l,l);
                end for k in 1:d-1
            ] for d in 2:9
        ]
        """ |> test_expr
    end
end

function _precompile()
    precompile(ParseState, (String,))
    precompile(ParseState, (String, Int))
    precompile(next, (ParseState,))
    precompile(parse_doc, (ParseState,))
    precompile(Expr, (EXPR,))
    precompile(parse_string_or_cmd, (ParseState, Bool))

    # precompile(setbinding!, (EXPR,))
    # precompile(setbinding!, (EXPR, EXPR))
    # precompile(Binding, (EXPR,))
    # precompile(Binding, (String, EXPR, Nothing, Vector{Any}, Nothing))
    # precompile(Scope, (Nothing, Dict{String,Binding}, Nothing, Bool))
    # precompile(Scope, (Scope, Dict{String,Binding}, Nothing, Bool))
    # precompile(Scope, (Nothing, Dict{String,Binding}, Dict{String,Any}, Bool))
    # precompile(Scope, (Scope, Dict{String,Binding}, Dict{String,Any}, Bool))
    # precompile(Scope, ())
    precompile(EXPR, (Symbol, Nothing, Int, Int, Nothing, Tokens.Kind, Bool, Nothing, Nothing, Nothing, Nothing))
    precompile(EXPR, (Symbol, Vector{EXPR}, Int, Int, Nothing, Tokens.Kind, Bool, Nothing, Nothing, Nothing, Nothing))
    precompile(EXPR, (Symbol, Vector{EXPR}, Int, Int, String, Tokens.Kind, Bool, Nothing, Nothing, Nothing, Nothing))
    precompile(EXPR, (Symbol, Vector{EXPR}, Int, Int))
    precompile(EXPR, (Symbol, Vector{EXPR}))


    precompile(INSTANCE, (ParseState,))

    precompile(str_value, (EXPR,))

    precompile(CSTParser.parse_expression, (ParseState,))
    precompile(CSTParser.parse_paren, (ParseState,))
    precompile(CSTParser._continue_doc_parse, (ParseState, EXPR))
    precompile(CSTParser.parse_compound, (ParseState, EXPR))
    precompile(CSTParser.parse_operator, (ParseState, EXPR, EXPR))
    precompile(parse_unary, (ParseState, EXPR))
    precompile(parse_unary_colon, (ParseState, EXPR))
    precompile(parse_operator_anon_func, (ParseState, EXPR, EXPR))
    precompile(parse_operator_colon, (ParseState, EXPR, EXPR))
    precompile(parse_operator_cond, (ParseState, EXPR, EXPR))
    precompile(parse_operator_dot, (ParseState, EXPR, EXPR))
    precompile(parse_operator_eq, (ParseState, EXPR, EXPR))
    precompile(parse_operator_power, (ParseState, EXPR, EXPR))
    precompile(parse_operator_where, (ParseState, EXPR, EXPR))

    precompile(CSTParser.parse_block, (ParseState, Vector{EXPR}))
    precompile(CSTParser.parse_block, (ParseState, Vector{EXPR}, Tuple{Tokens.Kind}))
    precompile(CSTParser.parse_block, (ParseState, Vector{EXPR}, Tuple{Tokens.Kind,Bool}))
    precompile(CSTParser.parse_iterator, (ParseState,))
    precompile(CSTParser.parse_iterators, (ParseState, Bool))
    precompile(CSTParser.parse_call, (ParseState, EXPR, Bool))
    precompile(CSTParser.parse_comma_sep, (ParseState, Vector{EXPR}, Bool, Bool, Bool))
    precompile(CSTParser.parse_parameters, (ParseState, Vector{EXPR}, Vector{EXPR}))
    precompile(CSTParser.parse_macrocall, (ParseState,))
    precompile(CSTParser.parse_generator, (ParseState, EXPR))
    precompile(CSTParser.parse_dot_mod, (ParseState, Bool))

    precompile(CSTParser.parse_tuple, (ParseState, EXPR))
    precompile(CSTParser.parse_array, (ParseState, Bool))
    precompile(CSTParser.parse_ref, (ParseState, EXPR))
    precompile(CSTParser.parse_curly, (ParseState, EXPR))
    precompile(CSTParser.parse_braces, (ParseState,))

    precompile(CSTParser.parse_kw, (ParseState,))
    precompile(CSTParser.parse_const, (ParseState,))
    precompile(CSTParser.parse_return, (ParseState,))
    precompile(CSTParser.parse_abstract, (ParseState,))
    precompile(CSTParser.parse_primitive, (ParseState,))
    precompile(CSTParser.parse_imports, (ParseState,))
    precompile(CSTParser.parse_export, (ParseState,))
    precompile(CSTParser.parse_blockexpr, (ParseState, Symbol))
    precompile(CSTParser.parse_if, (ParseState, Bool))
    precompile(CSTParser.parse_try, (ParseState,))
    precompile(CSTParser.parse_do, (ParseState, EXPR))
    precompile(CSTParser.parse_mutable, (ParseState,))

    precompile(CSTParser.closer, (ParseState,))
    precompile(CSTParser.create_tmp, (Closer,))
    precompile(CSTParser.update_from_tmp!, (Closer, Closer_TMP))
    precompile(CSTParser.update_to_default!, (Closer,))

    precompile(Tokenize.Lexers.Lexer, (IOBuffer, Type{Tokens.RawToken}))
    precompile(Tokenize.Lexers.next_token, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(get, (Dict{Char,Tokenize.Tokens.Kind}, Char, Tokenize.Tokens.Kind))
    precompile(getindex, (Dict{Tokenize.Tokens.Kind,Symbol}, Tokenize.Tokens.Kind))

    precompile(Tokenize.Lexers.next_token, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_amper, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_backslash, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_bar, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_circumflex, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_cmd, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_colon, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_comment, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_digit, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken}, Tokens.Kind))
    precompile(Tokenize.Lexers.lex_division, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_dollar, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_dot, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_equal, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_exclaim, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_forwardslash, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_greater, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_identifier, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken}, Char))
    precompile(Tokenize.Lexers.lex_less, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_minus, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_percent, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_plus, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_prime, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_quote, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_star, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_whitespace, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
    precompile(Tokenize.Lexers.lex_xor, (Tokenize.Lexers.Lexer{IOBuffer,Tokens.RawToken},))
end

# This deletes arbitrary tokens from files and checks that we can still parse them
# and that iteration functions are still correctly ordered.

@testitem "invalid jl file parsing" begin
    using CSTParser: to_codeobject
    using Tokenize: tokenize
    import Tokenize.Tokens: untokenize

    function trav(x, f=x -> nothing)
        f(x)
        for a in x
            trav(a, f)
        end
    end

    function trav1(x, f=x -> nothing)
        f(x)
        if x.args !== nothing
            for a in x
                trav(a, f)
            end
        end
    end

    function check_err_parse(s, n=length(s) ÷ 100)
        check_str(s) # parsing works?
        check_itr_order(s) # iteration produces same text?

        ts = collect(tokenize(s))[1:end-1]
        for _ in 1:n
            length(ts) == 1 && return
            deleteat!(ts, rand(1:length(ts)))
            check_str(untokenize(ts))
        end
    end

    function check_str(s)
        x = try
            CSTParser.parse(s, true)
        catch e
            @info "Couldn't parse:"
            @info s
            rethrow(e)
        end
        try
            trav(x)
        catch e
            @info "Couldn't traverse:"
            @info s
            rethrow(e)
        end
        try
            to_codeobject(x)
        catch e
            @info "Couldn't convert:"
            @info s
            rethrow(e)
        end
        if sizeof(s) != x.fullspan
            @info "sizeof(s) != x.fullspan for :"
            println(">>>>>>>>>>>>>>>>>>")
            println(s)
            println("<<<<<<<<<<<<<<<<<<")
        end
        check_itr_order(s, x)
    end

    function get_segs(x)
        offset = 0
        segs = []
        for i = 1:length(x)
            a = x[i]
            push!(segs, offset .+ (1:a.fullspan))
            offset += a.fullspan
        end
        segs
    end

    function check_itr_order(s, x=CSTParser.parse(s, true))
        length(x) == 0 && return
        segs = get_segs(x)
        s0 = join(String(codeunits(s)[seg]) for seg in segs)
        if s0 == s
            for i = 1:length(x)
                if length(x[i]) > 0
                    seg = segs[i]
                    s2 = String(codeunits(s)[seg])
                    check_itr_order(s2, x[i])
                end
            end
        else
            @info "check_itr_order failed: "
            println(">>>>>>>>>>>>>>>>>>")
            println(s)
            println("<<<<<<<<<<<<<<<<<<")
            error()
        end
    end

    comp(x, y) = x == y
    function comp(x::CSTParser.EXPR, y::CSTParser.EXPR)
        comp(x.head, y.head) &&
            x.span == y.span &&
            x.fullspan == y.fullspan &&
            x.val == y.val &&
            length(x) == length(y) &&
            all(comp(x[i], y[i]) for i = 1:length(x))
    end

    function check_reparse(s0, n=length(s0) ÷ 100)
        for _ in 1:n
            x0 = CSTParser.parse(s0, true)
            CSTParser.has_error(x0) && return
            ts = collect(tokenize(s0))[1:end-1]
            length(ts) < 2 && return
            deleteat!(ts, rand(1:length(ts)))
            s1 = untokenize(ts)
            length(ts) < 3 || isempty(s1) && return
            x1 = CSTParser.parse(s1, true)
            x2 = try
                CSTParser.minimal_reparse(s0, s1, x0, x1)
            catch err
                @info "minimal reparse failed with"
                @info "s0:"
                @info s0
                @info "s1:"
                @info s1
                rethrow(err)
            end
            @test comp(x1, x2) ? true : (@info(string("Comparison failed between s0:\n", s0, "\n\n and s1: \n", s1)); false)
            @test try
                join(String(codeunits(s0)[seg]) for seg in get_segs(x0)) == s0
            catch e
                @info "Couldn't reconstruct original text from EXPR segments for:"
                @info s0
                rethrow(e)
            end
            @test try
                join(String(codeunits(s1)[seg]) for seg in get_segs(x1)) == s1
            catch e
                @info "Couldn't reconstruct original text from EXPR segments for:"
                @info s1
                rethrow(e)
            end
            @test join(String(codeunits(s1)[seg]) for seg in get_segs(x2)) == s1
            s0 = s1
        end
    end

    function check_dir(dir, check)
        for (root, _, files) in walkdir(dir)
            for f in files
                f = joinpath(root, f)
                (!isfile(f) || !endswith(f, ".jl")) && continue
                @info "checking $(nameof(check)) against $f"
                s = String(read(f))
                if isvalid(s) && length(s) > 0
                    check(s)
                end
            end
        end
        true
    end

    if VERSION >= v"1.6"
        @test check_dir("..", check_err_parse)
        @test check_dir("..", check_reparse)
    end
end

@testitem "self test" begin
    include("../shared.jl")

    for (root, dirs, files) in walkdir(joinpath(@__DIR__, "..", ".."))
        for file in files
            if endswith(file, ".jl")
                test_iter_spans(CSTParser.parse(read(joinpath(root, file), String), true))
            end
        end
    end

end

"""
closer(ps::ParseState)

A magical function determining whether the parsing of an expression should continue or
stop.
"""
function closer(ps::ParseState)
    kindof(ps.nt) === Tokens.ENDMARKER ||
    (ps.closer.newline && kindof(ps.ws) == NewLineWS && !iscomma(ps.t)) ||
    (ps.closer.semicolon && kindof(ps.ws) == SemiColonWS) ||
    (isoperator(ps.nt) && precedence(ps.nt) <= ps.closer.precedence) ||
    (kindof(ps.nt) === Tokens.WHERE && ps.closer.precedence == LazyAndOp) ||
    (ps.closer.inwhere && kindof(ps.nt) === Tokens.WHERE) ||
    (ps.closer.inwhere && ps.closer.ws && kindof(ps.t) === Tokens.RPAREN && isoperator(ps.nt) && precedence(ps.nt) < DeclarationOp) ||
    (ps.closer.precedence > WhereOp && (
        (kindof(ps.nt) === Tokens.LPAREN && !(kindof(ps.t) === Tokens.EX_OR)) ||
        kindof(ps.nt) === Tokens.LBRACE ||
        kindof(ps.nt) === Tokens.LSQUARE ||
        (kindof(ps.nt) === Tokens.STRING && isemptyws(ps.ws)) ||
        ((kindof(ps.nt) === Tokens.RPAREN || kindof(ps.nt) === Tokens.RSQUARE) && isidentifier(ps.nt))
    )) ||
    (iscomma(ps.nt) && ps.closer.precedence > AssignmentOp) ||
    kindof(ps.nt) === Tokens.ENDMARKER ||
    (ps.closer.comma && iscomma(ps.nt)) ||
    (ps.closer.tuple && (iscomma(ps.nt) || isassignmentop(ps.nt))) ||
    (kindof(ps.nt) === Tokens.FOR && ps.closer.precedence > -1) ||
    (ps.closer.block && kindof(ps.nt) === Tokens.END) ||
    (ps.closer.paren && kindof(ps.nt) === Tokens.RPAREN) ||
    (ps.closer.brace && kindof(ps.nt) === Tokens.RBRACE) ||
    (ps.closer.square && kindof(ps.nt) === Tokens.RSQUARE) ||
    # tilde parsing in vect exprs needs to be special cased because `~` has assignment precedence
    (@static VERSION < v"1.4" ?
        false :
        ((ps.closer.insquare || ps.closer.inmacro) && kindof(ps.nt) === Tokens.APPROX && !isemptyws(ps.ws) && isemptyws(ps.nws))
    ) ||
    kindof(ps.nt) === Tokens.ELSEIF ||
    kindof(ps.nt) === Tokens.ELSE ||
    kindof(ps.nt) === Tokens.CATCH ||
    kindof(ps.nt) === Tokens.FINALLY ||
    (ps.closer.ifop && isoperator(ps.nt) && (precedence(ps.nt) <= 0 || kindof(ps.nt) === Tokens.COLON)) ||
    (ps.closer.range && (kindof(ps.nt) === Tokens.FOR || iscomma(ps.nt) || kindof(ps.nt) === Tokens.IF)) ||
    (ps.closer.ws && !isemptyws(ps.ws) &&
        !iscomma(ps.nt) &&
        !iscomma(ps.t) &&
        !(!ps.closer.inmacro && kindof(ps.nt) === Tokens.FOR) &&
        !(kindof(ps.nt) === Tokens.DO) &&
        !(
            (
                isbinaryop(ps.nt) && (
                    !(
                        ps.closer.wsop &&
                        isemptyws(ps.nws) &&
                        isunaryop(ps.nt) &&
                        precedence(ps.nt) > 7
                    )
                )
            ) || (
                isunaryop(ps.t) &&
                kindof(ps.ws) == WS &&
                kindof(ps.lt) !== CSTParser.Tokens.COLON
            )
        )
    ) ||
    (
        ps.closer.unary && (
            kindof(ps.t) in (
                Tokens.INTEGER,
                Tokens.FLOAT,
                Tokens.RPAREN,
                Tokens.RSQUARE,
                Tokens.RBRACE
            ) && isidentifier(ps.nt)
        )
    )
end

"""
    @closer ps rule body

Continues parsing closing on `rule`.
"""
macro closer(ps, opt, body)
    quote
        local tmp1 = getfield($(esc(ps)).closer, $opt)
        setfield!($(esc(ps)).closer, $opt, true)
        out = $(esc(body))
        setfield!($(esc(ps)).closer, $opt, tmp1)
        out
    end
end

"""
    @nocloser ps rule body

Continues parsing not closing on `rule`.
"""
macro nocloser(ps, opt, body)
    quote
        local tmp1 = getfield($(esc(ps)).closer, $opt)
        setfield!($(esc(ps)).closer, $opt, false)
        out = $(esc(body))
        setfield!($(esc(ps)).closer, $opt, tmp1)
        out
    end
end

macro closeparen(ps, body)
    quote
        local tmp1 = $(esc(ps)).closer.paren
        $(esc(ps)).closer.paren = true
        out = $(esc(body))
        $(esc(ps)).closer.paren = tmp1
        out
    end
end

macro closesquare(ps, body)
    quote
        local tmp1 = $(esc(ps)).closer.square
        $(esc(ps)).closer.square = true
        out = $(esc(body))
        $(esc(ps)).closer.square = tmp1
        out
    end
end
macro closebrace(ps, body)
    quote
        local tmp1 = $(esc(ps)).closer.brace
        $(esc(ps)).closer.brace = true
        out = $(esc(body))
        $(esc(ps)).closer.brace = tmp1
        out
    end
end

"""
    @precedence ps prec body

Continues parsing binary operators until it hits a more loosely binding
operator (with precdence lower than `prec`).
"""
macro precedence(ps, prec, body)
    quote
        local tmp1 = $(esc(ps)).closer.precedence
        $(esc(ps)).closer.precedence = $(esc(prec))
        out = $(esc(body))
        $(esc(ps)).closer.precedence = tmp1
        out
    end
end


# Closer_TMP and ancillary functions help reduce code generation
struct Closer_TMP
    newline::Bool
    semicolon::Bool
    inmacro::Bool
    tuple::Bool
    comma::Bool
    insquare::Bool
    range::Bool
    ifop::Bool
    ws::Bool
    wsop::Bool
    unary::Bool
    precedence::Int
end

@noinline function create_tmp(c::Closer)
    Closer_TMP(c.newline,
        c.semicolon,
        c.inmacro,
        c.tuple,
        c.comma,
        c.insquare,
        c.range,
        c.ifop,
        c.ws,
        c.wsop,
        c.unary,
        c.precedence)
end

@noinline function update_from_tmp!(c::Closer, tmp::Closer_TMP)
    c.newline = tmp.newline
    c.semicolon = tmp.semicolon
    c.inmacro = tmp.inmacro
    c.tuple = tmp.tuple
    c.comma = tmp.comma
    c.insquare = tmp.insquare
    c.range = tmp.range
    c.ifop = tmp.ifop
    c.ws = tmp.ws
    c.wsop = tmp.wsop
    c.unary = tmp.unary
    c.precedence = tmp.precedence
end


@noinline function update_to_default!(c::Closer)
    c.newline = true
    c.semicolon = true
    c.inmacro = false
    c.tuple = false
    c.comma = false
    c.insquare = false
    c.range = false
    c.ifop = false
    c.ws = false
    c.wsop = false
    c.unary = false
    c.precedence = -1
end


"""
    @default ps body

Parses the next expression using default closure rules.
"""
macro default(ps, body)
    quote
        TMP = create_tmp($(esc(ps)).closer)
        update_to_default!($(esc(ps)).closer)
        out = $(esc(body))
        update_from_tmp!($(esc(ps)).closer, TMP)
        out
    end
end


isajuxtaposition(ps::ParseState, ret::EXPR) = ((isnumber(ret) && (isidentifier(ps.nt) || kindof(ps.nt) === Tokens.LPAREN || kindof(ps.nt) === Tokens.CMD || kindof(ps.nt) === Tokens.STRING || kindof(ps.nt) === Tokens.TRIPLE_STRING)) ||
        ((is_prime(ret.head) && isidentifier(ps.nt)) ||
        ((kindof(ps.t) === Tokens.RPAREN || kindof(ps.t) === Tokens.RSQUARE) && (isidentifier(ps.nt) || kindof(ps.nt) === Tokens.CMD)) ||
        ((kindof(ps.t) === Tokens.STRING || kindof(ps.t) === Tokens.TRIPLE_STRING) && (kindof(ps.nt) === Tokens.STRING || kindof(ps.nt) === Tokens.TRIPLE_STRING)))) || ((kindof(ps.t) in (Tokens.INTEGER, Tokens.FLOAT) || kindof(ps.t) in (Tokens.RPAREN, Tokens.RSQUARE, Tokens.RBRACE)) && isidentifier(ps.nt)) ||
        (isnumber(ret) && ps.closer.inref && (ps.nt.kind === Tokens.END || ps.nt.kind === Tokens.BEGIN))

"""
    has_error(ps::ParseState)
    has_error(x::EXPR)

Determine whether a parsing error occured while processing text with the given
`ParseState`, or exists as a (sub) expression of `x`.
"""
function has_error(x::EXPR)
    return headof(x) == :errortoken || (x.args !== nothing && any(has_error, x.args)) || (x.trivia !== nothing && any(has_error, x.trivia))
end
has_error(ps::ParseState) = ps.errored

using Base.Meta

"""
    compare(x,y)

Recursively checks whether two Base.Expr are the same. Returns unequal sub-
expressions.
"""
compare(x, y) = x == y ? true : (x, y)

function compare(x::Expr, y::Expr)
    if x == y
        return true
    else
        if x.head != y.head
            return (x, y)
        end
        if length(x.args) != length(y.args)
            return (x.args, y.args)
        end
        for i = 1:length(x.args)
            t = compare(x.args[i], y.args[i])
            if t != true
                return t
            end
        end
    end
end

# code for updating CST
"""
    firstdiff(s0::AbstractString, s1::AbstractString)

Returns the last byte index, i, for which s0 and s1 are the same such that:
    `s0[1:i] == s1[1:i]`
"""
function firstdiff(s0::AbstractString, s1::AbstractString)
    minlength = min(sizeof(s0), sizeof(s1))
    @inbounds for i in 1:minlength
        if codeunits(s0)[i] !== codeunits(s1)[i]
            return i - 1 # This could return a non-commencing byte of a multi-byte unicode sequence.
        end
    end
    return minlength
end

"""
    revfirstdiff(s0::AbstractString, s1::AbstractString)

Reversed version of firstdiff but returns two indices, one for each string.
"""
function revfirstdiff(s0::AbstractString, s1::AbstractString)
    minlength = min(sizeof(s0), sizeof(s1))
    @inbounds for i in 0:minlength - 1
        if codeunits(s0)[end - i] !== codeunits(s1)[end - i]
            return sizeof(s0) - i, sizeof(s1) - i# This could return a non-commencing byte of a multi-byte unicode sequence.
        end
    end
    return 1, 1
end

"""
    find_arg_at(x, i)

Returns the index of the node of `x` within which the byte offset `i` falls.
"""
function find_arg_at(x::CSTParser.EXPR, i)
    @assert i <= x.fullspan
    offset = 0
    for (cnt, a) in enumerate(x.args)
        if i <= offset + a.fullspan
            return cnt
        end
        offset += a.fullspan
    end
    error("$(x.head) with fullspan: $(x.fullspan) at $i")
end

comp(x, y) = x == y
function comp(x::CSTParser.EXPR, y::CSTParser.EXPR)
    comp(x.head, y.head) &&
    x.span == y.span &&
    x.fullspan == y.fullspan &&
    x.val == y.val &&
    length(x) == length(y) &&
    all(comp(x[i], y[i]) for i = 1:length(x))
end

function minimal_reparse(s0, s1, x0 = CSTParser.parse(s0, true), x1 = CSTParser.parse(s1, true); inds = false)
    if has_error(x0)
        return inds ? (1:0, 1:length(x1.args), 1:0) : x1 # Error while re-parsing, so lets return the whole expression instead of patching
    end

    if sizeof(s0) !== x0.fullspan
       error("minimal reparse - original input text length doesn't match the full span of the provided CST.")
        # return inds ? (1:0, 1:length(x1.args), 1:0) : x1
    end

    if has_error(x1)
        return inds ? (1:0, 1:length(x1.args), 1:0) : x1 # Error while re-parsing, so lets return the whole expression instead of patching
    end

    if sizeof(s1) !== x1.fullspan
        error("minimal reparse - new input text length doesn't match the full span of the provided CST.")
         # return inds ? (1:0, 1:length(x1.args), 1:0) : x1
    end
    isempty(x0.args) && return inds ? (1:0, 1:length(x1.args), 1:0) : x1 # Original CST was empty
    x1.fullspan == 0 && return inds ? (1:0, 1:0, 1:0) : x1 # New CST is empty

    i0 = firstdiff(s0, s1)
    i0 > x0.fullspan && return inds ? (1:0, 1:length(x1.args), 1:0) : x1 # Should error?
    i1, i2 = revfirstdiff(s0, s1)
    (i0 > x1.fullspan || i1 > x1.fullspan || i2 > x1.fullspan) && return inds ? (1:0, 1:length(x1.args), 1:0) : x1 # Should error?
    # Find unaffected expressions at start
    # CST should be unaffected (and able to be copied across) up to this point,
    # but we need to check.
    r1 = 1:min(find_arg_at(x0, i0) - 1, length(x0.args), find_arg_at(x1, i0) - 1)
    for i = 1:min(find_arg_at(x0, i0) - 1, find_arg_at(x1, i0) - 1)
        if x0.args[i].fullspan !== x1.args[i].fullspan
            r1 = 1:(i-1)
            break
        end
        r1 = 1:i
    end
    # we can re-use x0.args[r1]

    # assume we'll just use x1.args from here on
    r2 = (last(r1) + 1):length(x1.args)
    r3 = 0:-1

    # though we now check whether there is a sequence at the end of x0.args and
    # x1.args that match
    offset = sizeof(s1)
    for i = 0:min(length(x0.args) - last(r1), length(x0.args), length(x1.args)) - 1
        if !quick_comp(x0.args[end - i], x1.args[end - i]) ||
            offset <= i1 ||
            length(x0.args) - i == last(r1) + 1 ||
            offset - x1.args[end-i].fullspan <= i2 <= offset

            r2 = first(r2):length(x1.args) - i
            r3 = length(x0.args) .+ ((-i + 1):0)
            break
        end
        offset -= x1.args[end - i].fullspan
    end
    inds && return r1, r2, r3
    x2 = CSTParser.EXPR(x0.head, CSTParser.EXPR[
        x0.args[r1]
        x1.args[r2]
        x0.args[r3]
    ], nothing)
    return x2
end

# Quick and very dirty comparison of two EXPR, makes extra effort for :errortokens
function quick_comp(a::EXPR, b::EXPR)
    a.fullspan != b.fullspan && return false
    if headof(a) === :errortoken
        headof(b) !== :errortoken && return false
        if a.args !== nothing
            b.args === nothing && return false
            return length(a.args) == length(b.args) && (length(a.args) == 0 || quick_comp(first(a.args), first(b.args)))
        end
    end
    return comp(headof(a), headof(b))
end

"""
check_span(x, neq = [])

Recursively checks whether the span of an expression equals the sum of the span
of its components. Returns a vector of failing expressions.
"""
function check_span(x::EXPR, neq = [])
    (ispunctuation(x) || isidentifier(x) || iskeyword(x) || isoperator(x) || isliteral(x) || headof(x) == :string) && return neq

    s = 0
    if x.args !== nothing
        for a in x.args
            check_span(a, neq)
            s += a.fullspan
        end
    end
    if hastrivia(x)
        for a in x.trivia
            check_span(a, neq)
            s += a.fullspan
        end
    end
    if x.head isa EXPR
        s += x.head.fullspan
    end
    if length(x) > 0 && s != x.fullspan
        push!(neq, x)
    end
    neq
end

function speed_test()
    dir = dirname(Base.find_source_file("essentials.jl"))
    println("speed test : ", @timed(for i = 1:5
        parse(read(joinpath(dir, "essentials.jl"), String), true);
        parse(read(joinpath(dir, "abstractarray.jl"), String), true);
    end)[2])
end

"""
    str_value(x)

Attempt to get a string representation of a nodeless expression.
"""
function str_value(x)
    if headof(x) === :IDENTIFIER || isliteral(x)
        return valof(x)
    elseif isidentifier(x)
        valof(x.args[2])
    elseif isoperator(x)
        return string(to_codeobject(x))
    else
        return ""
    end
end

_unescape_string(s::AbstractString) = sprint(_unescape_string, s, sizehint=lastindex(s))
function _unescape_string(io, s::AbstractString)
    a = Iterators.Stateful(s)
    for c in a
        if !isempty(a) && c == '\\'
            c = popfirst!(a)
            if c == 'x' || c == 'u' || c == 'U'
                n = k = 0
                m = c == 'x' ? 2 :
                    c == 'u' ? 4 : 8
                while (k += 1) <= m && !isempty(a)
                    nc = Base.peek(a)
                    n = '0' <= nc <= '9' ? n << 4 + nc - '0' :
                        'a' <= nc <= 'f' ? n << 4 + nc - 'a' + 10 :
                        'A' <= nc <= 'F' ? n << 4 + nc - 'A' + 10 : break
                    popfirst!(a)
                end
                if k == 1
                    # throw(ArgumentError("invalid $(m == 2 ? "hex (\\x)" :
                    #                         "unicode (\\u)") escape sequence used in $(repr(s))"))
                    # push error to ParseState?
                    # This matches Meta.parse at least
                    print(io, "\\x")
                else
                    if m == 2 # \x escape sequence
                        write(io, UInt8(n))
                    else
                        print(io, Char(n))
                    end
                end
            elseif '0' <= c <= '7'
                k = 1
                n = c - '0'
                while (k += 1) <= 3 && !isempty(a)
                    c  = Base.peek(a)
                    n = ('0' <= c <= '7') ? n << 3 + c - '0' : break
                    popfirst!(a)
                end
                if n > 255
                    # throw(ArgumentError("octal escape sequence out of range"))
                    # push error to ParseState?
                    n = 255
                end
                write(io, UInt8(n))
            else
                print(io, c == 'a' ? '\a' :
                          c == 'b' ? '\b' :
                          c == 't' ? '\t' :
                          c == 'n' ? '\n' :
                          c == 'v' ? '\v' :
                          c == 'f' ? '\f' :
                          c == 'r' ? '\r' :
                          c == 'e' ? '\e' : c)
            end
        else
            print(io, c)
        end
    end
end
@static if VERSION < v"1.9-"
    function valid_escaped_seq(s::AbstractString)
        l = length(s)
        l == 0 && return false # zero length chars are always invalid
        l == 1 && return true # length-one chars are always valid to Julia's parser
        a = Iterators.Stateful(s)
        if popfirst!(a) == '\\'
            c = popfirst!(a)
            if c === 'x' || c === 'u' || c === 'U'
                maxiter = c === 'x' ? 2 : c === 'u' ? 4 : 8
                0 < length(a) <= maxiter || return false
                n = 0
                while !isempty(a)
                    nc = popfirst!(a)
                    n = '0' <= nc <= '9' ? n << 4 + (nc - '0') :
                        'a' <= nc <= 'f' ? n << 4 + (nc - 'a' + 10) :
                        'A' <= nc <= 'F' ? n << 4 + (nc - 'A' + 10) : return false
                end
                return n <= 0x10ffff
            elseif '0' <= c <= '7'
                length(a) <= 3 || return false
                n = c - '0'
                while !isempty(a)
                    nc = popfirst!(a)
                    n = ('0' <= c <= '7') ? n << 3 + nc - '0' : return false
                end
                return n < 128
            else
                @static if VERSION < v"1.1.0"
                    c = string(c)
                end
                return ncodeunits(c) == 1 && isempty(a)
            end
        end
        return false
    end
else
    function valid_escaped_seq(s::AbstractString)
        l = length(s)
        l == 0 && return false # zero length chars are always invalid
        l == 1 && return true # length-one chars are always valid to Julia's parser
        a = Iterators.Stateful(s)
        ok = false
        while !isempty(a)
            if popfirst!(a) == '\\'
                c = popfirst!(a)
                if c === 'x' || c === 'u' || c === 'U'
                    maxiter = c === 'x' ? 2 : c === 'u' ? 4 : 8
                    n = 0
                    for _ in 1:maxiter
                        isempty(a) && break
                        nc = popfirst!(a)
                        n = '0' <= nc <= '9' ? n << 4 + (nc - '0') :
                            'a' <= nc <= 'f' ? n << 4 + (nc - 'a' + 10) :
                            'A' <= nc <= 'F' ? n << 4 + (nc - 'A' + 10) : return false
                    end
                    ok = n <= 0x10ffff
                elseif '0' <= c <= '7'
                    n = c - '0'
                    for _ in 1:3
                        isempty(a) && break
                        nc = popfirst!(a)
                        n = ('0' <= c <= '7') ? n << 3 + nc - '0' : return false
                    end
                    ok = n < 128
                else
                    @static if VERSION < v"1.1.0"
                        c = string(c)
                    end
                    ok = ncodeunits(c) == 1 && isempty(a)
                end
            else
                return false
            end

            !ok && return false
        end
        return ok
    end
end

"""
    disallowednumberjuxt(ret::EXPR)

Does this number literal end in a decimal and so cannot precede a paren for
implicit multiplication?
"""
disallowednumberjuxt(ret::EXPR) = isnumber(ret) && last(valof(ret)) == '.'


nexttokenstartsdocstring(ps::ParseState) = isidentifier(ps.nt) && val(ps.nt, ps) == "doc" && (kindof(ps.nnt) === Tokens.STRING || kindof(ps.nnt) === Tokens.TRIPLE_STRING)



"""
    _do_kw_convert(ps::ParseState, a::EXPR)

Should `a` be converted to a keyword-argument expression?
"""
_do_kw_convert(ps::ParseState, a::EXPR) = !ps.closer.brace && isassignment(a)

_do_block_convert(a::EXPR) =
    a.args[1] !== nothing && isoperator(a.args[1].head) && a.args[1].args !== nothing && a.args[1].args[1].head === :call

"""
    _kw_convert(a::EXPR, blockwrap = false)

Converted an assignment expression to a keyword-argument expression.
"""
_kw_convert(x::EXPR, blockwrap = false) = EXPR(
    :kw,
    EXPR[
        x.args[1],
        # in some specific cases, the reference parser wraps the RHS of kwargs in an extra block
        blockwrap ?
            EXPR(:block, EXPR[x.args[2]], EXPR[], x.args[2].fullspan, x.args[2].span) :
            x.args[2]
    ],
    EXPR[x.head], x.fullspan, x.span)

"""
    convertsigtotuple(sig::EXPR)

When parsing a function or macro signature, should it be converted to a tuple?
"""
convertsigtotuple(sig::EXPR) = isbracketed(sig) && !(
        istuple(sig.args[1]) ||
        iscall(sig.args[1]) ||
        headof(sig.args[1]) === :block ||
        issplat(sig.args[1])
    )

"""
    docable(head)

When parsing a block of expressions, can documentation be attached? Prefixed docs at the
top-level are handled within `parse(ps::ParseState, cont = false)`.
"""
docable(head) = head === :begin || head === :module || head === :baremodule || head === :quote


should_negate_number_literal(ps::ParseState, op::EXPR) = (is_plus(op) || is_minus(op)) && (kindof(ps.nt) === Tokens.INTEGER || kindof(ps.nt) === Tokens.FLOAT) && isemptyws(ps.ws) && kindof(ps.nnt) != Tokens.CIRCUMFLEX_ACCENT


"""
    can_become_comparison(x::EXPR)

Is `x` a binary comparison call (e.g. `a < b`) that can be extended to include more
arguments?
"""
can_become_comparison(x::EXPR) = (isoperator(x.head) && comp_prec(valof(x.head)) && length(x.args) > 1) || (x.head === :call && isoperator(x.args[1]) && comp_prec(valof(x.args[1])) && length(x.args) > 2 && !hastrivia(x))

"""
    can_become_chain(x::EXPR, op::EXPR)

Is `x` a binary call for `+` or `*` that can be extended to include more
arguments?
"""
can_become_chain(x::EXPR, op::EXPR) = isbinarycall(x) && (is_star(op) || is_plus(op)) && valof(op) == valof(x.args[2]) && !isdotted(x.args[2]) && x.args[2].span > 0


macro cst_str(x)
    CSTParser.parse(x)
end

function issuffixableliteral(ps::ParseState, x::EXPR)
    # prefixed string/cmd macros can be suffixed by identifiers or numeric literals
    return (
            isidentifier(ps.nt) ||
            isnumberliteral(ps.nt) ||
            isbool(ps.nt)
        ) &&
        isemptyws(ps.ws) &&
        ismacrocall(x) &&
        (
            (
            valof(x.args[1]) isa String &&
            (endswith(valof(x.args[1]), "_str") || endswith(valof(x.args[1]), "_cmd"))
            ) ||
            (
                is_getfield(x.args[1]) && x.args[1].args[2] isa EXPR && x.args[1].args[2].head in (:quote, :quotenode) &&
                (endswith(valof(x.args[1].args[2].args[1]), "_str") || endswith(valof(x.args[1].args[2].args[1]), "_cmd"))
            )
        )
end

function loop_check(ps, prevpos)
    if position(ps) <= prevpos && ps.nt.kind !== Tokens.ENDMARKER
        throw(CSTInfiniteLoop("Infinite loop at $ps"))
    else
        position(ps)
    end
end

using CSTParser: @cst_str, headof, valof

@testitem "const local global return.local" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"local a = 1"
    @test length(x) == 2
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
end

@testitem "const local global return.global" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"global a = 1"
    @test length(x) == 2
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
end

@testitem "const local global return.global tuple" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"global (a = 1,b = 2)"
    @test length(x) == 6
    @test x[1] === x.trivia[1]
    @test x[2] === x.trivia[2]
    @test x[3] === x.args[1]
    @test x[4] === x.trivia[3]
    @test x[5] === x.args[2]
    @test x[6] === x.trivia[4]
end

@testitem "const local global return.global tuple trailing comma" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"global (a = 1,b = 2,)"
    @test length(x) == 7
    @test x[1] === x.trivia[1]
    @test x[2] === x.trivia[2]
    @test x[3] === x.args[1]
    @test x[4] === x.trivia[3]
    @test x[5] === x.args[2]
    @test x[6] === x.trivia[4]
    @test x[7] === x.trivia[5]
end

@testitem "const local global return.const" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"const a = 1"
    @test length(x) == 2
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
end
@testitem "const local global return.simple" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"global const a = 1"
    @test length(x) == 2
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test length(x[2]) == 2
    @test x[2][1] === x.args[1].trivia[1]
    @test x[2][2] === x.args[1].args[1]
end

@testitem "const local global return.return" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"return a"
    @test length(x) == 2
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
end

@testitem "datatype declarations.abstract" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"abstract type T end"
    @test length(x) == 4
    @test x[1] === x.trivia[1]
    @test x[2] === x.trivia[2]
    @test x[3] === x.args[1]
    @test x[4] === x.trivia[3]
end

@testitem "datatype declarations.primitive" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"primitive type T N end"
    @test length(x) == 5
    @test x[1] === x.trivia[1]
    @test x[2] === x.trivia[2]
    @test x[3] === x.args[1]
    @test x[4] === x.args[2]
    @test x[5] === x.trivia[3]
end

@testitem "datatype declarations.struct" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"struct T body end"
    @test length(x) == 5
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.args[2]
    @test x[4] === x.args[3]
    @test x[5] === x.trivia[2]
end

@testitem "datatype declarations.mutable" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"mutable struct T body end"
    @test length(x) == 6
    @test x[1] === x.trivia[1]
    @test x[2] === x.trivia[2]
    @test x[3] === x.args[1]
    @test x[4] === x.args[2]
    @test x[5] === x.args[3]
    @test x[6] === x.trivia[3]
end

@testitem "quote.block" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"""quote
                    ex1
                    ex2
                end"""
    @test length(x) == 3
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.trivia[2]
end

@testitem "quote.op" begin
    using CSTParser: @cst_str, headof, valof

    x = cst""":(body + 1)"""
    @test length(x) == 2
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
end

@testitem "block.begin" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"""begin
                    ex1
                    ex2
                end"""
    @test length(x) == 4
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]
end

@testitem ":for" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"""for itr in itr
                    ex1
                    ex2
                end"""
    @test length(x) == 4
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]
end

@testitem ":outer" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"""for outer itr in itr
                    ex1
                    ex2
                end""".args[1].args[1]
    @test length(x) == 2
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
end


@testitem "function.name only" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"""function name end"""
    @test length(x) == 3
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.trivia[2]
end

@testitem "function.full" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"""function sig()
                    ex1
                    ex2
                end"""
    @test length(x) == 4
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]
end

@testitem "braces.simple" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"{a,b,c}"
    @test length(x) == 7
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.trivia[2]
    @test x[4] === x.args[2]
    @test x[5] === x.trivia[3]
    @test x[6] === x.args[3]
    @test x[7] === x.trivia[4]
end

@testitem "braces.params" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"{a,b;c}"
    @test length(x) == 6
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[2]
    @test x[3] === x.trivia[2]
    @test x[4] === x.args[3]
    @test x[5] === x.args[1]
    @test x[6] === x.trivia[3]
end

@testitem "curly.simple" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"x{a,b}"
    @test length(x) == 6
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]
    @test x[5] === x.args[3]
    @test x[6] === x.trivia[3]
end

@testitem "curly.params" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"x{a,b;c}"
    @test length(x) == 7
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[3]
    @test x[4] === x.trivia[2]
    @test x[5] === x.args[4]
    @test x[6] === x.args[2]
    @test x[7] === x.trivia[3]
end

@testitem ":comparison" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"a < b < c"
    @test length(x) == 5
    @test x[1] === x.args[1]
    @test x[2] === x.args[2]
    @test x[3] === x.args[3]
    @test x[4] === x.args[4]
    @test x[5] === x.args[5]
end

@testitem "using.:using" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"using a"
    @test length(x) == 2
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]

    x = cst"using a, b, c"
    @test length(x) == 6
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.trivia[2]
    @test x[4] === x.args[2]
    @test x[5] === x.trivia[3]
    @test x[6] === x.args[3]

    x = cst"using .a"
    @test length(x) == 2
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]

    x = cst"using a: b, c"
    @test length(x) == 2
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
end

@testitem "using.:" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"using a: b, c".args[1]
    @test length(x) == 5
    @test x[1] === x.args[1]
    @test x[2] === x.head
    @test x[3] === x.args[2]
    @test x[3] === x.args[2]
end

@testitem "using.." begin
    using CSTParser: @cst_str, headof, valof

    x = cst"using a".args[1]
    @test length(x) == 1
    @test x[1] === x.args[1]

    x = cst"using a.b".args[1]
    @test length(x) == 3
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]

    x = cst"using ..a.b".args[1]
    @test length(x) == 5
    @test x[1] === x.args[1]
    @test x[2] === x.args[2]
    @test x[3] === x.args[3]
    @test x[4] === x.trivia[1]
    @test x[5] === x.args[4]

    x = cst"using .a.b".args[1]
    @test length(x) == 4
    @test x[1] === x.args[1]
    @test x[2] === x.args[2]
    @test x[3] === x.trivia[1]
    @test x[4] === x.args[3]

    x = cst"using ...a.b".args[1]
    @test length(x) == 6
    @test x[1] === x.args[1]
    @test x[2] === x.args[2]
    @test x[3] === x.args[3]
    @test x[4] === x.args[4]
    @test x[5] === x.trivia[1]
    @test x[6] === x.args[5]
end

@testitem ":kw" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"f(a=1)".args[2]
    @test length(x) == 3
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
end

@testitem ":tuple" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"a,b"
    @test length(x) == 3
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]

    x = cst"(a,b)"
    @test length(x) == 5
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.trivia[2]
    @test x[4] === x.args[2]
    @test x[5] === x.trivia[3]

    x = cst"(a,b,)"
    @test length(x) == 6
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.trivia[2]
    @test x[4] === x.args[2]
    @test x[5] === x.trivia[3]
    @test x[6] === x.trivia[4]
end

@testitem ":call" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"f()"
    @test length(x) == 3
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.trivia[2]

    x = cst"f(a)"
    @test length(x) == 4
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]

    x = cst"f(a,)"
    @test length(x) == 5
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]
    @test x[5] === x.trivia[3]

    x = cst"f(;)"
    @test length(x) == 4
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]

    x = cst"f(a, b;c = 1)"
    @test length(x) == 7
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[3]
    @test x[4] === x.trivia[2]
    @test x[5] === x.args[4]
    @test x[6] === x.args[2]
    @test x[7] === x.trivia[3]

    x = cst"f(a, b,;c = 1)"
    @test length(x) == 8
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[3]
    @test x[4] === x.trivia[2]
    @test x[5] === x.args[4]
    @test x[6] === x.trivia[3]
    @test x[7] === x.args[2]
    @test x[8] === x.trivia[4]
end

@testitem ":where" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"a where {b,c;d}"
    @test length(x) == 8
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.trivia[2]
    @test x[4] === x.args[3]
    @test x[5] === x.trivia[3]
    @test x[6] === x.args[4]
    @test x[7] === x.args[2]
    @test x[8] === x.trivia[4]
end

@testitem ":quotenode" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"a.b".args[2]
    @test length(x) == 1
    @test x[1] === x.args[1]

    x = cst"a.:b".args[2]
    @test length(x) == 2
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
end

@testitem ":if" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"if cond end"
    @test length(x) == 4
    @test headof(x[1]) === :IF
    @test x[2] === x.args[1]
    @test x[3] === x.args[2]
    @test headof(x[4]) === :END

    x = cst"if cond else end"
    @test length(x) == 6
    @test headof(x[1]) === :IF
    @test x[2] === x.args[1]
    @test x[3] === x.args[2]
    @test headof(x[4]) === :ELSE
    @test x[5] === x.args[3]
    @test headof(x[6]) === :END

    x = cst"if cond args elseif a end"
    @test length(x) == 5
    @test headof(x[1]) === :IF
    @test x[2] === x.args[1]
    @test x[3] === x.args[2]
    @test headof(x[4]) === :elseif
    @test headof(x[5]) === :END

    x = cst"a ? b : c"
    @test length(x) == 5
    @test valof(x[1]) === "a"
    @test CSTParser.isoperator(x[2])
    @test valof(x[3]) === "b"
    @test CSTParser.isoperator(x[4])
    @test valof(x[5]) === "c"
end

@testitem ":elseif" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"if cond elseif c args end".args[3]
    @test length(x) == 3
    @test headof(x[1]) === :ELSEIF
    @test x[2] === x.args[1]
    @test x[3] === x.args[2]

    x = cst"if cond elseif c args else args end".args[3]
    @test length(x) == 5
    @test headof(x[1]) === :ELSEIF
    @test x[2] === x.args[1]
    @test x[3] === x.args[2]
    @test headof(x[4]) === :ELSE
    @test x[5] === x.args[3]
end

@testitem ":string" begin
    using CSTParser: @cst_str, headof, valof, EXPR

    x = cst"\"txt$interp txt\""
    @test length(x) == 4
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.args[3]

    x = cst"\"txt1 $interp1 txt2 $interp2 txt3\""
    @test length(x) == 7
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.args[3]
    @test x[5] === x.trivia[2]
    @test x[6] === x.args[4]
    @test x[7] === x.args[5]

    x = cst"\"$interp\""
    @test length(x) == 4
    @test x[1] === x.trivia[1]
    @test x[2] === x.trivia[2]
    @test x[3] === x.args[1]
    @test x[4] === x.trivia[3]

    x = cst"\"$interp txt\""
    @test length(x) == 4
    @test x[1] === x.trivia[1]
    @test x[2] === x.trivia[2]
    @test x[3] === x.args[1]
    @test x[4] === x.args[2]

    x = cst"\"$(interp)\""
    @test length(x) == 6
    @test x[1] === x.trivia[1]
    @test x[2] === x.trivia[2]
    @test x[3] === x.trivia[3]
    @test x[4] === x.args[1]
    @test x[5] === x.trivia[4]
    @test x[6] === x.trivia[5]

    x = cst"\"a$b$c \""
    @test length(x) == 6
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]
    @test x[5] === x.args[3]

    x = cst"\"$(a)$(b)$(c)d\""
    @test length(x) == 14
    @test x[1] === x.trivia[1]
    @test x[2] === x.trivia[2]
    @test x[3] === x.trivia[3]
    @test x[4] === x.args[1]
    @test x[5] === x.trivia[4]
    @test x[6] === x.trivia[5]
    @test x[7] === x.trivia[6]
    @test x[8] === x.args[2]
    @test x[9] === x.trivia[7]
    @test x[10] === x.trivia[8]
    @test x[11] === x.trivia[9]
    @test x[12] === x.args[3]
    @test x[13] === x.trivia[10]
    @test x[14] === x.args[4]

    x = cst"""
    "$(()$)"
    """
    @test x[6] === x.trivia[5]

    x = cst"\"$(\"\")\""
    @test length(x) == 6
    @test x[1] === x.trivia[1]
    @test x[2] === x.trivia[2]
    @test x[3] === x.trivia[3]
    @test x[4] === x.args[1]
    @test x[5] === x.trivia[4]
    @test x[6] === x.trivia[5]

    x = EXPR(:string, EXPR[cst"\" \"", EXPR(:errortoken, 0, 0), EXPR(:errortoken, 0, 0)], EXPR[cst"$"])
    @test x[4] == x.args[3]
end

@testitem ":macrocall" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"@mac a"
    @test length(x) == 3
    @test x[1] === x.args[1]
    @test x[2] === x.args[2]
    @test x[3] === x.args[3]

    x = cst"@mac(a)"
    @test length(x) == 5
    @test x[1] === x.args[1]
    @test x[2] === x.args[2]
    @test x[3] === x.trivia[1]
    @test x[4] === x.args[3]
    @test x[5] === x.trivia[2]

    x = cst"@mac(a, b)"
    @test length(x) == 7
    @test x[1] === x.args[1]
    @test x[2] === x.args[2]
    @test x[3] === x.trivia[1]
    @test x[4] === x.args[3]
    @test x[5] === x.trivia[2]
    @test x[6] === x.args[4]
    @test x[7] === x.trivia[3]

    x = cst"@mac(a; b = 1)"
    @test length(x) == 6
    @test x[1] === x.args[1]
    @test x[2] === x.args[2]
    @test x[3] === x.trivia[1]
    @test x[4] === x.args[4]
    @test x[5] === x.args[3]
    @test x[6] === x.trivia[2]

    x = cst"@mac(a, b; x)"
    @test length(x) == 8
    @test x[1] === x.args[1]
    @test x[2] === x.args[2]
    @test x[3] === x.trivia[1]
    @test x[4] === x.args[4]
    @test x[5] === x.trivia[2]
    @test x[6] === x.args[5]
    @test x[7] === x.args[3]
    @test x[8] === x.trivia[3]
end

@testitem ":brackets" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"(x)"
    @test length(x) == 3
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.trivia[2]
end

@testitem ":ref" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"x[i]"
    @test length(x) == 4
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]

    x = cst"x[i, j]"
    @test length(x) == 6
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]
    @test x[5] === x.args[3]
    @test x[6] === x.trivia[3]

    x = cst"x[i, j; k = 1]"
    @test length(x) == 7
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[3]
    @test x[4] === x.trivia[2]
    @test x[5] === x.args[4]
    @test x[6] === x.args[2]
    @test x[7] === x.trivia[3]
end

@testitem ":typed_vcat" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"x[i;j]"
    @test length(x) == 5
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.args[3]
    @test x[5] === x.trivia[2]
end

@testitem ":row" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"[a b; c d ]".args[1]
    @test length(x) == 2
    @test x[1] === x.args[1]
    @test x[2] === x.args[2]
end

@testitem ":module" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"module a end"
    @test length(x) == 5
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.args[2]
    @test x[4] === x.args[3]
    @test x[5] === x.trivia[2]
end

@testitem ":export" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"export a, b, c"
    @test length(x) == 6
    @test x[1] === x.trivia[1]
    @test x[2] === x.args[1]
    @test x[3] === x.trivia[2]
    @test x[4] === x.args[2]
    @test x[5] === x.trivia[3]
    @test x[6] === x.args[3]
end

if VERSION > v"1.11-"
    @testitem ":public" begin
        using CSTParser: @cst_str, headof, valof

        x = cst"public a, b, c"
        @test length(x) == 6
        @test x[1] === x.trivia[1]
        @test x[2] === x.args[1]
        @test x[3] === x.trivia[2]
        @test x[4] === x.args[2]
        @test x[5] === x.trivia[3]
        @test x[6] === x.args[3]
    end
end

@testitem ":parameters" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"f(a; b=1, c=1, d=1)"[4]
    @test length(x) == 5
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]
    @test x[5] === x.args[3]
end

@testitem "lowered iterator" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"for a in b end".args[1]
    @test length(x) == 3
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
end

@testitem ":do" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"f(x) do arg something end"
    @test length(x) == 4
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]
end

@testitem ":generator" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"(a for a in A)".args[1]
    @test length(x) == 3
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]

    x = cst"(a for a in A, b in B)".args[1]
    @test length(x) == 5
    @test x[1] === x.args[1]
    @test x[2] === x.trivia[1]
    @test x[3] === x.args[2]
    @test x[4] === x.trivia[2]
    @test x[5] === x.args[3]
end

@testitem ":flatten" begin
    using CSTParser: @cst_str, headof, valof

    function flatten(x)
        if length(x) == 0
            [x]
        else
            vcat([flatten(a) for a in x]...)
        end
    end
    function testflattenorder(s)
        x = CSTParser.parse(s)[2]
        issorted([Base.parse(Int, a.val) for a in flatten(x) if a.head === :INTEGER])
    end

    @test testflattenorder("(1 for 2 in 3)")
    @test testflattenorder("(1 for 2 in 3 for 4 in 5)")
    @test testflattenorder("(1 for 2 in 3, 4 in 5 for 6 in 7)")
    @test testflattenorder("(1 for 2 in 3 for 4 in 5, 6 in 7)")
    @test testflattenorder("(1 for 2 in 3 for 4 in 5, 6 in 7 if 8)")
end

@testitem ":filter" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"(a for a in A if a)".args[1].args[2]
    @test length(x) == 3
    @test valof(headof(x[1])) == "="
    @test headof(x[2]) === :IF
    @test valof(x[3]) == "a"
end

@testitem ":try" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"try expr catch e end"
    @test length(x) == 6
    @test headof(x[1]) === :TRY
    @test headof(x[2]) === :block
    @test headof(x[3]) === :CATCH
    @test valof(x[4]) == "e"
    @test headof(x[5]) === :block
    @test headof(x[6]) === :END

    x = cst"try expr finally expr2 end"
    @test length(x) == 8
    @test headof(x[1]) === :TRY
    @test headof(x[2]) === :block
    @test headof(x[3]) === :CATCH
    @test x[3].fullspan == 0
    @test headof(x[4]) === :FALSE
    @test headof(x[5]) === :FALSE
    @test headof(x[6]) === :FINALLY
    @test headof(x[7]) === :block
    @test headof(x[8]) === :END

    x = cst"try expr catch err finally expr3 end"
    @test length(x) == 8
    @test headof(x[1]) === :TRY
    @test headof(x[2]) === :block
    @test headof(x[3]) === :CATCH
    @test valof(x[4]) == "err"
    @test headof(x[5]) === :block
    @test headof(x[6]) === :FINALLY
    @test headof(x[7]) === :block
    @test headof(x[8]) === :END

    x = cst"try expr catch err expr2 finally expr3 end"
    @test length(x) == 8
    @test headof(x[1]) === :TRY
    @test headof(x[2]) === :block
    @test headof(x[3]) === :CATCH
    @test valof(x[4]) == "err"
    @test headof(x[5]) === :block
    @test headof(x[6]) === :FINALLY
    @test headof(x[7]) === :block
    @test headof(x[8]) === :END
end

@testitem ":comprehension" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"[a for a in A]"
    @test length(x) == 3
    @test headof(x[1]) === :LSQUARE
    @test headof(x[2]) === :generator
    @test headof(x[3]) === :RSQUARE
end

@testitem ":typed_comprehension" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"T[a for a in A]"
    @test length(x) == 4
    @test headof(x[1]) === :IDENTIFIER
    @test headof(x[2]) === :LSQUARE
    @test headof(x[3]) === :generator
    @test headof(x[4]) === :RSQUARE
end

@testitem "unary syntax" begin
    using CSTParser: @cst_str, headof, valof

    x = cst"<:a"
    @test length(x) == 2
    @test headof(x[1]) === :OPERATOR
    @test headof(x[2]) === :IDENTIFIER

    x = cst">:a"
    @test length(x) == 2
    @test headof(x[1]) === :OPERATOR
    @test headof(x[2]) === :IDENTIFIER

    x = cst"::a"
    @test length(x) == 2
    @test headof(x[1]) === :OPERATOR
    @test headof(x[2]) === :IDENTIFIER

    x = cst"&a"
    @test length(x) == 2
    @test headof(x[1]) === :OPERATOR
    @test headof(x[2]) === :IDENTIFIER

    x = cst"a..."
    @test length(x) == 2
    @test headof(x[1]) === :IDENTIFIER
    @test headof(x[2]) === :OPERATOR

    x = cst"$a"
    @test length(x) == 2
    @test headof(x[1]) === :OPERATOR
    @test headof(x[2]) === :IDENTIFIER
end

# @testitem "Binary Operators" begin
    # using CSTParser: remlineinfo!
    # include("../shared.jl")

#     for iter = 1:25
#         println(iter)
#         str = join([["x$(randop())" for i = 1:19];"x"])

#         @test test_expr(str)
#     end
# end

@testitem "Conditional Operator" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test test_expr("a ? b : c")
    @test test_expr("a ? b : c : d")
    @test test_expr("a ? b : c : d : e")
    @test test_expr("a ? b : c : d : e")
end


@testitem "Dot Operator" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "a.b" |> test_expr
    @test "a.b.c" |> test_expr
    @test "(a(b)).c" |> test_expr
    @test "(a).(b).(c)" |> test_expr
    @test "(a).b.(c)" |> test_expr
    @test "(a).b.(c+d)" |> test_expr
end

@testitem "Unary Operator" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "+" |> test_expr
    @test "-" |> test_expr
    @test "!" |> test_expr
    @test "~" |> test_expr
    @test "&" |> test_expr
    # @test "::" |> test_expr
    @test "<:" |> test_expr
    @test ">:" |> test_expr
    @test "¬" |> test_expr
    @test "√" |> test_expr
    @test "∛" |> test_expr
    @test "∜" |> test_expr

    @test "a=b..." |> test_expr
    @test "a-->b..." |> test_expr
    if VERSION >= v"1.6"
        @test "a<--b..." |> test_expr
        @test "a<-->b..." |> test_expr
    end
    @test "a&&b..." |> test_expr
    @test "a||b..." |> test_expr
    @test "a<b..." |> test_expr
    @test "a:b..." |> test_expr
    @test "a+b..." |> test_expr
    @test "a<<b..." |> test_expr
    @test "a*b..." |> test_expr
    @test "a//b..." |> test_expr
    @test "a^b..." |> test_expr
    @test "3a^b" |> test_expr
    @test "3//a^b" |> test_expr
    @test "3^b//a^b" |> test_expr
    @test "3^b//a" |> test_expr
    @test_broken "@a b ^ -c(d)^e" |> test_expr
    @test_broken "[a b ^ -c(d)^e f]" |> test_expr
    @test "a::b..." |> test_expr
    @test "a where b..." |> test_expr
    @test "a.b..." |> test_expr
end

@testitem "unary op calls" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "+(a,b)" |> test_expr
    @test "-(a,b)" |> test_expr
    @test "!(a,b)" |> test_expr
    @test "¬(a,b)" |> test_expr
    @test "~(a,b)" |> test_expr
    if VERSION > v"1.7-"
        @test "~(a)(foo...)" |> test_expr
        @test "~(&)(foo...)" |> test_expr
    end
    @test "<:(a,b)" |> test_expr
    @test "√(a,b)" |> test_expr
    @test "\$(a,b)" |> test_expr
    @test ":(a,b)" |> test_expr
    @test "&a" |> test_expr
    @test "&(a,b)" |> test_expr
    @test "::a" |> test_expr
    @test "::(a,b)" |> test_expr
end

@testitem "dotted non-calls" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "f(.+)" |> test_expr
    @test "f(.-)" |> test_expr
    @test "f(.!)" |> test_expr
    @test "f(.¬)" |> test_expr
    if VERSION >= v"1.6"
        @test_broken "f(.~)" |> test_expr_broken
    end
    @test "f(.√)" |> test_expr
    @test "f(:(.=))" |> test_expr
    @test "f(:(.+))" |> test_expr
    @test "f(:(.*))" |> test_expr
end


@testitem "comment parsing" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    if VERSION >= v"1.6"
        @test "[1#==#2#==#3]" |> test_expr
        @test """
        begin
        arraycopy_common(false, LLVM.Builder(B), orig, origops[1], gutils)#=fwd=#
        return nothing
        end
        """ |> test_expr
        @test CSTParser.has_error(CSTParser.parse("""
        begin
        arraycopy_common(false, LLVM.Builder(B), orig, origops[1], gutils)#=fwd=#return nothing
        end
        """))
    end
end

@testitem "weird quote parsing" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test ":(;)" |> test_expr
    @test ":(;;)" |> test_expr
    @test ":(;;;)" |> test_expr
end

# In previous Julia versions, this errored during lowering. With JuliaSyntax, this is a parser error
if VERSION < v"1.10-"
    @testitem "parse const without assignment in quote" begin
        using CSTParser: remlineinfo!
        include("../shared.jl")

        @test ":(global const x)" |> test_expr
        @test ":(global const x::Int)" |> test_expr
        @test ":(const global x)" |> test_expr
        @test ":(const global x::Int)" |> test_expr
    end
end

@testitem "where precedence" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "a = b where c = d" |> test_expr
    @test "a = b where c" |> test_expr
    @test "b where c = d" |> test_expr
    @test "b where {c} == d" |> test_expr

    @test "a ? b where c : d" |> test_expr
    if VERSION >= v"1.6"
        @test "a --> b where c --> d" |> test_expr
        @test "a --> b where c" |> test_expr
        @test "b where c --> d" |> test_expr
        @test "b where c <-- d" |> test_expr
        @test "b where c <--> d" |> test_expr
    end

    @test "a || b where c || d" |> test_expr
    @test "a || b where c" |> test_expr
    @test "b where c || d" |> test_expr

    @test "a && b where c && d" |> test_expr
    @test "a && b where c" |> test_expr
    @test "b where c && d" |> test_expr

    @test "a <: b where c <: d" |> test_expr
    @test "a <: b where c" |> test_expr
    @test "b where c <: d" |> test_expr

    @test "a <| b where c <| d" |> test_expr
    @test "a <| b where c" |> test_expr
    @test "b where c <| d" |> test_expr

    @test "a : b where c : d" |> test_expr
    @test "a : b where c" |> test_expr
    @test "b where c : d" |> test_expr

    @test "a + b where c + d" |> test_expr
    @test "a + b where c" |> test_expr
    @test "b where c + d" |> test_expr

    @test "a << b where c << d" |> test_expr
    @test "a << b where c" |> test_expr
    @test "b where c << d" |> test_expr

    @test "a * b where c * d" |> test_expr
    @test "a * b where c" |> test_expr
    @test "b where c * d" |> test_expr

    @test "a // b where c // d" |> test_expr
    @test "a // b where c" |> test_expr
    @test "b where c // d" |> test_expr

    @test "a ^ b where c ^ d" |> test_expr
    @test "a ^ b where c" |> test_expr
    @test "b where c ^ d" |> test_expr

    @test "a :: b where c :: d" |> test_expr
    @test "a :: b where c" |> test_expr
    @test "b where c :: d" |> test_expr

    @test "a.b where c.d" |> test_expr
    @test "a.b where c" |> test_expr
    @test "b where c.d" |> test_expr

    @test "a where b where c" |> test_expr
end

@testitem "function defs" begin
    @test CSTParser.defines_function(CSTParser.parse("function f end"))
    @test CSTParser.defines_function(CSTParser.parse("function f() end"))
    @test CSTParser.defines_function(CSTParser.parse("function f()::T end"))
    @test CSTParser.defines_function(CSTParser.parse("function f(x::T) where T end"))
    @test CSTParser.defines_function(CSTParser.parse("function f{T}() end"))
    @test CSTParser.defines_function(CSTParser.parse("f(x) = x"))
    @test CSTParser.defines_function(CSTParser.parse("f(x)::T = x"))
    @test CSTParser.defines_function(CSTParser.parse("f{T}(x)::T = x"))
    @test CSTParser.defines_function(CSTParser.parse("f{T}(x)::T = x"))
    @test CSTParser.defines_function(CSTParser.parse("*(x,y) = x"))
    @test CSTParser.defines_function(CSTParser.parse("*(x,y)::T = x"))
    @test CSTParser.defines_function(CSTParser.parse("!(x::T)::T = x"))
    @test CSTParser.defines_function(CSTParser.parse("a + b = a"))
    @test CSTParser.defines_function(CSTParser.parse("a/b = x"))
    @test !CSTParser.defines_function(CSTParser.parse("a.b = x"))
end

@testitem "datatype defs" begin
    @test CSTParser.defines_struct(CSTParser.parse("struct T end"))
    @test CSTParser.defines_struct(CSTParser.parse("mutable struct T end"))
    @test CSTParser.defines_mutable(CSTParser.parse("mutable struct T end"))
    @test CSTParser.defines_abstract(CSTParser.parse("abstract type T end"))
    # @test CSTParser.defines_abstract(CSTParser.parse("abstract T"))
    @test CSTParser.defines_primitive(CSTParser.parse("primitive type a b end"))
end

@testitem "get_name" begin
    using CSTParser: valof
    
    @test valof(CSTParser.get_name(CSTParser.parse("struct T end"))) == "T"
    @test valof(CSTParser.get_name(CSTParser.parse("struct T{T} end"))) == "T"
    @test valof(CSTParser.get_name(CSTParser.parse("struct T <: T end"))) == "T"
    @test valof(CSTParser.get_name(CSTParser.parse("struct T{T} <: T end"))) == "T"

    @test valof(CSTParser.get_name(CSTParser.parse("mutable struct T end"))) == "T"
    @test valof(CSTParser.get_name(CSTParser.parse("mutable struct T{T} end"))) == "T"
    @test valof(CSTParser.get_name(CSTParser.parse("mutable struct T <: T end"))) == "T"
    @test valof(CSTParser.get_name(CSTParser.parse("mutable struct T{T} <: T end"))) == "T"

    @test valof(CSTParser.get_name(CSTParser.parse("abstract type T end"))) == "T"
    @test valof(CSTParser.get_name(CSTParser.parse("abstract type T{T} end"))) == "T"
    @test valof(CSTParser.get_name(CSTParser.parse("abstract type T <: T end"))) == "T"
    @test valof(CSTParser.get_name(CSTParser.parse("abstract type T{T} <: T end"))) == "T"
    # NEEDS FIX: v0.6 dep
    # @test CSTParser.get_name(CSTParser.parse("abstract T")).val == "T"
    # @test CSTParser.get_name(CSTParser.parse("abstract T{T}")).val == "T"
    # @test CSTParser.get_name(CSTParser.parse("abstract T <: T")).val == "T"
    # @test CSTParser.get_name(CSTParser.parse("abstract T{T} <: T")).val == "T"

    @test valof(CSTParser.get_name(CSTParser.parse("function f end"))) == "f"
    @test valof(CSTParser.get_name(CSTParser.parse("function f() end"))) == "f"
    @test valof(CSTParser.get_name(CSTParser.parse("function f()::T end"))) == "f"
    @test valof(CSTParser.get_name(CSTParser.parse("function f(x::T) where T end"))) == "f"
    @test valof(CSTParser.get_name(CSTParser.parse("function f{T}() end"))) == "f"
    @test valof(CSTParser.get_name(CSTParser.parse("function (f()) end"))) == "f"

    # Operators
    @test CSTParser.str_value(CSTParser.get_name(CSTParser.parse("function +() end"))) == "+"
    @test CSTParser.str_value(CSTParser.get_name(CSTParser.parse("function (+)() end"))) == "+"
    @test CSTParser.str_value(CSTParser.get_name(CSTParser.parse("function (a + b) end"))) == "+"
    @test CSTParser.str_value(CSTParser.get_name(CSTParser.parse("+(x,y) = x"))) == "+"
    @test CSTParser.str_value(CSTParser.get_name(CSTParser.parse("+(x,y)::T = x"))) == "+"
    @test CSTParser.str_value(CSTParser.get_name(CSTParser.parse("!(x)::T = x"))) == "!"
    @test CSTParser.str_value(CSTParser.get_name(CSTParser.parse("!(x) = x"))) == "!"
end


# @testitem "get_sig_params" begin
#     f = x -> CSTParser.str_value.(CSTParser.get_args(CSTParser.parse(x)))
#     @test f("function f(a) end") == ["a"]
#     @test f("function f(a::T) end") == ["a"]
#     @test f("function f(a,b) end") == ["a", "b"]
#     @test f("function f(a::T,b::T) end") == ["a", "b"]
#     @test f("function f(a::T,b::T) where T end") == ["a", "b"]
#     @test f("function f{T}(a::T,b::T) where T end") == ["a", "b"]
#     @test f("function f{T}(a::T,b::T;c = 1) where T end") == ["a", "b", "c"]

#     @test f("a -> a") == ["a"]
#     @test f("a::T -> a") == ["a"]
#     @test f("(a::T) -> a") == ["a"]
#     @test f("(a,b) -> a") == ["a", "b"]

#     @test f("map(1:10) do a
#         a
#     end") == ["a"]
#     @test f("map(1:10) do a,b
#         a
#     end") == ["a", "b"]
# end

@testitem "has_error" begin
    # Just an error token
    @test CSTParser.has_error(CSTParser.parse(","))
    # A nested ErrorToken
    @test CSTParser.has_error(CSTParser.parse("foo(bar(\"\$ x\"))"))
    # Not an error
    @test !CSTParser.has_error(CSTParser.parse("foo(bar(\"\$x\"))"))
end

@testitem "If" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test "if cond end" |> test_expr
    @test "if cond; a; end" |> test_expr
    @test "if cond a; end" |> test_expr
    @test "if cond; a end" |> test_expr
    @test """if cond
    1
    1
end""" |> test_expr
    @test """if cond
else
    2
    2
end""" |> test_expr
    @test """if cond
    1
    1
else
    2
    2
end""" |> test_expr
    @test "if 1<2 end" |> test_expr
    @test """if 1<2
    f(1)
    f(2)
end""" |> test_expr
    @test """if 1<2
    f(1)
elseif 1<2
    f(2)
end""" |> test_expr
    @test """if 1<2
    f(1)
elseif 1<2
    f(2)
else
    f(3)
end""" |> test_expr
    @test "if cond a end" |> test_expr
end


@testitem "Try" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    # @test "try f(1) end" |> test_expr
    # @test "try; f(1) end" |> test_expr
    # @test "try; f(1); end" |> test_expr
    @test "try; f(1); catch e; e; end" |> test_expr
    @test "try; f(1); catch e; e end" |> test_expr
    @test "try; f(1); catch e e; end" |> test_expr
    @test """
    try
        f(1)
    catch
    end
    """ |> test_expr
    @test """try
        f(1)
    catch
        error(err)
    end
    """ |> test_expr
    @test """
    try
        f(1)
    catch err
        error(err)
    end
    """ |> test_expr
    @test """
    try
        f(1)
    catch
        error(err)
    finally
        stop(f)
    end
    """ |> test_expr
    @test """
    try
        f(1)
    catch err
    finally
        stop(f)
    end
    """ |> test_expr
    @test """
    try
        f(1)
    catch err
        error(err)
    finally
        stop(f)
    end
    """ |> test_expr
    @test """try
        f(1)
    finally
        stop(f)
    end
    """ |> test_expr

    if VERSION > v"1.8-"
        @test """try
            f(1)
        catch
            x
        else
            stop(f)
        end
        """ |> test_expr
        @test """try
            f(1)
        catch
        else
            stop(f)
        end
        """ |> test_expr
        @test """try
            f(1)
        catch err
            x
        else
            stop(f)
        finally
            foo
        end
        """ |> test_expr
        # the most useless try catch ever:
        @test """try
        catch
        else
        finally
        end
        """ |> test_expr
    end
end
@testitem "For" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test """
    for i = 1:10
        f(i)
    end""" |> test_expr
    @test """
    for i = 1:10, j = 1:20
        f(i)
    end
    """ |> test_expr

    @testset "for outer parsing" begin
        @test "for outer i in 1:3 end" |> test_expr
        @test "for outer i = 1:3 end" |> test_expr
        if VERSION >= v"1.6"
            @test "for outer \$i = 1:3 end" |> test_expr
            if VERSION < v"1.12-"
                @test "for outer \$ i = 1:3 end" |> test_expr
            end
        end
    end
end

@testitem "Let" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test """
    let x = 1
        f(x)
    end
    """ |> test_expr
    @test """
    let x = 1, y = 2
        f(x)
    end
    """ |> test_expr
    @test """
    let
        x
    end
    """ |> test_expr
end

@testitem "Do" begin
    using CSTParser: remlineinfo!
    include("../shared.jl")

    @test """f(X) do x
    return x
end""" |> test_expr
    @test """f(X,Y) do x,y
    return x,y
end""" |> test_expr
    @test "f() do x body end" |> test_expr
end

if VERSION > v"1.11-"
    @testitem "public" begin
        using CSTParser: remlineinfo!
        include("../shared.jl")

        @test "public foo" |> test_expr
        @test "public foo, bar" |> test_expr
        @test """
        public foo,
        bar
        """ |> test_expr
        @test "f() = public" |> test_expr
        @test "public(x) = 1" |> test_expr
        @test "public(x)" |> test_expr
        @test """
        let
            public
        end
        """ |> test_expr
    end
end

using CSTParser
using Documenter

makedocs(;
    modules=[CSTParser],
    authors="Julia VSCode",
    repo="https://github.com/julia-vscode/CSTParser.jl/blob/{commit}{path}#L{line}",
    sitename="CSTParser.jl",
    format=Documenter.HTML(;
        prettyurls=prettyurls = get(ENV, "CI", nothing) == "true",
        # canonical="https://www.julia-vscode.org/CSTParser.jl",
        # assets=String[],
    ),
    pages=[
        "Home" => "index.md",
        "Syntax Reference" => "syntax.md",
    ],
)

deploydocs(;
    repo="github.com/julia-vscode/CSTParser.jl",
)

# Syntax Reference

```@index
Modules = [CSTParser]
Pages   = ["syntax.md"]
```

## Main

```@autodocs
Modules = [CSTParser]
Pages = readdir("../src")
```

## Components

```@autodocs
Modules = [CSTParser]
Pages = readdir("../src/components")
```

Expression is used to refer to any `EXPR` object, including those without children (terminals).

```
mutable struct EXPR
    head::Symbol
    args::Union{Nothing,Vector{EXPR}}
    trivia::Union{Nothing,Vector{EXPR}}
    fullspan::Int
    span::Int
    val::Union{Nothing,String}
    parent::Union{Nothing,EXPR}
    meta
end
```
The first two arguments match the representation within `Expr`.
## `head`
The type of expression, equivalent to the head of Expr. Possible heads are a superset of those available for an Expr.

## `args`
As for `Expr`, holds child expressions. Terminal expressions do not hold children.

## `trivia`
Holds terminals specific to the CST representation. Terminal expressions do not hold trivia.

## `fullspan`
The byte size of the expression in the source code text, including trailing white space.

## `span`
As above but excluding trailing white space. (`fullspan - span` is the byte size of trailing white space.)

## `val`
A field to store the textual representation of the token as necessary, otherwise it is set to `nothing`. This is needed for identifiers, operators and literals.


# Heads
An extended group of expression types is used to allow full equivalence of terminal tokens with other expressions. By convention expression heads will match those used in Julia AST (lowercase) and others are capitalised.

## Terminals
Identifier
Nonstdidentifier
Operator

### Punctuation
comma
lparen
rparen
lsquare
rsquare
lbrace
rbrace
atsign
dot
      
### Keywords
abstract
baremodule
begin
break
catch
const
continue
do
else
elseif
end
export
finally
for
function
global
if
import
importall
let
local
macro
module
mutable
new
outer
primitive
quote
return
struct
try
type
using
while

### Literals
:INTEGER,
:BININT,
:HEXINT,
:OCTINT,
:FLOAT,
:STRING,
:TRIPLESTRING,
:CHAR,
:CMD,
:TRIPLECMD,
:NOTHING,
:true,
:false,

# Expressions

##### :const

##### :global
`(args...) (global ,...)`
`(args...) (,...)`
Special handling: `global const expr` is parsed as `const global expr`. In this case both the `const` and `global` keywords are stored wihin the `:const` expression's trivia (the `:global` expression has no trivia).
##### :local
`(args...) (local ,...)`
##### :return
`(body) (return)`
## Datatype declarations
##### :abstract
`(name) (abstract type end)`
##### :primitive
`(name n) (primitive type end)`
##### :struct
`(mut name block) (struct end)`
`(mut name block) (mutable struct end)`
##### :block
`(bodyargs...) (begin end)`
`(bodyargs...) ()`
##### :quote
`(block) (quote end)`
`(block) (:)`
##### :for
`(itrs block) (for end)`
##### :function
`(sig block) (function end)`
`(name) (function end)`
##### :outer
`(arg) (outer)`
##### :braces
`(args...) ({ commas.. })`
##### :curly
`(args...) ({ commas... })`
##### :comparison
`(args...) (commas...)`
##### :(:)
Only used as the head of an expression within `using/import` calls.
##### :if
`(cond block) (if end)`
`(cond block elseif) (if end)`
`(cond block block) (if else end)`
##### :elseif 
`(cond block) (elseif)`
`(cond block block) (elseif else)`
##### :call
##### :string
`(args...)`
##### :if
##### :kw



##### ChainOpCall
##### ColonOpCall
##### Bracescat

##### Do
##### Filter
##### Flatten
##### Generator
##### GlobalRefDoc
##### Let
##### Ref
##### Row
##### Vcat
##### Macro
##### MacroCall
##### MacroName

##### Parameters
##### Quotenode
##### InvisBrackets
##### String
##### Try
##### Tuple
##### File

##### While
##### Module
Trivia: `module`, `end`
##### BareModule
Trivia: `baremodule`, `end`
##### TopLevel
##### Export
##### Import
##### Using
##### Comprehension
##### Dict_Comprehension
##### Typed_Comprehension
##### Hcat
##### Typed_Hcat
##### Typed_Vcat
##### Vect

## Head's not present in `Expr`
:ErrorToken

## Iterators
Iterators of loops are converted to `a = b` if needed in line with the scheme parser. the operator is a facade and the actual operator use  is stored as trivia.


# Decisions
1. For single token keyword expressions (e.g. `break`) do we use the visible token as the head or store it in trivia?

```@meta
CurrentModule = CSTParser
```

# CSTParser

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://www.julia-vscode.org/CSTParser.jl/dev)
[![Project Status: Active - The project has reached a stable, usable state and is being actively developed.](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active)
![](https://github.com/julia-vscode/CSTParser.jl/workflows/Run%20CI%20on%20master/badge.svg)
[![codecov](https://codecov.io/gh/julia-vscode/CSTParser.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/julia-vscode/CSTParser.jl)

A parser for Julia using [Tokenize](https://github.com/JuliaLang/Tokenize.jl/) that aims to extend the built-in parser by providing additional meta information along with the resultant AST.

## Installation and Usage
```julia
using Pkg
Pkg.add("CSTParser")
```
```julia
using CSTParser
```
**Documentation**: [![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://www.julia-vscode.org/CSTParser.jl/dev)


### Additional Output
- `EXPR`'s are iterable producing children in the order that they appear in the source code, including punctuation.

    Example:
  ```
  f(x) = x*2 becomes [f(x), =, x*2]
  f(x) becomes [f, (, x, )]
  ```
- The byte span of each `EXPR` is stored allowing a mapping between byte position in the source code and the releveant parsed expression. The span of a single token includes any trailing whitespace, newlines or comments. This also allows for fast partial parsing of modified source code.
- Formatting hints are generated as the source code is parsed (e.g. mismatched indents for blocks, missing white space around operators).
- The declaration of modules, functions, datatypes and variables are tracked and stored in the relevant hierarchical scopes attatched to the expressions that declare the scope. This allows for a mapping between any identifying symbol and the relevant code that it refers to.

### Structure

Expressions are represented solely by the following types:
```
Parser.SyntaxNode
  Parser.EXPR
  Parser.INSTANCE
    Parser.HEAD{K}
    Parser.IDENTIFIER
    Parser.KEYWORD{K}
    Parser.LITERAL{K}
    Parser.OPERATOR{P,K,dot}
    Parser.PUNCTUATION
  Parser.QUOTENODE
```

The `K` parameterisation refers to the `kind` of the associated token as specified by `Tokenize.Tokens.Kind`. The `P` and `dot` parameters for operators refers to the precedence of the operator and whether it is dotted (e.g. `.+`).

`INSTANCE`s represent singular objects that may have a concrete or implicit relation to a portion of the source text. In the the former case they have a `span` storing the width in bytes that they occupy in the source text, in the latter case their span is 0. Additionally, `IDENTIFIER`s store their value as a `Symbol` and `LITERAL`s as a `String`.

`EXPR` are equivalent to `Base.Expr` but have extra fields to store their span and any punctuation tokens.
